// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : affectCd.h                                                 //
// description : header file for the ENIB/LI2 Affectation codes             //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef AFFECTCD_H
#define AFFECTCD_H

#include "Utility/word.h"

#include "oRis/Codes/smaCd.h"

//--------------------------------------------------------------------------//
// class Affect_I_I_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_I_I_Code : public SmaCode
{
public:
// Allocators
  Affect_I_I_Code(const SmaNode * node);
  virtual ~Affect_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_I_R_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_I_R_Code : public SmaCode
{
public:
// Allocators
  Affect_I_R_Code(const SmaNode * node);
  virtual ~Affect_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_R_I_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_R_I_Code : public SmaCode
{
public:
// Allocators
  Affect_R_I_Code(const SmaNode * node);
  virtual ~Affect_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_R_R_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_R_R_Code : public SmaCode
{
public:
// Allocators
  Affect_R_R_Code(const SmaNode * node);
  virtual ~Affect_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_S_S_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_S_S_Code : public SmaCode
{
public:
// Allocators
  Affect_S_S_Code(const SmaNode * node);
  virtual ~Affect_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_A_A_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_A_A_Code : public SmaCode
{
public:
// Allocators
  Affect_A_A_Code(const SmaNode * node);
  virtual ~Affect_A_A_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_Deep_Code                                                   //
//--------------------------------------------------------------------------//
 
class Affect_Deep_Code : public SmaCode
{
public:
// Allocators
  Affect_Deep_Code(const SmaNode * node);
  virtual ~Affect_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
protected:
// Attributes
  static Word _affectWord;
};


//--------------------------------------------------------------------------//
// class Affect_V_V_Code                                                    //
//--------------------------------------------------------------------------//

class Affect_V_V_Code : public SmaCode
{
public:
// Allocators
  Affect_V_V_Code(const SmaNode * node);
  virtual ~Affect_V_V_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_IV_RV_Code                                                  //
//--------------------------------------------------------------------------//

class Affect_IV_RV_Code : public SmaCode
{
public:
// Allocators
  Affect_IV_RV_Code(const SmaNode * node);
  virtual ~Affect_IV_RV_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Affect_RV_IV_Code                                                  //
//--------------------------------------------------------------------------//

class Affect_RV_IV_Code : public SmaCode
{
public:
// Allocators
  Affect_RV_IV_Code(const SmaNode * node);
  virtual ~Affect_RV_IV_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class AffectCastCode                                                     //
//--------------------------------------------------------------------------//

class AffectCastCode : public SmaCode
{
public:
// Allocators
  AffectCastCode(const SmaNode * node);
  virtual ~AffectCastCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_V_V_Code                                                    //
//--------------------------------------------------------------------------//

class PlusEq_V_V_Code : public SmaCode
{
public:
// Allocators
  PlusEq_V_V_Code(const SmaNode * node);
  virtual ~PlusEq_V_V_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_IV_RV_Code                                                  //
//--------------------------------------------------------------------------//

class PlusEq_IV_RV_Code : public SmaCode
{
public:
// Allocators
  PlusEq_IV_RV_Code(const SmaNode * node);
  virtual ~PlusEq_IV_RV_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_RV_IV_Code                                                  //
//--------------------------------------------------------------------------//

class PlusEq_RV_IV_Code : public SmaCode
{
public:
// Allocators
  PlusEq_RV_IV_Code(const SmaNode * node);
  virtual ~PlusEq_RV_IV_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_I_I_Code                                                    //
//--------------------------------------------------------------------------//

class PlusEq_I_I_Code : public SmaCode
{
public:
// Allocators
  PlusEq_I_I_Code(const SmaNode * node);
  virtual ~PlusEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_I_R_Code                                                    //
//--------------------------------------------------------------------------//

class PlusEq_I_R_Code : public SmaCode
{
public:
// Allocators
  PlusEq_I_R_Code(const SmaNode * node);
  virtual ~PlusEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_R_R_Code                                                    //
//--------------------------------------------------------------------------//

class PlusEq_R_R_Code : public SmaCode
{
public:
// Allocators
  PlusEq_R_R_Code(const SmaNode * node);
  virtual ~PlusEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_R_I_Code                                                    //
//--------------------------------------------------------------------------//

class PlusEq_R_I_Code : public SmaCode
{
public:
// Allocators
  PlusEq_R_I_Code(const SmaNode * node);
  virtual ~PlusEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PlusEq_S_S_Code                                                    //
//--------------------------------------------------------------------------//

class PlusEq_S_S_Code : public SmaCode
{
public:
// Allocators
  PlusEq_S_S_Code(const SmaNode * node);
  virtual ~PlusEq_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MinusEq_I_I_Code                                                   //
//--------------------------------------------------------------------------//

class MinusEq_I_I_Code : public SmaCode
{
public:
// Allocators
  MinusEq_I_I_Code(const SmaNode * node);
  virtual ~MinusEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MinusEq_I_R_Code                                                   //
//--------------------------------------------------------------------------//

class MinusEq_I_R_Code : public SmaCode
{
public:
// Allocators
  MinusEq_I_R_Code(const SmaNode * node);
  virtual ~MinusEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MinusEq_R_R_Code                                                   //
//--------------------------------------------------------------------------//

class MinusEq_R_R_Code : public SmaCode
{
public:
// Allocators
  MinusEq_R_R_Code(const SmaNode * node);
  virtual ~MinusEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MinusEq_R_I_Code                                                   //
//--------------------------------------------------------------------------//

class MinusEq_R_I_Code : public SmaCode
{
public:
// Allocators
  MinusEq_R_I_Code(const SmaNode * node);
  virtual ~MinusEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MultEq_I_I_Code                                                    //
//--------------------------------------------------------------------------//

class MultEq_I_I_Code : public SmaCode
{
public:
// Allocators
  MultEq_I_I_Code(const SmaNode * node);
  virtual ~MultEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MultEq_I_R_Code                                                    //
//--------------------------------------------------------------------------//

class MultEq_I_R_Code : public SmaCode
{
public:
// Allocators
  MultEq_I_R_Code(const SmaNode * node);
  virtual ~MultEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MultEq_R_R_Code                                                    //
//--------------------------------------------------------------------------//

class MultEq_R_R_Code : public SmaCode
{
public:
// Allocators
  MultEq_R_R_Code(const SmaNode * node);
  virtual ~MultEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class MultEq_R_I_Code                                                    //
//--------------------------------------------------------------------------//

class MultEq_R_I_Code : public SmaCode
{
public:
// Allocators
  MultEq_R_I_Code(const SmaNode * node);
  virtual ~MultEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class DivEq_I_I_Code                                                     //
//--------------------------------------------------------------------------//

class DivEq_I_I_Code : public SmaCode
{
public:
// Allocators
  DivEq_I_I_Code(const SmaNode * node);
  virtual ~DivEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class DivEq_I_R_Code                                                     //
//--------------------------------------------------------------------------//

class DivEq_I_R_Code : public SmaCode
{
public:
// Allocators
  DivEq_I_R_Code(const SmaNode * node);
  virtual ~DivEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class DivEq_R_R_Code                                                     //
//--------------------------------------------------------------------------//

class DivEq_R_R_Code : public SmaCode
{
public:
// Allocators
  DivEq_R_R_Code(const SmaNode * node);
  virtual ~DivEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class DivEq_R_I_Code                                                     //
//--------------------------------------------------------------------------//

class DivEq_R_I_Code : public SmaCode
{
public:
// Allocators
  DivEq_R_I_Code(const SmaNode * node);
  virtual ~DivEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class ModEq_I_I_Code                                                     //
//--------------------------------------------------------------------------//

class ModEq_I_I_Code : public SmaCode
{
public:
// Allocators
  ModEq_I_I_Code(const SmaNode * node);
  virtual ~ModEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class ModEq_I_R_Code                                                     //
//--------------------------------------------------------------------------//

class ModEq_I_R_Code : public SmaCode
{
public:
// Allocators
  ModEq_I_R_Code(const SmaNode * node);
  virtual ~ModEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class ModEq_R_R_Code                                                     //
//--------------------------------------------------------------------------//

class ModEq_R_R_Code : public SmaCode
{
public:
// Allocators
  ModEq_R_R_Code(const SmaNode * node);
  virtual ~ModEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class ModEq_R_I_Code                                                     //
//--------------------------------------------------------------------------//

class ModEq_R_I_Code : public SmaCode
{
public:
// Allocators
  ModEq_R_I_Code(const SmaNode * node);
  virtual ~ModEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitAndEqCode                                                       //
//--------------------------------------------------------------------------//

class BitAndEqCode : public SmaCode
{
public:
// Allocators
  BitAndEqCode(const SmaNode * node);
  virtual ~BitAndEqCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitOrEqCode                                                        //
//--------------------------------------------------------------------------//

class BitOrEqCode : public SmaCode
{
public:
// Allocators
  BitOrEqCode(const SmaNode * node);
  virtual ~BitOrEqCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitXorEqCode                                                       //
//--------------------------------------------------------------------------//

class BitXorEqCode : public SmaCode
{
public:
// Allocators
  BitXorEqCode(const SmaNode * node);
  virtual ~BitXorEqCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class LShiftEqCode                                                       //
//--------------------------------------------------------------------------//

class LShiftEqCode : public SmaCode
{
public:
// Allocators
  LShiftEqCode(const SmaNode * node);
  virtual ~LShiftEqCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class RShiftEqCode                                                       //
//--------------------------------------------------------------------------//

class RShiftEqCode : public SmaCode
{
public:
// Allocators
  RShiftEqCode(const SmaNode * node);
  virtual ~RShiftEqCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};

#endif // AFFECTCD_H

