// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : calculCd.h                                                 //
// description : header file for the ENIB/LI2 Calcul codes                  //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef CALCULCD_H
#define CALCULCD_H

#include "oRis/Codes/smaCd.h"

//--------------------------------------------------------------------------//
// class Decr_I_Code                                                        //
//--------------------------------------------------------------------------//

class Decr_I_Code : public SmaCode
{
public:
// Allocators
  Decr_I_Code(const SmaNode * node);
  virtual ~Decr_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Decr_R_Code                                                        //
//--------------------------------------------------------------------------//

class Decr_R_Code : public SmaCode
{
public:
// Allocators
  Decr_R_Code(const SmaNode * node);
  virtual ~Decr_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PreDecr_I_Code                                                     //
//--------------------------------------------------------------------------//

class PreDecr_I_Code : public SmaCode
{
public:
// Allocators
  PreDecr_I_Code(const SmaNode * node);
  virtual ~PreDecr_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PreDecr_R_Code                                                     //
//--------------------------------------------------------------------------//

class PreDecr_R_Code : public SmaCode
{
public:
// Allocators
  PreDecr_R_Code(const SmaNode * node);
  virtual ~PreDecr_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PostDecr_I_Code                                                    //
//--------------------------------------------------------------------------//

class PostDecr_I_Code : public SmaCode
{
public:
// Allocators
  PostDecr_I_Code(const SmaNode * node);
  virtual ~PostDecr_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PostDecr_R_Code                                                    //
//--------------------------------------------------------------------------//

class PostDecr_R_Code : public SmaCode
{
public:
// Allocators
  PostDecr_R_Code(const SmaNode * node);
  virtual ~PostDecr_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Incr_I_Code                                                        //
//--------------------------------------------------------------------------//

class Incr_I_Code : public SmaCode
{
public:
// Allocators
  Incr_I_Code(const SmaNode * node);
  virtual ~Incr_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Incr_R_Code                                                        //
//--------------------------------------------------------------------------//

class Incr_R_Code : public SmaCode
{
public:
// Allocators
  Incr_R_Code(const SmaNode * node);
  virtual ~Incr_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PreIncr_I_Code                                                     //
//--------------------------------------------------------------------------//

class PreIncr_I_Code : public SmaCode
{
public:
// Allocators
  PreIncr_I_Code(const SmaNode * node);
  virtual ~PreIncr_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PreIncr_R_Code                                                     //
//--------------------------------------------------------------------------//

class PreIncr_R_Code : public SmaCode
{
public:
// Allocators
  PreIncr_R_Code(const SmaNode * node);
  virtual ~PreIncr_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PostIncr_I_Code                                                    //
//--------------------------------------------------------------------------//

class PostIncr_I_Code : public SmaCode
{
public:
// Allocators
  PostIncr_I_Code(const SmaNode * node);
  virtual ~PostIncr_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class PostIncr_R_Code                                                    //
//--------------------------------------------------------------------------//

class PostIncr_R_Code : public SmaCode
{
public:
// Allocators
  PostIncr_R_Code(const SmaNode * node);
  virtual ~PostIncr_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_V_V_Code                                                      //
//--------------------------------------------------------------------------//

class Plus_V_V_Code : public SmaCode
{
public:
// Allocators
  Plus_V_V_Code(const SmaNode * node);
  virtual ~Plus_V_V_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_IV_RV_Code                                                    //
//--------------------------------------------------------------------------//

class Plus_IV_RV_Code : public SmaCode
{
public:
// Allocators
  Plus_IV_RV_Code(const SmaNode * node);
  virtual ~Plus_IV_RV_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_RV_IV_Code                                                    //
//--------------------------------------------------------------------------//

class Plus_RV_IV_Code : public SmaCode
{
public:
// Allocators
  Plus_RV_IV_Code(const SmaNode * node);
  virtual ~Plus_RV_IV_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_I_I_Code                                                      //
//--------------------------------------------------------------------------//

class Plus_I_I_Code : public SmaCode
{
public:
// Allocators
  Plus_I_I_Code(const SmaNode * node);
  virtual ~Plus_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_I_R_Code                                                      //
//--------------------------------------------------------------------------//

class Plus_I_R_Code : public SmaCode
{
public:
// Allocators
  Plus_I_R_Code(const SmaNode * node);
  virtual ~Plus_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_R_R_Code                                                      //
//--------------------------------------------------------------------------//

class Plus_R_R_Code : public SmaCode
{
public:
// Allocators
  Plus_R_R_Code(const SmaNode * node);
  virtual ~Plus_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_R_I_Code                                                      //
//--------------------------------------------------------------------------//

class Plus_R_I_Code : public SmaCode
{
public:
// Allocators
  Plus_R_I_Code(const SmaNode * node);
  virtual ~Plus_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Plus_S_S_Code                                                      //
//--------------------------------------------------------------------------//

class Plus_S_S_Code : public SmaCode
{
public:
// Allocators
  Plus_S_S_Code(const SmaNode * node);
  virtual ~Plus_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Minus_I_I_Code                                                     //
//--------------------------------------------------------------------------//

class Minus_I_I_Code : public SmaCode
{
public:
// Allocators
  Minus_I_I_Code(const SmaNode * node);
  virtual ~Minus_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Minus_I_R_Code                                                     //
//--------------------------------------------------------------------------//

class Minus_I_R_Code : public SmaCode
{
public:
// Allocators
  Minus_I_R_Code(const SmaNode * node);
  virtual ~Minus_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Minus_R_R_Code                                                     //
//--------------------------------------------------------------------------//

class Minus_R_R_Code : public SmaCode
{
public:
// Allocators
  Minus_R_R_Code(const SmaNode * node);
  virtual ~Minus_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Minus_R_I_Code                                                     //
//--------------------------------------------------------------------------//

class Minus_R_I_Code : public SmaCode
{
public:
// Allocators
  Minus_R_I_Code(const SmaNode * node);
  virtual ~Minus_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mult_I_I_Code                                                      //
//--------------------------------------------------------------------------//

class Mult_I_I_Code : public SmaCode
{
public:
// Allocators
  Mult_I_I_Code(const SmaNode * node);
  virtual ~Mult_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mult_I_R_Code                                                      //
//--------------------------------------------------------------------------//

class Mult_I_R_Code : public SmaCode
{
public:
// Allocators
  Mult_I_R_Code(const SmaNode * node);
  virtual ~Mult_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mult_R_R_Code                                                      //
//--------------------------------------------------------------------------//

class Mult_R_R_Code : public SmaCode
{
public:
// Allocators
  Mult_R_R_Code(const SmaNode * node);
  virtual ~Mult_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mult_R_I_Code                                                      //
//--------------------------------------------------------------------------//

class Mult_R_I_Code : public SmaCode
{
public:
// Allocators
  Mult_R_I_Code(const SmaNode * node);
  virtual ~Mult_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Div_I_I_Code                                                       //
//--------------------------------------------------------------------------//

class Div_I_I_Code : public SmaCode
{
public:
// Allocators
  Div_I_I_Code(const SmaNode * node);
  virtual ~Div_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Div_I_R_Code                                                       //
//--------------------------------------------------------------------------//

class Div_I_R_Code : public SmaCode
{
public:
// Allocators
  Div_I_R_Code(const SmaNode * node);
  virtual ~Div_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Div_R_R_Code                                                       //
//--------------------------------------------------------------------------//

class Div_R_R_Code : public SmaCode
{
public:
// Allocators
  Div_R_R_Code(const SmaNode * node);
  virtual ~Div_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Div_R_I_Code                                                       //
//--------------------------------------------------------------------------//

class Div_R_I_Code : public SmaCode
{
public:
// Allocators
  Div_R_I_Code(const SmaNode * node);
  virtual ~Div_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mod_I_I_Code                                                       //
//--------------------------------------------------------------------------//

class Mod_I_I_Code : public SmaCode
{
public:
// Allocators
  Mod_I_I_Code(const SmaNode * node);
  virtual ~Mod_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mod_I_R_Code                                                       //
//--------------------------------------------------------------------------//

class Mod_I_R_Code : public SmaCode
{
public:
// Allocators
  Mod_I_R_Code(const SmaNode * node);
  virtual ~Mod_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mod_R_R_Code                                                       //
//--------------------------------------------------------------------------//

class Mod_R_R_Code : public SmaCode
{
public:
// Allocators
  Mod_R_R_Code(const SmaNode * node);
  virtual ~Mod_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Mod_R_I_Code                                                       //
//--------------------------------------------------------------------------//

class Mod_R_I_Code : public SmaCode
{
public:
// Allocators
  Mod_R_I_Code(const SmaNode * node);
  virtual ~Mod_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class UMinus_I_Code                                                      //
//--------------------------------------------------------------------------//

class UMinus_I_Code : public SmaCode
{
public:
// Allocators
  UMinus_I_Code(const SmaNode * node);
  virtual ~UMinus_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class UMinus_R_Code                                                      //
//--------------------------------------------------------------------------//

class UMinus_R_Code : public SmaCode
{
public:
// Allocators
  UMinus_R_Code(const SmaNode * node);
  virtual ~UMinus_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitNotCode                                                         //
//--------------------------------------------------------------------------//

class BitNotCode : public SmaCode
{
public:
// Allocators
  BitNotCode(const SmaNode * node);
  virtual ~BitNotCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitAndCode                                                         //
//--------------------------------------------------------------------------//

class BitAndCode : public SmaCode
{
public:
// Allocators
  BitAndCode(const SmaNode * node);
  virtual ~BitAndCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitOrCode                                                          //
//--------------------------------------------------------------------------//

class BitOrCode : public SmaCode
{
public:
// Allocators
  BitOrCode(const SmaNode * node);
  virtual ~BitOrCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class BitXorCode                                                         //
//--------------------------------------------------------------------------//

class BitXorCode : public SmaCode
{
public:
// Allocators
  BitXorCode(const SmaNode * node);
  virtual ~BitXorCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class LShiftCode                                                         //
//--------------------------------------------------------------------------//

class LShiftCode : public SmaCode
{
public:
// Allocators
  LShiftCode(const SmaNode * node);
  virtual ~LShiftCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class RShiftCode                                                         //
//--------------------------------------------------------------------------//

class RShiftCode : public SmaCode
{
public:
// Allocators
  RShiftCode(const SmaNode * node);
  virtual ~RShiftCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};

#endif // CALCULCD_H

