// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : comparCd.h                                                 //
// description : header file for the ENIB/LI2 Calcul Comparaison            //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef COMPARCD_H
#define COMPARCD_H

#include "oRis/Codes/smaCd.h"

//--------------------------------------------------------------------------//
// class Equal_Deep_Code                                                    //
//--------------------------------------------------------------------------//
 
class Equal_Deep_Code : public SmaCode
{
public:
// Allocators
  Equal_Deep_Code(const SmaNode * node);
  virtual ~Equal_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_V_V_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_V_V_Code : public SmaCode
{
public:
// Allocators
  Equal_V_V_Code(const SmaNode * node);
  virtual ~Equal_V_V_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_I_I_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_I_I_Code : public SmaCode
{
public:
// Allocators
  Equal_I_I_Code(const SmaNode * node);
  virtual ~Equal_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_I_R_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_I_R_Code : public SmaCode
{
public:
// Allocators
  Equal_I_R_Code(const SmaNode * node);
  virtual ~Equal_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_R_R_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_R_R_Code : public SmaCode
{
public:
// Allocators
  Equal_R_R_Code(const SmaNode * node);
  virtual ~Equal_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_R_I_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_R_I_Code : public SmaCode
{
public:
// Allocators
  Equal_R_I_Code(const SmaNode * node);
  virtual ~Equal_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_S_S_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_S_S_Code : public SmaCode
{
public:
// Allocators
  Equal_S_S_Code(const SmaNode * node);
  virtual ~Equal_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Equal_A_A_Code                                                     //
//--------------------------------------------------------------------------//

class Equal_A_A_Code : public SmaCode
{
public:
// Allocators
  Equal_A_A_Code(const SmaNode * node);
  virtual ~Equal_A_A_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_Deep_Code                                                     //
//--------------------------------------------------------------------------//
 
class Diff_Deep_Code : public SmaCode
{
public:
// Allocators
  Diff_Deep_Code(const SmaNode * node);
  virtual ~Diff_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_V_V_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_V_V_Code : public SmaCode
{
public:
// Allocators
  Diff_V_V_Code(const SmaNode * node);
  virtual ~Diff_V_V_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_I_I_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_I_I_Code : public SmaCode
{
public:
// Allocators
  Diff_I_I_Code(const SmaNode * node);
  virtual ~Diff_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_I_R_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_I_R_Code : public SmaCode
{
public:
// Allocators
  Diff_I_R_Code(const SmaNode * node);
  virtual ~Diff_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_R_R_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_R_R_Code : public SmaCode
{
public:
// Allocators
  Diff_R_R_Code(const SmaNode * node);
  virtual ~Diff_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_R_I_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_R_I_Code : public SmaCode
{
public:
// Allocators
  Diff_R_I_Code(const SmaNode * node);
  virtual ~Diff_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_S_S_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_S_S_Code : public SmaCode
{
public:
// Allocators
  Diff_S_S_Code(const SmaNode * node);
  virtual ~Diff_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Diff_A_A_Code                                                      //
//--------------------------------------------------------------------------//

class Diff_A_A_Code : public SmaCode
{
public:
// Allocators
  Diff_A_A_Code(const SmaNode * node);
  virtual ~Diff_A_A_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Inf_Deep_Code                                                      //
//--------------------------------------------------------------------------//

class Inf_Deep_Code : public SmaCode
{
public:
// Allocators
  Inf_Deep_Code(const SmaNode * node);
  virtual ~Inf_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Inf_I_I_Code                                                       //
//--------------------------------------------------------------------------//

class Inf_I_I_Code : public SmaCode
{
public:
// Allocators
  Inf_I_I_Code(const SmaNode * node);
  virtual ~Inf_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Inf_I_R_Code                                                       //
//--------------------------------------------------------------------------//

class Inf_I_R_Code : public SmaCode
{
public:
// Allocators
  Inf_I_R_Code(const SmaNode * node);
  virtual ~Inf_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Inf_R_R_Code                                                       //
//--------------------------------------------------------------------------//

class Inf_R_R_Code : public SmaCode
{
public:
// Allocators
  Inf_R_R_Code(const SmaNode * node);
  virtual ~Inf_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Inf_R_I_Code                                                       //
//--------------------------------------------------------------------------//

class Inf_R_I_Code : public SmaCode
{
public:
// Allocators
  Inf_R_I_Code(const SmaNode * node);
  virtual ~Inf_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Inf_S_S_Code                                                       //
//--------------------------------------------------------------------------//

class Inf_S_S_Code : public SmaCode
{
public:
// Allocators
  Inf_S_S_Code(const SmaNode * node);
  virtual ~Inf_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class InfEq_Deep_Code                                                    //
//--------------------------------------------------------------------------//

class InfEq_Deep_Code : public SmaCode
{
public:
// Allocators
  InfEq_Deep_Code(const SmaNode * node);
  virtual ~InfEq_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class InfEq_I_I_Code                                                     //
//--------------------------------------------------------------------------//

class InfEq_I_I_Code : public SmaCode
{
public:
// Allocators
  InfEq_I_I_Code(const SmaNode * node);
  virtual ~InfEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class InfEq_I_R_Code                                                     //
//--------------------------------------------------------------------------//

class InfEq_I_R_Code : public SmaCode
{
public:
// Allocators
  InfEq_I_R_Code(const SmaNode * node);
  virtual ~InfEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class InfEq_R_R_Code                                                     //
//--------------------------------------------------------------------------//

class InfEq_R_R_Code : public SmaCode
{
public:
// Allocators
  InfEq_R_R_Code(const SmaNode * node);
  virtual ~InfEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class InfEq_R_I_Code                                                     //
//--------------------------------------------------------------------------//

class InfEq_R_I_Code : public SmaCode
{
public:
// Allocators
  InfEq_R_I_Code(const SmaNode * node);
  virtual ~InfEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class InfEq_S_S_Code                                                     //
//--------------------------------------------------------------------------//

class InfEq_S_S_Code : public SmaCode
{
public:
// Allocators
  InfEq_S_S_Code(const SmaNode * node);
  virtual ~InfEq_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Sup_Deep_Code                                                      //
//--------------------------------------------------------------------------//

class Sup_Deep_Code : public SmaCode
{
public:
// Allocators
  Sup_Deep_Code(const SmaNode * node);
  virtual ~Sup_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Sup_I_I_Code                                                       //
//--------------------------------------------------------------------------//

class Sup_I_I_Code : public SmaCode
{
public:
// Allocators
  Sup_I_I_Code(const SmaNode * node);
  virtual ~Sup_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Sup_I_R_Code                                                       //
//--------------------------------------------------------------------------//

class Sup_I_R_Code : public SmaCode
{
public:
// Allocators
  Sup_I_R_Code(const SmaNode * node);
  virtual ~Sup_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Sup_R_R_Code                                                       //
//--------------------------------------------------------------------------//

class Sup_R_R_Code : public SmaCode
{
public:
// Allocators
  Sup_R_R_Code(const SmaNode * node);
  virtual ~Sup_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Sup_R_I_Code                                                       //
//--------------------------------------------------------------------------//

class Sup_R_I_Code : public SmaCode
{
public:
// Allocators
  Sup_R_I_Code(const SmaNode * node);
  virtual ~Sup_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Sup_S_S_Code                                                       //
//--------------------------------------------------------------------------//

class Sup_S_S_Code : public SmaCode
{
public:
// Allocators
  Sup_S_S_Code(const SmaNode * node);
  virtual ~Sup_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SupEq_Deep_Code                                                    //
//--------------------------------------------------------------------------//

class SupEq_Deep_Code : public SmaCode
{
public:
// Allocators
  SupEq_Deep_Code(const SmaNode * node);
  virtual ~SupEq_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SupEq_I_I_Code                                                     //
//--------------------------------------------------------------------------//

class SupEq_I_I_Code : public SmaCode
{
public:
// Allocators
  SupEq_I_I_Code(const SmaNode * node);
  virtual ~SupEq_I_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SupEq_I_R_Code                                                     //
//--------------------------------------------------------------------------//

class SupEq_I_R_Code : public SmaCode
{
public:
// Allocators
  SupEq_I_R_Code(const SmaNode * node);
  virtual ~SupEq_I_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SupEq_R_R_Code                                                     //
//--------------------------------------------------------------------------//

class SupEq_R_R_Code : public SmaCode
{
public:
// Allocators
  SupEq_R_R_Code(const SmaNode * node);
  virtual ~SupEq_R_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SupEq_R_I_Code                                                     //
//--------------------------------------------------------------------------//

class SupEq_R_I_Code : public SmaCode
{
public:
// Allocators
  SupEq_R_I_Code(const SmaNode * node);
  virtual ~SupEq_R_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SupEq_S_S_Code                                                     //
//--------------------------------------------------------------------------//

class SupEq_S_S_Code : public SmaCode
{
public:
// Allocators
  SupEq_S_S_Code(const SmaNode * node);
  virtual ~SupEq_S_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Min_Deep_Code                                                      //
//--------------------------------------------------------------------------//
 
class Min_Deep_Code : public SmaCode
{
public:
// Allocators
  Min_Deep_Code(const SmaNode * node);
  virtual ~Min_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Min_I_Code                                                         //
//--------------------------------------------------------------------------//
 
class Min_I_Code : public SmaCode
{
public:
// Allocators
  Min_I_Code(const SmaNode * node);
  virtual ~Min_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Min_R_Code                                                         //
//--------------------------------------------------------------------------//
 
class Min_R_Code : public SmaCode
{
public:
// Allocators
  Min_R_Code(const SmaNode * node);
  virtual ~Min_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Min_S_Code                                                         //
//--------------------------------------------------------------------------//
 
class Min_S_Code : public SmaCode
{
public:
// Allocators
  Min_S_Code(const SmaNode * node);
  virtual ~Min_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Max_Deep_Code                                                      //
//--------------------------------------------------------------------------//
 
class Max_Deep_Code : public SmaCode
{
public:
// Allocators
  Max_Deep_Code(const SmaNode * node);
  virtual ~Max_Deep_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Max_I_Code                                                         //
//--------------------------------------------------------------------------//
 
class Max_I_Code : public SmaCode
{
public:
// Allocators
  Max_I_Code(const SmaNode * node);
  virtual ~Max_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Max_R_Code                                                         //
//--------------------------------------------------------------------------//
 
class Max_R_Code : public SmaCode
{
public:
// Allocators
  Max_R_Code(const SmaNode * node);
  virtual ~Max_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class Max_S_Code                                                         //
//--------------------------------------------------------------------------//
 
class Max_S_Code : public SmaCode
{
public:
// Allocators
  Max_S_Code(const SmaNode * node);
  virtual ~Max_S_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};

#endif // COMPARCD_H

