// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : valCd.h                                                    //
// description : header file for the ENIB/LI2 Values access codes           //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef VALCD_H
#define VALCD_H

#include "oRis/Codes/smaCd.h"
#include "oRis/Main/constVal.h"

//--------------------------------------------------------------------------//
// class ConstCode                                                          //
//--------------------------------------------------------------------------//

class ConstCode : public SmaCode
{
public:
// Allocators
  ConstCode(const SmaNode * node,const Value & value);
  virtual ~ConstCode(void);
// Evaluation
  virtual void eval(Context * context) const;
protected:
// Attributes
  ConstValue * _value;
};


//--------------------------------------------------------------------------//
// class RealRndCode                                                        //
//--------------------------------------------------------------------------//

class RealRndCode : public SmaCode
{
public:
// Allocators
  RealRndCode(const SmaNode * node);
  virtual ~RealRndCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class IntRnd_I_Code                                                      //
//--------------------------------------------------------------------------//

class IntRnd_I_Code : public SmaCode
{
public:
// Allocators
  IntRnd_I_Code(const SmaNode * node);
  virtual ~IntRnd_I_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class IntRnd_R_Code                                                      //
//--------------------------------------------------------------------------//

class IntRnd_R_Code : public SmaCode
{
public:
// Allocators
  IntRnd_R_Code(const SmaNode * node);
  virtual ~IntRnd_R_Code(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class SelfCode                                                           //
//--------------------------------------------------------------------------//

class SelfCode : public SmaCode
{
public:
// Allocators
  SelfCode(const SmaNode * node);
  virtual ~SelfCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class CallerCode                                                         //
//--------------------------------------------------------------------------//

class CallerCode : public SmaCode
{
public:
// Allocators
  CallerCode(const SmaNode * node);
  virtual ~CallerCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class DumpCode                                                           //
//--------------------------------------------------------------------------//

class DumpCode : public SmaCode
{
public:
// Allocators
  DumpCode(const SmaNode * node);
  virtual ~DumpCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};


//--------------------------------------------------------------------------//
// class ValueOfCode                                                        //
//--------------------------------------------------------------------------//

class ValueOfCode : public SmaCode
{
public:
// Allocators
  ValueOfCode(const SmaNode * node);
  virtual ~ValueOfCode(void);
// Evaluation
  virtual void eval(Context * context) const;
};

#endif // VALCD_H


