// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : varCd.h                                                    //
// description : header file for the ENIB/LI2 Variable access codes         //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef VARCD_H
#define VARCD_H

#include "oRis/Codes/smaCd.h"
#include "oRis/Main/value.h"

//--------------------------------------------------------------------------//
// class VarCode                                                            //
//--------------------------------------------------------------------------//

class VarCode : public SmaCode
{
public:
// Allocators
  VarCode(const SmaNode * node,const Word & name);
  virtual ~VarCode(void);
// Evaluation
  virtual void eval(Context * context) const;
protected:
// Attributes
  Word _name;
};


//--------------------------------------------------------------------------//
// class LocalVarCode                                                       //
//--------------------------------------------------------------------------//

class LocalVarCode : public SmaCode
{
public:
// Allocators
  LocalVarCode(const SmaNode * node,int rank);
  virtual ~LocalVarCode(void);
// Evaluation
  virtual void eval(Context * context) const;
protected:
// Attributes
  int _rank;
};


//--------------------------------------------------------------------------//
// class FarVarCode                                                         //
//--------------------------------------------------------------------------//

class FarVarCode : public SmaCode
{
public:
// Allocators
  FarVarCode(const SmaNode * node,const Word & name);
  virtual ~FarVarCode(void);
// Evaluation
  virtual void eval(Context * context) const;
protected:
// Attributes
  Word _name;
};


#endif // VARCD_H

