// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : agtName.h                                                  //
// description : source file for the ENIB/LI2 class AgentName               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//------------------------------------------------------------------------- //

#ifndef AGTNAME_H
#define AGTNAME_H

#include "Utility/word.h"

//--------------------------------------------------------------------------//
// class AgentName                                                          //
//--------------------------------------------------------------------------//

class AgentName : public BlockAllocatedObject
{
public:
// Allocators
  inline AgentName(void);
  inline AgentName(const AgentName & agentName);
  AgentName(const Strings & agentName);
  inline AgentName(const Word & modelName,long instNum);
  inline virtual ~AgentName(void);
// Inspectors
  inline const Word & getModelName(void) const;
  inline long getInstNum(void) const;
// Comparisons
  inline bool operator==(const AgentName & agentName) const;
  inline bool operator!=(const AgentName & agentName) const;
  inline bool operator<(const AgentName & agentName) const;
  inline bool operator>(const AgentName & agentName) const;
  inline bool operator<=(const AgentName & agentName) const;
  inline bool operator>=(const AgentName & agentName) const;
// Input/output
  friend ostream &operator<<(ostream & stream,const AgentName & agentName);
  Strings print(void) const;
// Modifiers
  inline void setModelName(const Word & modelName);
  inline void setInstNum(long instNum);
  inline AgentName & operator=(const AgentName & agtname);
private:
// Attributes 
  Word _modelName;
  long _instNum;
};

#include "oRis/Main/agtName.Ci"

#endif // AGTNAME_H

