// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : dLibInfo.h                                                 //
// description : header file for the ENIB/LI2 class DynLibInfo              //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef DLIBINFO_H
#define DLIBINFO_H

#include "Utility/strings.h"

//--------------------------------------------------------------------------//
// class DynLibInfo                                                         //
//--------------------------------------------------------------------------//

class Agent;
class Model;
class Context;

typedef void (*ExternFunction)(Context *);

class DynLibInfo : public BlockAllocatedObject
{
public:
// Static Methods
  static Strings buildWrapName(const Strings & completeName);
// Allocators
  DynLibInfo(const Strings & libName);
  virtual ~DynLibInfo(void);
// Inspectors
  inline const Strings & getLibName(void) const;
  inline bool fail(void) const;
  inline Agent * getNewAgent(Model * model,long instNum) const;
  ExternFunction getExternFunction(const Strings & completeName,
                                   const Strings & wrapName) const;
protected:
// Attributes
  Strings _libName;
  void * _handle;
  void (*_openFunction)(void);
  void (*_closeFunction)(void);
  Agent * (*_agtFunction)(Model *,long);
  ExternFunction (*_modFunction)(const Strings &);
};

typedef SimpleVector<DynLibInfo *> DynLibInfoVect;

#include "oRis/Main/dLibInfo.Ci"

#endif // DLIBINFO_H

