// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : extMod.h                                                   //
// description : header file for the ENIB/LI2 class ExternModule            //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//------------------------------------------------------------------------- //

#ifndef EXTMOD_H
#define EXTMOD_H

#include "oRis/Main/execMod.h"
#include "oRis/Main/dLibInfo.h"

//---------------------------------------------------------------------------//
// class ExternModule                                                        //
//---------------------------------------------------------------------------//

class ExternModule : public ExecModule
{
public:
// Allocators
  ExternModule(const Word & name,
               ExecModule::SpecialType specialType,
               const ValueType & valueType,
               Model * model,Agent * owner,
               const Strings & nativeName);
  ExternModule(const ExternModule & module);
  virtual ExecModule * duplicate(void) const;
  virtual ~ExternModule(void);
// Inspectors
  inline virtual ExecModule::ModuleType getType(void) const;
  const Strings & getNativeName(void) const;
// Comparisons
// Input/output
  virtual Strings print(int column=0) const;
// Modifiers
protected:
// Attributes
  ExternFunction _function;
  Strings _nativeName;
};

#include "oRis/Main/extMod.Ci"

#endif // EXTMOD_H

