// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : parser.h                                                   //
// description : header file for the ENIB/LI2 parser classes                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef PARSER_H
#define PARSER_H

#include "Utility/stlVect.h"
#include "Utility/stlList.h"
#include "Utility/stlMap.h"

#include "oRis/Main/value.h"

class SmaNode;
class Model;

class ParserSymbol : public BlockAllocatedObject // 'yylval' is a ParserSymbol
{
public:
  int code;     // code returned by flex++
  Value value;
  SmaNode * node;
  Model * model;
  //-----------
  inline ParserSymbol(void)
          : BlockAllocatedObject(),
            code(0), value(),
            node((SmaNode *)0), model((Model *)0) {}
  inline ParserSymbol(const ParserSymbol & symbol)
          : BlockAllocatedObject(),
            code(symbol.code), value(symbol.value),
            node(symbol.node), model(symbol.model) {}
  inline virtual ~ParserSymbol(void) {}
  inline ParserSymbol & operator=(const ParserSymbol & symbol)
          {
          code=symbol.code;
          value=symbol.value;
          node=symbol.node;
          model=symbol.model;
          return(*this);
          }
};

typedef StlList<ParserSymbol> SymbolList;
typedef StlVector<ParserSymbol> SymbolVect;
typedef StlMap<Strings,SymbolVect> SymbolMap;

#endif // PARSER_H

