// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : textOut.h                                                  //
// description : header file for the ENIB/LI2 class TextOutput              //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef TEXTOUT_H
#define TEXTOUT_H


#include "Utility/blockAlc.h"

#include <iostream>

//---------------------------------------------------------------------------//
// class TextOutput                                                          //
//---------------------------------------------------------------------------//

class TextOutput : public BlockAllocatedObject
{
public:
// Allocators
  TextOutput(ostream * stream=(ostream *)0);
  virtual ~TextOutput(void);
// Input/output
  virtual TextOutput & operator<<(char c);
  virtual TextOutput & operator<<(const char * s);
  virtual TextOutput & operator<<(void * p);
  virtual TextOutput & operator<<(int n);
  virtual TextOutput & operator<<(unsigned int n);
  virtual TextOutput & operator<<(short s);
  virtual TextOutput & operator<<(unsigned short s);
  virtual TextOutput & operator<<(long l);
  virtual TextOutput & operator<<(unsigned long l);
  virtual TextOutput & operator<<(float f);
  virtual TextOutput & operator<<(double d);
  virtual TextOutput & operator<<(ostream & (*func)(ostream &));
protected:
// Attributes
  ostream * _stream;
};

#endif // TEXTOUT_H

