// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : tmpVal.h                                                   //
// description : header file for the ENIB/LI2 class TmpValue                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef TMPVAL_H
#define TMPVAL_H

#include "oRis/Main/value.h"

//---------------------------------------------------------------------------//
// class TmpValue                                                            //
//---------------------------------------------------------------------------//

class TmpValue : public Value
{
public:
// Static methods
  inline static TmpValue * getTmpValue(const ValueType & type);
  static void clearTmpValueStock(void);
// Allocators
protected:                                 // use static methods
  inline TmpValue(const ValueType & type);
  inline virtual ~TmpValue(void);
public:
// Inspectors
// Comparisons
// Input/output
// Modifiers
  inline virtual void reference(void);
  inline virtual void relax(void);
protected:
// Attributes
  static SimpleVector<TmpValue *> _tmpValueStock;
};

#include "oRis/Main/tmpVal.Ci"

#endif // TMPVAL_H

