// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : ifNd.h                                                     //
// description : header file for the ENIB/LI2 class IfNode                  //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef IFND_H
#define IFND_H

#include "oRis/Nodes/smaNd.h"

//--------------------------------------------------------------------------//
// class IfNode                                                             //
//--------------------------------------------------------------------------//

class IfNode : public SmaNode
{
public:
// Allocators
  IfNode(int lineNumber,const Strings & fileName,const Strings & name,
         const Strings & secondName);
  IfNode(const IfNode & node);
  virtual SmaNode * duplicate(void) const;
  virtual ~IfNode(void);
// Inspectors
  virtual bool containsReturn(void) const;
  virtual bool buildsParent(const Model * parent) const;
  virtual bool destroysParent(const Model * parent) const;
// Input/Output
  virtual Strings print(int column=0) const;
// Evaluation
  virtual bool check(const Context * context,const Model * model);  
  virtual CodeVect * generateVoidCode(void); 
private:
// Attributes
  Strings _secondName;
};

#endif // IFND_H

