// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : newNd.h                                                    //
// description : header file for the ENIB/LI2 class NewNode                 //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef NEWND_H
#define NEWND_H

#include "oRis/Nodes/smaNd.h"

//--------------------------------------------------------------------------//
// class NewNode                                                            //
//--------------------------------------------------------------------------//

class NewNode : public SmaNode
{
public:
// Allocators
  NewNode(int lineNumber,const Strings & fileName,const Strings & name,
          Model * model,bool isTransient,bool suffixGiven);
  NewNode(const NewNode & node);
  virtual SmaNode * duplicate(void) const;
  virtual ~NewNode(void);
// Input/Output
  virtual Strings _print(int column=0) const;
// Evaluation
  virtual bool check(const Context * context,const Model * model);  
  virtual CodeVect * generateCode(void);
private:
// Attributes
  Model * _model;
  bool _isTransient;
  bool _suffixGiven;
};

#endif // NEWND_H

