// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : nodes.h                                                    //
// description : header file for the ENIB/LI2 node classes                  //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef NODES_H
#define NODES_H

//-------- Instruction Nodes -----------------------------------------------//

#include "oRis/Nodes/affectNd.h"
#include "oRis/Nodes/seqNd.h"
#include "oRis/Nodes/castNd.h"
#include "oRis/Nodes/returnNd.h"
#include "oRis/Nodes/criticNd.h"
#include "oRis/Nodes/noAtCBNd.h"
#include "oRis/Nodes/startNd.h"
#include "oRis/Nodes/formatNd.h"
#include "oRis/Nodes/printNd.h"
#include "oRis/Nodes/errorNd.h"
#include "oRis/Nodes/moduleNd.h"
#include "oRis/Nodes/farModNd.h"

#include "oRis/Nodes/condNd.h"
#include "oRis/Nodes/minNd.h"
#include "oRis/Nodes/maxNd.h"
#include "oRis/Nodes/ifNd.h"
#include "oRis/Nodes/doNd.h"
#include "oRis/Nodes/whileNd.h"
#include "oRis/Nodes/forNd.h"

#include "oRis/Nodes/dumpNd.h"
#include "oRis/Nodes/valOfNd.h"
#include "oRis/Nodes/newNd.h"
#include "oRis/Nodes/deleteNd.h"

#include "oRis/Nodes/insertNd.h"
#include "oRis/Nodes/pushFrNd.h"
#include "oRis/Nodes/pushBaNd.h"
#include "oRis/Nodes/removeNd.h"
#include "oRis/Nodes/popFrNd.h"
#include "oRis/Nodes/popBaNd.h"
#include "oRis/Nodes/eraseNd.h"
#include "oRis/Nodes/sortNd.h"

//-------- Logical Nodes ---------------------------------------------------//

#include "oRis/Nodes/andNd.h"
#include "oRis/Nodes/orNd.h"
#include "oRis/Nodes/notNd.h"

#include "oRis/Nodes/eqNd.h"
#include "oRis/Nodes/difNd.h"
#include "oRis/Nodes/infNd.h"
#include "oRis/Nodes/infEqNd.h"
#include "oRis/Nodes/supNd.h"
#include "oRis/Nodes/supEqNd.h"

//-------- Valued Nodes ----------------------------------------------------//

#include "oRis/Nodes/varNd.h"
#include "oRis/Nodes/indexNd.h"
#include "oRis/Nodes/frontNd.h"
#include "oRis/Nodes/backNd.h"
#include "oRis/Nodes/farVarNd.h"
#include "oRis/Nodes/intRndNd.h"
#include "oRis/Nodes/reaRndNd.h"
#include "oRis/Nodes/constNd.h"
#include "oRis/Nodes/selfNd.h"
#include "oRis/Nodes/callerNd.h"

#include "oRis/Nodes/incrNd.h"
#include "oRis/Nodes/decrNd.h"
#include "oRis/Nodes/plusNd.h"
#include "oRis/Nodes/plusEqNd.h"
#include "oRis/Nodes/minusNd.h"
#include "oRis/Nodes/minsEqNd.h"
#include "oRis/Nodes/multNd.h"
#include "oRis/Nodes/multEqNd.h"
#include "oRis/Nodes/divNd.h"
#include "oRis/Nodes/divEqNd.h"
#include "oRis/Nodes/modNd.h"
#include "oRis/Nodes/modEqNd.h"
#include "oRis/Nodes/uMinNd.h"

#include "oRis/Nodes/bitNotNd.h"
#include "oRis/Nodes/bitAndNd.h"
#include "oRis/Nodes/bAndEqNd.h"
#include "oRis/Nodes/bitOrNd.h"
#include "oRis/Nodes/bOrEqNd.h"
#include "oRis/Nodes/bitXorNd.h"
#include "oRis/Nodes/bXorEqNd.h"
#include "oRis/Nodes/lShiftNd.h"
#include "oRis/Nodes/lShEqNd.h"
#include "oRis/Nodes/rShiftNd.h"
#include "oRis/Nodes/rShEqNd.h"

#include "oRis/Nodes/seekNd.h"
#include "oRis/Nodes/lengthNd.h"
#include "oRis/Nodes/minPosNd.h"
#include "oRis/Nodes/maxPosNd.h"

#endif // NODES_H

