// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : selfNd.h                                                   //
// description : header file for the ENIB/LI2 class SelfNode                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef SELFND_H
#define SELFND_H

#include "oRis/Nodes/smaNd.h"

//--------------------------------------------------------------------------//
// class SelfNode                                                           //
//--------------------------------------------------------------------------//

class SelfNode : public SmaNode
{
public:
// Allocators
  SelfNode(int lineNumber,const Strings & fileName,const Strings & name);
  SelfNode(const SelfNode & node);
  virtual SmaNode * duplicate(void) const;
  virtual ~SelfNode(void);
// Input/Output
  virtual Strings _print(int column=0) const;
// Evaluation
  virtual bool check(const Context * context,const Model * model);  
  virtual CodeVect * generateCode(void);
};

#endif // SELFND_H

