// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : startNd.h                                                  //
// description : header file for the ENIB/LI2 class StartNode               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef STARTND_H
#define STARTND_H

#include "oRis/Nodes/smaNd.h"

//--------------------------------------------------------------------------//
// class StartNode                                                          //
//--------------------------------------------------------------------------//

class ExecModule;

class StartNode : public SmaNode
{
public:
// Allocators
  StartNode(int lineNumber,const Strings & fileName,const Strings & name,
            ExecModule * module);
  StartNode(const StartNode & node);
  virtual SmaNode * duplicate(void) const;
  virtual ~StartNode(void);
// Inspectors
// Input/Output
  virtual Strings print(int column=0) const;
// Modifiers
  virtual void setOwner(Agent * owner);
// Evaluation
  virtual bool check(const Context * context,const Model * model);  
  virtual CodeVect * generateVoidCode(void);
private:
// Attributes
  ExecModule * _module;
};

#endif // STARTND_H

