// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : attCbPkg.h                                                 //
// description : header file for the ENIB/LI2 oRis package attrCB.pkg       //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef ATTCBPKG_H
#define ATTCBPKG_H

#include "oRis/Main/agent.h"

//--------------------------------------------------------------------------//
// class AttrCB                                                             //
//--------------------------------------------------------------------------//

class AttrCB : public Agent, public ValueCallback
{
public:
  AttrCB(Model * model,int instNum);
  virtual ~AttrCB(void);
  inline void * operator new(size_t size)
         {
         return(Agent::operator new(size));
         }
  inline void * operator new(size_t size,void * block)
         {
         return(Agent::operator new(size,block));
         }
  inline void operator delete(void * block,size_t size)
         {
         Agent::operator delete(block,size);
         }
  virtual Strings userSave(int column=0) const;
  virtual void clearReferences(bool strongClear=false);
  virtual void before(void);
  virtual void after(void);
  inline const Agent * getAgent(void) const
         {
         return(_agent);
         }
  inline Agent * accessAgent(void)
         {
         return(_agent);
         }
  inline void setAgent(Agent * agent)
         {
         _agent=agent;
         }
  inline const Strings & getAttr(void) const
         {
         return(_attribute);
         }
  inline Strings & accessAttr(void)
         {
         return(_attribute);
         }

//---- Attributes ----
protected:
  Agent * _agent;
  Strings _attribute;
  static Word _beforeWord;
  static Word _afterWord;
};

#endif // ATTCBPKG_H

