// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : cntnrPkg.h                                                 //
// description : header file for the ENIB/LI2 oRis package contain.pkg      //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef CNTNRPKG_H
#define CNTNRPKG_H

#include "oRis/Main/agent.h"
#include "Utility/stlMap.h"
#include "Utility/stlSet.h"

//--------------------------------------------------------------------------//
// class OSet                                                               //
//--------------------------------------------------------------------------//
 
class OSet : public Agent
{
public:
  OSet(Model * model,int instNum);
  virtual ~OSet(void);
  virtual void clearReferences(bool strongClear=false);
  virtual Strings userSave(int column=0) const;
 
  // native int Set::getSize(void);
  //
  static void getSize(Context * context);
 
  // native void Set::erase(void);
  //
  static void erase(Context * context);
 
  // native ELEM_TYPE[] Set::getElems(void);
  //
  static void getElems(Context * context);
 
  // native bool Set::hasElem(ELEM_TYPE elem);
  //
  static void hasElem(Context * context);
 
  // native void Set::setElem(ELEM_TYPE elem);
  //
  static void setElem(Context * context);

  // native void Set::remove(ELEM_TYPE elem);
  //
  static void remove(Context * context);
 
//---- Attributes ----
protected:
  typedef StlSet<Value *,StlPtrLess<Value> > SetType;
  SetType _set;
};

//--------------------------------------------------------------------------//
// class OMap                                                               //
//--------------------------------------------------------------------------//

class OMap : public Agent
{
public:
  OMap(Model * model,int instNum);
  virtual ~OMap(void);
  virtual void clearReferences(bool strongClear=false);
  virtual Strings userSave(int column=0) const;

  // native int Map::getSize(void);
  //
  static void getSize(Context * context);

  // native void Map::erase(void);
  //
  static void erase(Context * context);

  // native ELEM_TYPE[] Map::getElems(void);
  //
  static void getElems(Context * context);

  // native KEY_TYPE[] Map::getKeys(void);
  //
  static void getKeys(Context * context);

  // native bool Map::getElem(KEY_TYPE key,ELEM_TYPE & found);
  //
  static void getElem(Context * context);

  // native void Map::setElem(KEY_TYPE key,ELEM_TYPE elem);
  //
  static void setElem(Context * context);

  // native bool Map::readRemove(KEY_TYPE key,ELEM_TYPE & found);
  //
  static void readRemove(Context * context);

  // native void Map::remove(KEY_TYPE key);
  //
  static void remove(Context * context);

//---- Attributes ----
protected:
  typedef StlMap<Value *,Value *,StlPtrLess<Value> > MapType;
  MapType _map;
};

#endif // CNTNRPKG_H

