// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : convPkg.h                                                  //
// description : header file for the ENIB/LI2 oRis package convert.pkg      //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef CONVPKG_H
#define CONVPKG_H

#include "oRis/Main/agent.h"

//--------------------------------------------------------------------------//
// class IntConv                                                            //
//--------------------------------------------------------------------------//

class IntConv : public Agent
{
public:
  IntConv(Model * model,int instNum);
  virtual ~IntConv(void);
  virtual Strings userSave(int column=0) const;

  // native void IntConv::read(int i);
  //
  static void read(Context * context);

  // native int IntConv::intValue(void);
  //
  static void intValue(Context * context);

  // native float IntConv::floatValue(void);
  //
  static void floatValue(Context * context);

  // native string IntConv::stringValue(void);
  //
  static void stringValue(Context * context);

//---- Attributes ----
protected:
  long _intValue;
};

//--------------------------------------------------------------------------//
// class FloatConv                                                          //
//--------------------------------------------------------------------------//

class FloatConv : public Agent
{
public:
  FloatConv(Model * model,int instNum);
  virtual ~FloatConv(void);
  virtual Strings userSave(int column=0) const;

  // native void FloatConv::read(float f);
  //
  static void read(Context * context);

  // native int FloatConv::intValue(void);
  //
  static void intValue(Context * context);

  // native float FloatConv::floatValue(void);
  //
  static void floatValue(Context * context);

  // native string FloatConv::stringValue(void);
  //
  static void stringValue(Context * context);

//---- Attributes ----
protected:
  double _floatValue;
};

//--------------------------------------------------------------------------//
// class StringConv                                                         //
//--------------------------------------------------------------------------//

class StringConv : public Agent
{
public:
  StringConv(Model * model,int instNum);
  virtual ~StringConv(void);
  virtual Strings userSave(int column=0) const;

  // native void StringConv::read(string s);
  //
  static void read(Context * context);

  // native bool StringConv::fail(void);
  //
  static void fail(Context * context);

  // native int StringConv::intValue(void);
  //
  static void intValue(Context * context);

  // native float StringConv::floatValue(void);
  //
  static void floatValue(Context * context);

  // native string StringConv::stringValue(void);
  //
  static void stringValue(Context * context);

  // native Object StringConv::objectValue(void);
  //
  static void objectValue(Context * context);

  // native int StringConv::lookup(string str);
  //
  static void lookup(Context * context);

  // native string StringConv::subString(int pos,int len);
  //
  static void subString(Context * context);

  // native int StringConv::substitute(string str1,string str2);
  //
  static void substitute(Context * context);

  // native int StringConv::substituteAll(string str1,string str2);
  //
  static void substituteAll(Context * context);

  // native string StringConv::baseName(void);
  //
  static void baseName(Context * context);

  // native string StringConv::extension(void);
  //
  static void extension(Context * context);

  // native string StringConv::dirName(void);
  //
  static void dirName(Context * context);

  // native bool StringConv::toUpperChar(int pos);
  //
  static void toUpperChar(Context * context);
 
  // native bool StringConv::toLowerChar(int pos);
  //
  static void toLowerChar(Context * context);
 
  // native void StringConv::toUpper(void);
  //
  static void toUpper(Context * context);
 
  // native void StringConv::toLower(void);
  //
  static void toLower(Context * context);
 
  // native int StringConv::length(int pos);
  //
  static void length(Context * context);

//---- Attributes ----
protected:
  Strings _stringValue;
  bool _fail;
};

//--------------------------------------------------------------------------//
// class ObjectConv                                                         //
//--------------------------------------------------------------------------//

class ObjectConv : public Agent
{
public:
  ObjectConv(Model * model,int instNum);
  virtual ~ObjectConv(void);
  virtual void clearReferences(bool strongClear=false);

  virtual Strings userSave(int column=0) const;

  // native void ObjectConv::read(int i);
  //
  static void read(Context * context);

  // native int ObjectConv::intValue(void);
  //
  static void intValue(Context * context);

  // native float ObjectConv::floatValue(void);
  //
  static void floatValue(Context * context);

  // native string ObjectConv::stringValue(void);
  //
  static void stringValue(Context * context);

  // native Object ObjectConv::objectValue(void);
  //
  static void objectValue(Context * context);

//---- Attributes ----
protected:
  Agent * _objectValue;
};

#endif // CONVPKG_H

