#ifndef FCM_H
#define FCM_H

#include <fstream>
using namespace std;

#include <stdlib.h>

#include "oRis/Main/context.h"
#include "oRis/Main/agent.h"

typedef float (*PFUNCTION) (float x,float y,float* params,int count);

class GFunction
{
public:
  GFunction();
  virtual ~GFunction();
  void affect(GFunction& src);
  void init(Strings name,vector<float> params);
  float eval(float x,float y);
  Strings getName() { return _name; }
  int GetParamCount() { return _count; }
  float GetParam(int index) { return _params[index]; }

private:
  void _clean();

  static float _min(float x,float y,float* params,int count);
  static float _max(float x,float y,float* params,int count);
  static float _sum(float x,float y,float* params,int count);
  static float _punderateSum(float x,float y,float* params,int count);
  static float _multiplication(float x,float y,float* params,int count);

  Strings	_name;
  void*		_pOpenLib;
  PFUNCTION	_gFunction;
  float*	_params;
  int		_count;
};

class NFcm : public Agent {
  public :

  NFcm ( Model * model  , int instNum );
  virtual ~NFcm(void);

  //native void Fcm::new(void) ;
  static void N_Fcm(Context * context);

  //native void Fcm::setName(string name) ;
  static void setName(Context * context);

  //native void Fcm::setBiValued(void) ;
  static void setBiValued(Context * context) ;
  //native void Fcm::setTriValued(void)
  static void setTriValued(Context * context) ;
  //native void Fcm::setFuzzy(float k)
  static void setFuzzy(Context * context) ;
  //native void Fcm::setDelta(float delta)
  static void setDelta(Context * context) ; 
  //native void Fcm::setA0(float a)
  static void setA0(Context * context) ;
  //native float Fcm::getDelta(void)
  static void getDelta(Context * context); 
  //native float Fcm::getA0(void)
  static void getA0(Context * context);
  //native void Fcm::setCrisp(void)
  static void setCrisp(Context * context) ;
  //native void Fcm::setThreshold(float threshold)
  static void setThreshold(Context * context) ;
  //native void Fcm::setNormalisationBeforeForcing(bool norm);
  static void setNormalisationBeforeForcing(Context * context) ;
  //native bool Fcm::getNormalisationBeforeForcing(void);
  static void getNormalisationBeforeForcing(Context * context) ;

  //native bool Fcm::isBiValued(void)
  static void isBiValued(Context * context) ;
  //native bool Fcm::isTriValued(void)
  static void isTriValued(Context * context) ;
  //native bool Fcm::isCrisp(void)
  static void isCrisp(Context * context) ;
  //native float Fcm::getK(void);
  static void getK(Context * context);
  //native void Fcm::setK(float);
  static void setK(Context * context);
  //native float Fcm::getThreshold(void);
  static void getThreshold(Context * context);

  //native static void Fcm::addConcepts(string[] concept)
  static void addConcepts(Context * context) ;
  //native static void Fcm::addConceptsFromFile(string filename)
  static void addConceptsFromFile(Context * context) ;
  //native static void Fcm::addRandomizedConceptsFromFile(string filename, float delta)
  static void addRandomizedConceptsFromFile(Context * context) ;
  //native void Fcm::removeConcepts(string[] concept) 
  static void removeConcepts(Context * context) ;
  //native void Fcm::connect(string[] from, string[] to, float weight)
  static void connect(Context * context) ;
  //native void Fcm::disconnect(string[] from, string[] to) 
  static void disconnect(Context * context) ;

  //native void Fcm::merge(Fcm c)
  static void merge(Context * context) ;

  //native void Fcm::display(void)
  static void display(Context * context) ;
 //native string Fcm::statusTextValues(int i) 
  static void _statusTextValues(Context * context) ;

  //native void Fcm::eval(void)
  static void eval(Context * context) ;
  //native int[][] Fcm::cycle(int[] startValue, int[] forcing)
  static void cycle(Context * context) ;

  //native float FCM::getValues(int i)
  static void _getValues(Context * context);
  //native float FCM::getForcing(int i)
  static void _getForcing(Context * context);
  //native void FCM::setValues(float[] values)
  static void setValues(Context * context);
  //native void FCM::setForcing(float[] values)
  static void setForcing(Context * context);

  //native void Fcm::setValue(string concept, float value); 
  static void setValue(Context * context); 
  //native float Fcm::getValue(string concept);
  static void getValue(Context * context); 
  //native void Fcm::setNamedForcing(string concept, float value); 
  static void setNamedForcing(Context * context); 
  //native float Fcm::getNamedForcing(string concept);
  static void getNamedForcing(Context * context); 

  //native bool Fcm::has(string concept)
  static void has(Context * context) ;
  //native float Fcm::getWeight(string from , string to)
  static void getWeight(Context * context) ;

  //native void Fcm::affect(Object object)
  static void affect(Context * context) ;

  //native void Fcm::SetGFct(string concept,string gFunction,float[] params);
  static void SetGFct(Context * context) ;
  //native string Fcm::GetGFct(string concept);
  static void GetGFct(Context * context) ;
  //native float[] Fcm::GetGFctParams(string concept);
  static void GetGFctParams(Context * context) ;
  //native void Fcm::SetDefaultGFct(string gFunction,float[] params);
  static void SetDefaultGFct(Context * context) ;
  //native string Fcm::GetDefaultGFct();
  static void GetDefaultGFct(Context * context) ;
  //native float[] Fcm::GetDefaultGFctParams();
  static void GetDefaultGFctParams(Context * context) ;
  //native void Fcm::SetNumberOfEvals(int count);
  static void SetNumberOfEvals(Context * context) ;
  //native int Fcm::GetNumberOfEvals();
  static void GetNumberOfEvals(Context * context) ;
  
  //native string[] Fcm::statusTextValues(void)
  static void statusTextValues(Context * context);
  //native float[] Fcm::getValues(void)
  static void getValues(Context * context);
  //native float[] Fcm::getForcing()
  static void getForcing(Context * context);
  //native string[] Fcm::getTextWeight(void)
  static void getTextWeight(Context * context);
  //native void Fcm::setTextWeight(string[] str)
  static void setTextWeight(Context * context);
  //native void Fcm::main(void)
  static void main(Context * context);

  Strings _name; 
  bool _fuzzy;
  float _threshold;
  float _k;
  float _delta;
  float _a0;
  bool _biValued ;
  bool  _triValued ;
  bool _normalisationBeforeForcing ;
  Strings _defaultGFunction;
  vector<float> _defaultGParams;
  int _numberOfEvals;

  size_t _nbConcepts;
  StringsVect _conceptsName;
  float * _conceptVector;
  float * _forcingVector;
  float * _matrix;
  GFunction * _gFunctions;
  
  static bool _has(Strings & conceptName , NFcm * obj);
  static int _seek(Strings & conceptName, NFcm * obj) ;
  static void _normName(Strings & conceptName) ;
  static void _addConcepts(StringsVect & vect,NFcm * obj);
  static void _connect(StringsVect fromVect,StringsVect toVect,float weight,NFcm * obj);
  static bool getWord(ifstream * file , Strings & str, bool& endOfLine);
  static void eatWhites(ifstream * file);
  static void _g(float * x , float * y , size_t size,NFcm * obj);
  static float _sigma(float x,float delta,float a0,float k);
  static float _getValue(size_t i , NFcm * obj);
  static void _eval(NFcm * obj) ;

  static void getSize(Context * context);
  static void getName(Context * context);

  static float _getWeight(Strings & from, Strings & to , NFcm * obj );
};


class NLearnFcm : public NFcm {
  public :
    NLearnFcm ( Model * model  , int instNum );
  virtual ~NLearnFcm(void);

  //native void LearnFcm::addExample(float[] data)
  static void addExample(Context * context) ;
  //native void LearnFcm::resetExamples(void)
  static void resetExamples(Context * context) ;
  //native void LearnFcm::addExamplesFromFile(string filename)
  static void addExamplesFromFile(Context * context) ;
  //native void LearnFcm::learn(bool scratch) 
  static void learn(Context * context) ;
  //native void LearnFcm::_normalize(void)
  static void _normalize(Context * context) ;
};

class NCorrelationFcm : public NFcm {
  public :
    NCorrelationFcm ( Model * model  , int instNum );
  virtual ~NCorrelationFcm(void);

  //native void CorrelationFcm::learn(bool scratch) 
  static void learn(Context * context) ;
};

class NHebbianFcm : public  NFcm {
  public :
    NHebbianFcm ( Model * model  , int instNum );
  virtual ~NHebbianFcm(void);

  //native void HebbianFcm::learn(bool scratch) 
  static void learn(Context * context) ;
  };

#endif // FCM_H
