// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : filesPkg.cpp                                               //
// description : source file for the ENIB/LI2 oRis package files.pkg        //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#include "Files/filesPkg.h"
#include "Memory/memoryPkg.h"
#include "oRis/Main/simul.h"
#include "oRis/Main/context.h"

#ifndef __MSDOS__
#define EXPORT_PREFIX extern "C"
#else
#include <windows.h>
#define EXPORT_PREFIX extern "C" __declspec(dllexport)
#define openingLibrary    openingFilesLibrary
#define closingLibrary    closingFilesLibrary
#define getExternFunction getExternFilesFunction
#define getNewAgent       getNewFilesAgent
#endif

#if defined __i386__ || defined __MSDOS__
// invert16 is only accessible in this file
inline static void invert16(unsigned char * ptr)
{
unsigned char tmp=ptr[0];
ptr[0]=ptr[1];
ptr[1]=tmp;
}
 
// invert32 is only accessible in this file
inline static void invert32(unsigned char * ptr)
{
unsigned char tmp=ptr[0];
ptr[0]=ptr[3];
ptr[3]=tmp;
tmp=ptr[1];
ptr[1]=ptr[2];
ptr[2]=tmp;
}
 
// invert64 is only accessible in this file
inline static void invert64(unsigned char * ptr)
{
unsigned char tmp=ptr[0];
ptr[0]=ptr[7];
ptr[7]=tmp;
tmp=ptr[1];
ptr[1]=ptr[6];
ptr[6]=tmp;
tmp=ptr[2];
ptr[2]=ptr[5];
ptr[5]=tmp;
tmp=ptr[3];
ptr[3]=ptr[4];
ptr[4]=tmp;
}
#endif // __i386__ || __MSDOS__

//--------------------------------------------------------------------------//
// Opening and closing the library                                          //
//--------------------------------------------------------------------------//
 
EXPORT_PREFIX void openingLibrary(void)
{
  // nothing to do
}
 
EXPORT_PREFIX void closingLibrary(void)
{
  // nothing to do
}

//--------------------------------------------------------------------------//
// LookUp table for functions                                               //
//--------------------------------------------------------------------------//

EXPORT_PREFIX ExternFunction getExternFunction(const Strings & name)
{
if(name==Strings("InputFile::close()"))
        return(InputFile::close);
if(name==Strings("InputFile::fileName()"))
        return(InputFile::fileName);
if(name==Strings("InputFile::fail()"))
        return(InputFile::fail);
if(name==Strings("InputFile::eof()"))
        return(InputFile::eof);

if(name==Strings("TextInputFile::open()"))
        return(TextInputFile::open);
if(name==Strings("TextInputFile::eatBlanks()"))
        return(TextInputFile::eatBlanks);
if(name==Strings("TextInputFile::getContent()"))
        return(TextInputFile::getContent);
if(name==Strings("TextInputFile::readInt()"))
        return(TextInputFile::readInt);
if(name==Strings("TextInputFile::readFloat()"))
        return(TextInputFile::readFloat);
if(name==Strings("TextInputFile::readString()"))
        return(TextInputFile::readString);
if(name==Strings("TextInputFile::readLine()"))
        return(TextInputFile::readLine);
if(name==Strings("TextInputFile::readWord()"))
        return(TextInputFile::readWord);
if(name==Strings("TextInputFile::readObject()"))
        return(TextInputFile::readObject);

if(name==Strings("BinaryInputFile::open()"))
        return(BinaryInputFile::open);
if(name==Strings("BinaryInputFile::readByte()"))
        return(BinaryInputFile::readByte);
if(name==Strings("BinaryInputFile::readInt16()"))
        return(BinaryInputFile::readInt16);
if(name==Strings("BinaryInputFile::readInt32()"))
        return(BinaryInputFile::readInt32);
if(name==Strings("BinaryInputFile::readFloat32()"))
        return(BinaryInputFile::readFloat32);
if(name==Strings("BinaryInputFile::readFloat64()"))
        return(BinaryInputFile::readFloat64);
if(name==Strings("BinaryInputFile::readString()"))
        return(BinaryInputFile::readString);
if(name==Strings("BinaryInputFile::readBlock()"))
        return(BinaryInputFile::readBlock);

if(name==Strings("OutputFile::close()"))
        return(OutputFile::close);
if(name==Strings("OutputFile::fileName()"))
        return(OutputFile::fileName);
if(name==Strings("OutputFile::fail()"))
        return(OutputFile::fail);

if(name==Strings("TextOutputFile::open()"))
        return(TextOutputFile::open);
if(name==Strings("TextOutputFile::openAppend()"))
        return(TextOutputFile::openAppend);
if(name==Strings("TextOutputFile::writeInt()"))
        return(TextOutputFile::writeValue);
if(name==Strings("TextOutputFile::writeFloat()"))
        return(TextOutputFile::writeValue);
if(name==Strings("TextOutputFile::writeString()"))
        return(TextOutputFile::writeValue);
if(name==Strings("TextOutputFile::writeObject()"))
        return(TextOutputFile::writeValue);

if(name==Strings("BinaryOutputFile::open()"))
        return(BinaryOutputFile::open);
if(name==Strings("BinaryOutputFile::openAppend()"))
        return(BinaryOutputFile::openAppend);
if(name==Strings("BinaryOutputFile::writeByte()"))
        return(BinaryOutputFile::writeByte);
if(name==Strings("BinaryOutputFile::writeInt16()"))
        return(BinaryOutputFile::writeInt16);
if(name==Strings("BinaryOutputFile::writeInt32()"))
        return(BinaryOutputFile::writeInt32);
if(name==Strings("BinaryOutputFile::writeFloat32()"))
        return(BinaryOutputFile::writeFloat32);
if(name==Strings("BinaryOutputFile::writeFloat64()"))
        return(BinaryOutputFile::writeFloat64);
if(name==Strings("BinaryOutputFile::writeString()"))
        return(BinaryOutputFile::writeString);
if(name==Strings("BinaryOutputFile::writeBlock()"))
        return(BinaryOutputFile::writeBlock);

return((ExternFunction)0); // not found
}

//--------------------------------------------------------------------------//
// LookUp table for agents                                                  //
//--------------------------------------------------------------------------//

static Word inputFileWord(Word::create("InputFile"));
static Word textInputFileWord(Word::create("TextInputFile"));
static Word binaryInputFileWord(Word::create("BinaryInputFile"));
static Word outputFileWord(Word::create("OutputFile"));
static Word textOutputFileWord(Word::create("TextOutputFile"));
static Word binaryOutputFileWord(Word::create("BinaryOutputFile"));

EXPORT_PREFIX Agent * getNewAgent(Model * model,long instNum)
{
if(model->isA(::binaryInputFileWord))
        return(new BinaryInputFile(model,instNum));
if(model->isA(::textInputFileWord))
        return(new TextInputFile(model,instNum));
if(model->isA(::inputFileWord))
        return(new InputFile(model,instNum));
if(model->isA(::binaryOutputFileWord))
        return(new BinaryOutputFile(model,instNum));
if(model->isA(::textOutputFileWord))
        return(new TextOutputFile(model,instNum));
if(model->isA(::outputFileWord))
        return(new OutputFile(model,instNum));
return((Agent *)0); // not found
}

//--------------------------------------------------------------------------//
// InputFile functions                                                      //
//--------------------------------------------------------------------------//

// native void InputFile::close(void);
//
void InputFile::close(Context * context) // static
{
InputFile * file=(InputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_file=(FILE *)0;
}

// native string InputFile::fileName(void);
//
void InputFile::fileName(Context * context) // static
{
InputFile * file=(InputFile *)context->accessOwner();
context->returnStrings(file->_fileName);
}
 
// native bool InputFile::fail(void);
//
void InputFile::fail(Context * context) // static
{
InputFile * file=(InputFile *)context->accessOwner();
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}
 
// native bool InputFile::eof(void);
//
void InputFile::eof(Context * context) // static
{
InputFile * file=(InputFile *)context->accessOwner();
bool endReached=false;
if(!file->_file||feof(file->_file)) endReached=true;
else
  {
  int c=getc(file->_file);
  if(c==EOF) endReached=true;
  else ungetc(c,file->_file);
  }
context->returnInteger(endReached);
}

//--------------------------------------------------------------------------//
// TextInputFile functions                                                  //
//--------------------------------------------------------------------------//

// native bool TextInputFile::open(string fileName);
//
void TextInputFile::open(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_fileName=context->getStrings(0);
file->_file=fopen(file->_fileName,"r");
if(!file->_file)
  {
  const StringsVect & pathVect=getSimul()->getPathVect();
  for(unsigned int i=0;!file->_file&&i<pathVect.size();i++)
    {
    file->_fileName=pathVect[i]+context->getStrings(0);
    file->_file=fopen(file->_fileName,"r");
    }
  }
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}

// native void TextInputFile::eatBlanks(void);
//
void TextInputFile::eatBlanks(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
if(file->_file)
  {
  int c;
  while(!feof(file->_file))
    {
    c=getc(file->_file);
    if(c>' ')
      {
      ungetc(c,file->_file);
      break;
      }
    }
  }
}

// native string TextInputFile::getContent(void);
//
void TextInputFile::getContent(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
if(file->_file)
  {
  int pos=ftell(file->_file);
  if(pos<0) context->returnStrings(Strings());
  else
    {
    fseek(file->_file,0,SEEK_END);
    int len=ftell(file->_file)-pos;
    fseek(file->_file,pos,SEEK_SET);
    char * str=(char *)BlockAllocator::allocate(sizeof(char)*(len+1));
#ifndef __MSDOS__
    fread(str,sizeof(char),len,file->_file);
    str[len]='\0';
#else
    char * ptr=str;
    while(!feof(file->_file))
      fread(ptr++,sizeof(char),1,file->_file);
    *(ptr-1)='\0';
#endif
    context->returnStrings(Strings(str));
    BlockAllocator::free(str);
    }
  }
else context->returnStrings(Strings());
}

// native int TextInputFile::readInt(void);
//
void TextInputFile::readInt(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
long i=0;
if(!file->_file||(fscanf(file->_file,"%ld",&i)!=1)) i=0;
context->returnInteger(i);
}

// native float TextInputFile::readFloat(void);
//
void TextInputFile::readFloat(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
double d=0.0;
if(!file->_file||(fscanf(file->_file,"%lf",&d)!=1)) d=0.0;
context->returnReal(d);
}

// native string TextInputFile::readString(int stringLength);
//
void TextInputFile::readString(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
long len=context->getInteger(0);
if(file->_file&&(len>0))
  {
  char * str=(char *)BlockAllocator::allocate(sizeof(char)*(len+1));
  int nb=fread(str,sizeof(char),len,file->_file);
  str[nb]='\0';
  context->returnStrings(Strings(str));
  BlockAllocator::free(str);
  }
else context->returnStrings(Strings());
}

// native string TextInputFile::readLine(void);
//
void TextInputFile::readLine(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
Strings str;
if(file->_file)
  {
  int c;
  while(!feof(file->_file))
    {
    c=getc(file->_file);
    if((c=='\n')||(c==EOF)) break;
    else str+=c;
    }
  }
context->returnStrings(str);
}

// native string TextInputFile::readWord(void);
//
void TextInputFile::readWord(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
Strings str;
if(file->_file)
  {
  int c;
  while(!feof(file->_file))
    {
    c=getc(file->_file);
    if(c>' ')
      {
      ungetc(c,file->_file);
      break;
      }
    }
  while(!feof(file->_file))
    {
    c=getc(file->_file);
    if(c>' ') str+=c;
    else
      {
      ungetc(c,file->_file);
      break;
      }
    }
  }
context->returnStrings(str);
}

// native Object TextInputFile::readObject(void);
//
void TextInputFile::readObject(Context * context) // static
{
TextInputFile * file=(TextInputFile *)context->accessOwner();
Agent * agent=(Agent *)0;
if(file->_file)
  {
  int c;
  while(!feof(file->_file)) // eat bad characters
    {
    c=getc(file->_file);
    if((c=='_')||((c>='a')&&(c<='z'))||((c>='A')&&(c<='Z')))
      {
      ungetc(c,file->_file);
      break;
      }
    }
  char extractedModelName[0x80];
  char extractedInstNum[0x80];
  if(fscanf(file->_file,"%[_A-Za-z0-9].%[0-9]",
                        extractedModelName,extractedInstNum)==2)
    {
    Strings name=Strings(extractedModelName)+"."+Strings(extractedInstNum);
    agent=getSimul()->accessAgent(AgentName(name));
    }
  }
if(agent&&agent->isAlive())
  context->returnAgent(agent,agent->accessModel());
else
  context->returnAgent((Agent *)0,Model::getBaseModel());
}

//--------------------------------------------------------------------------//
// BinaryInputFile functions                                                //
//--------------------------------------------------------------------------//
 
// native bool BinaryInputFile::open(string fileName);
//
void BinaryInputFile::open(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_fileName=context->getStrings(0);
file->_file=fopen(file->_fileName,"rb");
if(!file->_file)
  {
  const StringsVect & pathVect=getSimul()->getPathVect();
  for(unsigned int i=0;!file->_file&&i<pathVect.size();i++)
    {
    file->_fileName=pathVect[i]+context->getStrings(0);
    file->_file=fopen(file->_fileName,"rb");
    }
  }
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}

// native int BinaryInputFile::readByte(void);
//
void BinaryInputFile::readByte(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
char c=0;
if(!file->_file||(fread(&c,sizeof(char),1,file->_file)!=1)) c=0;
context->returnInteger((long)c);
}

// native int BinaryInputFile::readInt16(void);
//
void BinaryInputFile::readInt16(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
short s=0;
if(!file->_file||(fread(&s,sizeof(short),1,file->_file)!=1)) s=0;
#if defined __i386__ || defined __MSDOS__
::invert16((unsigned char *)&s);
#endif
context->returnInteger((long)s);
}

// native int BinaryInputFile::readInt32(void);
//
void BinaryInputFile::readInt32(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
long l=0;
if(!file->_file||(fread(&l,sizeof(long),1,file->_file)!=1)) l=0;
#if defined __i386__ || defined __MSDOS__
::invert32((unsigned char *)&l);
#endif
context->returnInteger(l);
}

// native float BinaryInputFile::readFloat32(void);
//
void BinaryInputFile::readFloat32(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
float f=0.0;
if(!file->_file||(fread(&f,sizeof(float),1,file->_file)!=1)) f=0.0;
#if defined __i386__ || defined __MSDOS__
::invert32((unsigned char *)&f);
#endif
context->returnReal((double)f);
}

// native float BinaryInputFile::readFloat64(void);
//
void BinaryInputFile::readFloat64(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
double d=0.0;
if(!file->_file||(fread(&d,sizeof(double),1,file->_file)!=1)) d=0.0;
#if defined __i386__ || defined __MSDOS__
::invert64((unsigned char *)&d);
#endif
context->returnReal(d);
}

// native string BinaryInputFile::readString(int stringLength);
//
void BinaryInputFile::readString(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
long len=context->getInteger(0);
if(file->_file&&(len>0))
  {
  char * str=(char *)BlockAllocator::allocate(sizeof(char)*(len+1));
  int nb=fread(str,sizeof(char),len,file->_file);
  str[nb]='\0';
  context->returnStrings(Strings(str));
  BlockAllocator::free(str);
  }
else context->returnStrings(Strings());
}

// native int BinaryInputFile::readBlock(Memory mem,int offset,int length);
//
void BinaryInputFile::readBlock(Context * context) // static
{
BinaryInputFile * file=(BinaryInputFile *)context->accessOwner();
OMemory * memory=(OMemory *)context->getAgent(0);
int pos=context->getInteger(1);
int length=context->getInteger(2);
int nb=0;
if(file->_file&&memory&&memory->isAlive()&&
   (pos>=0)&&(length>=0)&&(pos+length<=(int)memory->getSize()))
  {
  nb=fread(memory->getBlock(),sizeof(char),length,file->_file);
  }
context->returnInteger(nb);
}

//--------------------------------------------------------------------------//
// OutputFile functions                                                     //
//--------------------------------------------------------------------------//

// native void OutputFile::close(void);
//
void OutputFile::close(Context * context) // static
{
OutputFile * file=(OutputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_file=(FILE *)0;
file->_append=false;
}
 
// native string OutputFile::fileName(void);
//
void OutputFile::fileName(Context * context) // static
{
OutputFile * file=(OutputFile *)context->accessOwner();
context->returnStrings(file->_fileName);
}

// native bool OutputFile::fail(void);
//
void OutputFile::fail(Context * context) // static
{
OutputFile * file=(OutputFile *)context->accessOwner();
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}

//--------------------------------------------------------------------------//
// TextOutputFile functions                                                 //
//--------------------------------------------------------------------------//

// native bool TextOutputFile::open(string fileName);
//
void TextOutputFile::open(Context * context) // static
{
TextOutputFile * file=(TextOutputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_fileName=context->getStrings(0);
file->_file=fopen(file->_fileName,"w");
file->_append=false;
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}

// native bool TextOutputFile::openAppend(string fileName);
//
void TextOutputFile::openAppend(Context * context) // static
{
TextOutputFile * file=(TextOutputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_fileName=context->getStrings(0);
file->_file=fopen(file->_fileName,"a");
file->_append=true;
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}

// native void TextOutputFile::writeInt(int intValue);
//
// native void TextOutputFile::writeFloat(float floatValue);
//
// native void TextOutputFile::writeString(string stringValue);
//
// native void TextOutputFile::writeObject(Object objectValue);
//
void TextOutputFile::writeValue(Context * context) // static
{
TextOutputFile * file=(TextOutputFile *)context->accessOwner();
if(file->_file)
  {
  fprintf(file->_file,"%s",(const char *)context->getLocal(0)->print());
  fflush(file->_file);
  }
}

//--------------------------------------------------------------------------//
// BinaryOutputFile functions                                               //
//--------------------------------------------------------------------------//

// native bool BinaryOutputFile::open(string fileName);
//
void BinaryOutputFile::open(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_fileName=context->getStrings(0);
file->_file=fopen(file->_fileName,"wb");
file->_append=false;
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}
 
// native bool BinaryOutputFile::openAppend(string fileName);
//
void BinaryOutputFile::openAppend(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file) fclose(file->_file);
file->_fileName=context->getStrings(0);
file->_file=fopen(file->_fileName,"ab");
file->_append=true;
context->returnInteger(!file->_file||ferror(file->_file) ? 1 : 0);
}

// native void BinaryOutputFile::writeByte(int byteValue);
//
void BinaryOutputFile::writeByte(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file)
  {
  char c=(char)context->getInteger(0);
  fwrite(&c,sizeof(char),1,file->_file);
  fflush(file->_file);
  }
}

// native void BinaryOutputFile::writeInt16(int int16Value);
//
void BinaryOutputFile::writeInt16(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file)
  {
  short s=(short)context->getInteger(0);
#if defined __i386__ || defined __MSDOS__
  ::invert16((unsigned char *)&s);
#endif
  fwrite(&s,sizeof(short),1,file->_file);
  fflush(file->_file);
  }
}

// native void BinaryOutputFile::writeInt32(int int32Value);
//
void BinaryOutputFile::writeInt32(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file)
  {
  long l=context->getInteger(0);
#if defined __i386__ || defined __MSDOS__
  ::invert32((unsigned char *)&l);
#endif
  fwrite(&l,sizeof(long),1,file->_file);
  fflush(file->_file);
  }
}

// native void BinaryOutputFile::writeFloat32(float float32Value);
//
void BinaryOutputFile::writeFloat32(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file)
  {
  float f=(float)context->getReal(0);
#if defined __i386__ || defined __MSDOS__
  ::invert32((unsigned char *)&f);
#endif
  fwrite(&f,sizeof(float),1,file->_file);
  fflush(file->_file);
  }
}

// native void BinaryOutputFile::writeFloat64(float float64Value);
//
void BinaryOutputFile::writeFloat64(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file)
  {
  double d=context->getReal(0);
#if defined __i386__ || defined __MSDOS__
  ::invert64((unsigned char *)&d);
#endif
  fwrite(&d,sizeof(double),1,file->_file);
  fflush(file->_file);
  }
}

// native void BinaryOutputFile::writeString(string stringValue);
//
void BinaryOutputFile::writeString(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
if(file->_file)
  {
  const char * str=(const char *)context->getStrings(0);
  fwrite(str,sizeof(char),context->getStrings(0).len(),file->_file);
  fflush(file->_file);
  }
}

// native void BinaryOutputFile::writeBlock(Memory mem,int offset,int length);
//
void BinaryOutputFile::writeBlock(Context * context) // static
{
BinaryOutputFile * file=(BinaryOutputFile *)context->accessOwner();
OMemory * memory=(OMemory *)context->getAgent(0);
int pos=context->getInteger(1);
int length=context->getInteger(2);
if(file->_file&&memory&&memory->isAlive()&&
   (pos>=0)&&(length>=0)&&(pos+length<=(int)memory->getSize()))
  {
  fwrite(memory->getBlock(),sizeof(char),length,file->_file);
  fflush(file->_file);
  }
}

//--------------------------------------------------------------------------//
// class InputFile                                                          //
//--------------------------------------------------------------------------//

InputFile::InputFile(Model * model,int instNum)
 : Agent(model,instNum),
   _fileName(), _file((FILE *)0)
{}

InputFile::~InputFile(void)
{
if(_file) fclose(_file);
}

Strings InputFile::userSave(int column) const // virtual
{
Strings str;
if(_file)
  {
  for(int i=0;i<column;i++) str+=" ";
  str+=getName().print()+"->open("+_fileName+");\n";
  }
return(str);
}

//--------------------------------------------------------------------------//
// class TextInputFile                                                      //
//--------------------------------------------------------------------------//
 
TextInputFile::TextInputFile(Model * model,int instNum)
 : InputFile(model,instNum)
{}
 
TextInputFile::~TextInputFile(void)
{}
 
//--------------------------------------------------------------------------//
// class BinaryInputFile                                                    //
//--------------------------------------------------------------------------//
 
BinaryInputFile::BinaryInputFile(Model * model,int instNum)
 : InputFile(model,instNum)
{}
 
BinaryInputFile::~BinaryInputFile(void)
{}
 
//--------------------------------------------------------------------------//
// class OutputFile                                                         //
//--------------------------------------------------------------------------//

OutputFile::OutputFile(Model * model,int instNum)
 : Agent(model,instNum),
   _fileName(), _file((FILE *)0),
   _append(false)
{}

OutputFile::~OutputFile(void)
{
if(_file) fclose(_file);
}

Strings OutputFile::userSave(int column) const // virtual
{
Strings str;
if(_file)
  {
  for(int i=0;i<column;i++) str+=" ";
  if(_append) str+=getName().print()+"->openAppend("+_fileName+");\n";
  else str+=getName().print()+"->open("+_fileName+");\n";
  }
return(str);
}

//--------------------------------------------------------------------------//
// class TextOutputFile                                                     //
//--------------------------------------------------------------------------//
 
TextOutputFile::TextOutputFile(Model * model,int instNum)
 : OutputFile(model,instNum)
{}
 
TextOutputFile::~TextOutputFile(void)
{}
 
//--------------------------------------------------------------------------//
// class BinaryOutputFile                                                   //
//--------------------------------------------------------------------------//
 
BinaryOutputFile::BinaryOutputFile(Model * model,int instNum)
 : OutputFile(model,instNum)
{}
 
BinaryOutputFile::~BinaryOutputFile(void)
{}

