// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : guiPkg.cpp                                                 //
// description : source file for the ENIB/LI2 oRis package gui.pkg          //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#if defined(X_GUI) || defined(W_GUI)

#include "Gui/guiPkg.h"
#include "Object2d/obj2dPkg.h"
#ifdef OPEN_GL
#include "Object3d/obj3dPkg.h"
#endif
#include "oRis/Main/simul.h"
#include "oRis/Main/errors.h"
#include "oRis/Main/context.h"
#include "oRis/Main/tmpVal.h"

#ifndef __MSDOS__
#define EXPORT_PREFIX extern "C"
#else
#include <windows.h>
#define EXPORT_PREFIX extern "C" __declspec(dllexport)
#define openingLibrary    openingGuiLibrary
#define closingLibrary    closingGuiLibrary
#define getExternFunction getExternGuiFunction
#define getNewAgent       getNewGuiAgent
#endif
 
//--------------------------------------------------------------------------//
// Opening and closing the library                                          //
//--------------------------------------------------------------------------//
 
EXPORT_PREFIX void openingLibrary(void)
{
  // nothing to do
}
 
EXPORT_PREFIX void closingLibrary(void)
{
  // nothing to do
}

//--------------------------------------------------------------------------//
// LookUp table for functions                                               //
//--------------------------------------------------------------------------//

EXPORT_PREFIX ExternFunction getExternFunction(const Strings & name)
{
if(name==Strings("::guiScreenWidth()"))
                                      return(::guiScreenWidth);
if(name==Strings("::guiScreenHeight()"))
                                      return(::guiScreenHeight);
if(name==Strings("::guiTextWidth()")) return(::guiTextWidth);
if(name==Strings("::guiTextHeight()"))
                                      return(::guiTextHeight);
if(name==Strings("::guiMargin()"))    return(::guiMargin);
if(name==Strings("::guiBell()"))      return(::guiBell);


if(name==Strings("GuiElem::_delete()"))
                                      return(OGuiElem::destruct);
if(name==Strings("GuiElem::getX()"))  return(OGuiElem::getX);
if(name==Strings("GuiElem::getY()"))  return(OGuiElem::getY);
if(name==Strings("GuiElem::getWidth()"))
                                      return(OGuiElem::getWidth);
if(name==Strings("GuiElem::getHeight()"))
                                      return(OGuiElem::getHeight);
if(name==Strings("GuiElem::getTitle()"))
                                      return(OGuiElem::getTitle);
if(name==Strings("GuiElem::setX()"))  return(OGuiElem::setX);
if(name==Strings("GuiElem::setY()"))  return(OGuiElem::setY);
if(name==Strings("GuiElem::setWidth()"))
                                      return(OGuiElem::setWidth);
if(name==Strings("GuiElem::setHeight()"))
                                      return(OGuiElem::setHeight);
if(name==Strings("GuiElem::setTitle()"))
                                      return(OGuiElem::setTitle);
if(name==Strings("GuiElem::dump()"))  return(OGuiElem::dump);


if(name==Strings("GuiArea::new()"))   return(OGuiArea::construct);
if(name==Strings("GuiArea::getWindowID()"))
                                      return(OGuiArea::getWindowID);
if(name==Strings("GuiArea::getInWidth()"))
                                      return(OGuiArea::getInWidth);
if(name==Strings("GuiArea::getInHeight()"))
                                      return(OGuiArea::getInHeight);
if(name==Strings("GuiArea::setInWidth()"))
                                      return(OGuiArea::setInWidth);
if(name==Strings("GuiArea::setInHeight()"))
                                      return(OGuiArea::setInHeight);


if(name==Strings("GuiScrolledArea::new()"))
                                      return(OGuiScrolledArea::construct);


if(name==Strings("GuiHScrolledArea::new()"))
                                      return(OGuiHScrolledArea::construct);


if(name==Strings("GuiVScrolledArea::new()"))
                                      return(OGuiVScrolledArea::construct);


if(name==Strings("GuiColorArea::new()"))
                                      return(OGuiColorArea::construct);
if(name==Strings("GuiColorArea::getColor()"))
                                      return(OGuiColorArea::getColor);
if(name==Strings("GuiColorArea::setColor()"))
                                      return(OGuiColorArea::setColor);


if(name==Strings("GuiWindow::new()")) return(OGuiWindow::construct);
if(name==Strings("GuiWindow::isVisible()"))
                                      return(OGuiWindow::isVisible);
if(name==Strings("GuiWindow::show()"))
                                      return(OGuiWindow::show);
if(name==Strings("GuiWindow::hide()"))
                                      return(OGuiWindow::hide);


if(name==Strings("GuiFrame::new()"))  return(OGuiFrame::construct);

if(name==Strings("GuiTabGroup::new()"))
                                      return(OGuiTabGroup::construct);
if(name==Strings("GuiTabGroup::getCurrentTab()"))
                                      return(OGuiTabGroup::getCurrentTab);
if(name==Strings("GuiTabGroup::getNbTabs()"))
                                      return(OGuiTabGroup::getNbTabs);
if(name==Strings("GuiTabGroup::getTab()"))
                                      return(OGuiTabGroup::getTab);
if(name==Strings("GuiTabGroup::setCurrentTab()"))
                                      return(OGuiTabGroup::setCurrentTab);

if(name==Strings("GuiTab::new()"))    return(OGuiTab::construct);


if(name==Strings("GuiMenu::new()"))   return(OGuiMenu::construct);


if(name==Strings("GuiMenuBar::new()"))
                                      return(OGuiMenuBar::construct);


if(name==Strings("GuiMenuItem::new()"))
                                      return(OGuiMenuItem::construct);


if(name==Strings("GuiMenuSepar::new()"))
                                      return(OGuiMenuSepar::construct);


if(name==Strings("GuiLabel::new()"))  return(OGuiLabel::construct);


if(name==Strings("GuiEditLabel::new()"))
                                      return(OGuiEditLabel::construct);


if(name==Strings("GuiButton::new()")) return(OGuiButton::construct);


if(name==Strings("GuiToggle::new()")) return(OGuiToggle::construct);
if(name==Strings("GuiToggle::isPressed()")) 
                                      return(OGuiToggle::isPressed);
if(name==Strings("GuiToggle::setPressed()"))
                                      return(OGuiToggle::setPressed);


if(name==Strings("GuiToggleGroup::new()"))
                                      return(OGuiToggleGroup::construct);
if(name==Strings("GuiToggleGroup::getResult()"))
                                      return(OGuiToggleGroup::getResult);
if(name==Strings("GuiToggleGroup::getNbEntries()"))
                                      return(OGuiToggleGroup::getNbEntries);
if(name==Strings("GuiToggleGroup::getEntry()"))
                                      return(OGuiToggleGroup::getEntry);
if(name==Strings("GuiToggleGroup::setActiveEntry()"))
                                      return(OGuiToggleGroup::setActiveEntry);


if(name==Strings("GuiOptionMenu::new()"))
                                      return(OGuiOptionMenu::construct);
if(name==Strings("GuiOptionMenu::getResult()"))
                                      return(OGuiOptionMenu::getResult);
if(name==Strings("GuiOptionMenu::getNbEntries()"))
                                      return(OGuiOptionMenu::getNbEntries);
if(name==Strings("GuiOptionMenu::getEntry()"))
                                      return(OGuiOptionMenu::getEntry);
if(name==Strings("GuiOptionMenu::setActiveEntry()"))
                                      return(OGuiOptionMenu::setActiveEntry);


if(name==Strings("GuiCursor::new()")) return(OGuiCursor::construct);
if(name==Strings("GuiCursor::getValue()"))
                                      return(OGuiCursor::getValue);
if(name==Strings("GuiCursor::setValue()"))
                                      return(OGuiCursor::setValue);


if(name==Strings("GuiScroller::new()"))
                                      return(OGuiScroller::construct);
if(name==Strings("GuiScroller::getValue()"))
                                      return(OGuiScroller::getValue);
if(name==Strings("GuiScroller::getRatio()"))
                                      return(OGuiScroller::getRatio);
if(name==Strings("GuiScroller::setValue()"))
                                      return(OGuiScroller::setValue);
if(name==Strings("GuiScroller::setRatio()"))
                                      return(OGuiScroller::setRatio);


if(name==Strings("GuiList::new()"))   return(OGuiList::construct);
if(name==Strings("GuiList::getResult()"))
                                      return(OGuiList::getResult);
if(name==Strings("GuiList::isEntered()"))
                                      return(OGuiList::isEntered);
if(name==Strings("GuiList::getNbEntries()"))
                                      return(OGuiList::getNbEntries);
if(name==Strings("GuiList::getEntry()"))
                                      return(OGuiList::getEntry);
if(name==Strings("GuiList::setEntries()"))
                                      return(OGuiList::setEntries);


if(name==Strings("GuiEditor::new()")) 
                                      return(OGuiEditor::construct);
if(name==Strings("GuiEditor::getContent()"))
                                      return(OGuiEditor::getContent);
if(name==Strings("GuiEditor::setContent()"))
                                      return(OGuiEditor::setContent);


#ifdef OPEN_GL
if(name==Strings("GuiViewer3d::new()"))
                               return(OGuiViewer3d::construct);
if(name==Strings("GuiViewer3d::isSelected()"))
                               return(OGuiViewer3d::isSelected);
if(name==Strings("GuiViewer3d::getSelection()"))
                               return(OGuiViewer3d::getSelection);
if(name==Strings("GuiViewer3d::select()"))
                               return(OGuiViewer3d::select);
if(name==Strings("GuiViewer3d::unselect()"))
                               return(OGuiViewer3d::unselect);
if(name==Strings("GuiViewer3d::getBackground()"))
                               return(OGuiViewer3d::getBackground);
if(name==Strings("GuiViewer3d::setBackground()"))
                               return(OGuiViewer3d::setBackground);
if(name==Strings("GuiViewer3d::getPosition()"))
                               return(OGuiViewer3d::getPosition);
if(name==Strings("GuiViewer3d::globalToLocalPosition()"))
                               return(OGuiViewer3d::globalToLocalPosition);
if(name==Strings("GuiViewer3d::localToGlobalPosition()"))
                               return(OGuiViewer3d::localToGlobalPosition);
if(name==Strings("GuiViewer3d::setPosition()"))
                               return(OGuiViewer3d::setPosition);
if(name==Strings("GuiViewer3d::translate()"))
                               return(OGuiViewer3d::translate);
if(name==Strings("GuiViewer3d::getOrientation()"))
                               return(OGuiViewer3d::getOrientation);
if(name==Strings("GuiViewer3d::globalToLocalOrientation()"))
                               return(OGuiViewer3d::globalToLocalOrientation);
if(name==Strings("GuiViewer3d::localToGlobalOrientation()"))
                               return(OGuiViewer3d::localToGlobalOrientation);
if(name==Strings("GuiViewer3d::cancelRotation()"))
                               return(OGuiViewer3d::cancelRotation);
if(name==Strings("GuiViewer3d::setOrientation()"))
                               return(OGuiViewer3d::setOrientation);
if(name==Strings("GuiViewer3d::getLocation()"))
                               return(OGuiViewer3d::getLocation);
if(name==Strings("GuiViewer3d::setLocation()"))
                               return(OGuiViewer3d::setLocation);
if(name==Strings("GuiViewer3d::roll()"))
                               return(OGuiViewer3d::roll);
if(name==Strings("GuiViewer3d::pitch()"))
                               return(OGuiViewer3d::pitch);
if(name==Strings("GuiViewer3d::yaw()"))
                               return(OGuiViewer3d::yaw);
#endif


if(name==Strings("GuiViewer2d::new()"))
                                      return(OGuiViewer2d::construct);
if(name==Strings("GuiViewer2d::isSelected()"))
                                      return(OGuiViewer2d::isSelected);
if(name==Strings("GuiViewer2d::getSelection()"))
                                      return(OGuiViewer2d::getSelection);
if(name==Strings("GuiViewer2d::select()"))
                                      return(OGuiViewer2d::select);
if(name==Strings("GuiViewer2d::unselect()"))
                                      return(OGuiViewer2d::unselect);
if(name==Strings("GuiViewer2d::getBackground()"))
                                      return(OGuiViewer2d::getBackground);
if(name==Strings("GuiViewer2d::setBackground()"))
                                      return(OGuiViewer2d::setBackground);
if(name==Strings("GuiViewer2d::getViewPoint()"))
                                      return(OGuiViewer2d::getViewPoint);
if(name==Strings("GuiViewer2d::setViewPoint()"))
                                      return(OGuiViewer2d::setViewPoint);
if(name==Strings("GuiViewer2d::autoScale()"))
                                      return(OGuiViewer2d::autoScale);


if(name==Strings("GuiGrapher::new()"))
                                      return(OGuiGrapher::construct);
if(name==Strings("GuiGrapher::getBackground()"))
                                      return(OGuiGrapher::getBackground);
if(name==Strings("GuiGrapher::setBackground()"))
                                      return(OGuiGrapher::setBackground);
if(name==Strings("GuiGrapher::getViewPoint()"))
                                      return(OGuiGrapher::getViewPoint);
if(name==Strings("GuiGrapher::setViewPoint()"))
                                      return(OGuiGrapher::setViewPoint);
if(name==Strings("GuiGrapher::autoScale()"))
                                      return(OGuiGrapher::autoScale);
if(name==Strings("GuiGrapher::autoScaleX()"))
                                      return(OGuiGrapher::autoScaleX);
if(name==Strings("GuiGrapher::autoScaleY()"))
                                      return(OGuiGrapher::autoScaleY);
if(name==Strings("GuiGrapher::addPoint()"))
                                      return(OGuiGrapher::addPoint);
if(name==Strings("GuiGrapher::accumulatePoint()"))
                                      return(OGuiGrapher::accumulatePoint);
if(name==Strings("GuiGrapher::clear()"))
                                      return(OGuiGrapher::clear);


if(name==Strings("GuiTextDialog::new()"))
                                      return(OGuiTextDialog::construct);
if(name==Strings("GuiTextDialog::isEntered()"))
                                      return(OGuiTextDialog::isEntered);
if(name==Strings("GuiTextDialog::isCanceled()"))
                                      return(OGuiTextDialog::isCanceled);
if(name==Strings("GuiTextDialog::getText()"))
                                      return(OGuiTextDialog::getText);
if(name==Strings("GuiTextDialog::setText()"))
                                      return(OGuiTextDialog::setText);
if(name==Strings("GuiTextDialog::modalAsk()"))
                                      return(OGuiTextDialog::modalAsk);


if(name==Strings("GuiButtonDialog::new()"))
                                      return(OGuiButtonDialog::construct);
if(name==Strings("GuiButtonDialog::getAnswer()"))
                                      return(OGuiButtonDialog::getAnswer);
if(name==Strings("GuiButtonDialog::getNbButtons()"))
                                      return(OGuiButtonDialog::getNbButtons);
if(name==Strings("GuiButtonDialog::getButton()"))
                                      return(OGuiButtonDialog::getButton);
if(name==Strings("GuiButtonDialog::modalAsk()"))
                                      return(OGuiButtonDialog::modalAsk);


if(name==Strings("GuiFileChooser::new()"))
                                      return(OGuiFileChooser::construct);
if(name==Strings("GuiFileChooser::isEntered()"))
                                      return(OGuiFileChooser::isEntered);
if(name==Strings("GuiFileChooser::isCanceled()"))
                                      return(OGuiFileChooser::isCanceled);
if(name==Strings("GuiFileChooser::getFileName()"))
                                      return(OGuiFileChooser::getFileName);
if(name==Strings("GuiFileChooser::getPath()"))
                                      return(OGuiFileChooser::getPath);
if(name==Strings("GuiFileChooser::setPath()"))
                                      return(OGuiFileChooser::setPath);
if(name==Strings("GuiFileChooser::modalAsk()"))
                                      return(OGuiFileChooser::modalAsk);


if(name==Strings("GuiColorChooser::new()"))
                                      return(OGuiColorChooser::construct);
if(name==Strings("GuiColorChooser::isEntered()"))
                                      return(OGuiColorChooser::isEntered);
if(name==Strings("GuiColorChooser::isCanceled()"))
                                      return(OGuiColorChooser::isCanceled);
if(name==Strings("GuiColorChooser::getColor()"))
                                      return(OGuiColorChooser::getColor);
if(name==Strings("GuiColorChooser::setColor()"))
                                      return(OGuiColorChooser::setColor);
if(name==Strings("GuiColorChooser::modalAsk()"))
                                      return(OGuiColorChooser::modalAsk);

return((ExternFunction)0); // not found
}

//--------------------------------------------------------------------------//
// LookUp table for agents                                                  //
//--------------------------------------------------------------------------//

static Word guiColorChooserWord(Word::create("GuiColorChooser"));
static Word guiFileChooserWord(Word::create("GuiFileChooser"));
static Word guiButtonDialogWord(Word::create("GuiButtonDialog"));
static Word guiTextDialogWord(Word::create("GuiTextDialog"));
static Word guiGrapherWord(Word::create("GuiGrapher"));
static Word guiViewer3dWord(Word::create("GuiViewer3d"));
static Word guiViewer2dWord(Word::create("GuiViewer2d"));
static Word guiEditorWord(Word::create("GuiEditor"));
static Word guiListWord(Word::create("GuiList"));
static Word guiScrollerWord(Word::create("GuiScroller"));
static Word guiCursorWord(Word::create("GuiCursor"));
static Word guiOptionMenuWord(Word::create("GuiOptionMenu"));
static Word guiToggleGroupWord(Word::create("GuiToggleGroup"));
static Word guiToggleWord(Word::create("GuiToggle"));
static Word guiButtonWord(Word::create("GuiButton"));
static Word guiEditLabelWord(Word::create("GuiEditLabel"));
static Word guiLabelWord(Word::create("GuiLabel"));
static Word guiMenuSeparWord(Word::create("GuiMenuSepar"));
static Word guiMenuItemWord(Word::create("GuiMenuItem"));
static Word guiMenuBarWord(Word::create("GuiMenuBar"));
static Word guiMenuWord(Word::create("GuiMenu"));
static Word guiFrameWord(Word::create("GuiFrame"));
static Word guiTabWord(Word::create("GuiTab"));
static Word guiTabGroupWord(Word::create("GuiTabGroup"));
static Word guiWindowWord(Word::create("GuiWindow"));
static Word guiColorAreaWord(Word::create("GuiColorArea"));
static Word guiVScrolledAreaWord(Word::create("GuiVScrolledArea"));
static Word guiHScrolledAreaWord(Word::create("GuiHScrolledArea"));
static Word guiScrolledAreaWord(Word::create("GuiScrolledArea"));
static Word guiAreaWord(Word::create("GuiArea"));
static Word guiElemWord(Word::create("GuiElem"));

EXPORT_PREFIX Agent * getNewAgent(Model * model,long instNum)
{
if(model->isA(::guiColorChooserWord))
        return(new OGuiColorChooser(model,instNum));
if(model->isA(::guiFileChooserWord))
        return(new OGuiFileChooser(model,instNum));
if(model->isA(::guiButtonDialogWord))
        return(new OGuiButtonDialog(model,instNum));
if(model->isA(::guiTextDialogWord))
        return(new OGuiTextDialog(model,instNum));
if(model->isA(::guiGrapherWord))
        return(new OGuiGrapher(model,instNum));
#ifdef OPEN_GL
if(model->isA(::guiViewer3dWord))
        return(new OGuiViewer3d(model,instNum));
#endif
if(model->isA(::guiViewer2dWord))
        return(new OGuiViewer2d(model,instNum));
if(model->isA(::guiEditorWord))
        return(new OGuiEditor(model,instNum));
if(model->isA(::guiListWord))
        return(new OGuiList(model,instNum));
if(model->isA(::guiScrollerWord))
        return(new OGuiScroller(model,instNum));
if(model->isA(::guiCursorWord))
        return(new OGuiCursor(model,instNum));
if(model->isA(::guiOptionMenuWord))
        return(new OGuiOptionMenu(model,instNum));
if(model->isA(::guiToggleGroupWord))
        return(new OGuiToggleGroup(model,instNum));
if(model->isA(::guiToggleWord))
        return(new OGuiToggle(model,instNum));
if(model->isA(::guiButtonWord))
        return(new OGuiButton(model,instNum));
if(model->isA(::guiEditLabelWord))
        return(new OGuiEditLabel(model,instNum));
if(model->isA(::guiLabelWord))
        return(new OGuiLabel(model,instNum));
if(model->isA(::guiMenuSeparWord))
        return(new OGuiMenuSepar(model,instNum));
if(model->isA(::guiMenuItemWord))
        return(new OGuiMenuItem(model,instNum));
if(model->isA(::guiMenuBarWord))
        return(new OGuiMenuBar(model,instNum));
if(model->isA(::guiMenuWord))
        return(new OGuiMenu(model,instNum));
if(model->isA(::guiFrameWord))
        return(new OGuiFrame(model,instNum));
if(model->isA(::guiTabWord))
        return(new OGuiTab(model,instNum));
if(model->isA(::guiTabGroupWord))
        return(new OGuiTabGroup(model,instNum));
if(model->isA(::guiWindowWord))
        return(new OGuiWindow(model,instNum));
if(model->isA(::guiColorAreaWord))
        return(new OGuiColorArea(model,instNum));
if(model->isA(::guiVScrolledAreaWord))
        return(new OGuiVScrolledArea(model,instNum));
if(model->isA(::guiHScrolledAreaWord))
        return(new OGuiHScrolledArea(model,instNum));
if(model->isA(::guiScrolledAreaWord))
        return(new OGuiScrolledArea(model,instNum));
if(model->isA(::guiAreaWord))
        return(new OGuiArea(model,instNum));
if(model->isA(::guiElemWord))
        return(new OGuiElem(model,instNum));
return((Agent *)0); // not found
}

//--------------------------------------------------------------------------//
// Gui functions                                                            //
//--------------------------------------------------------------------------//

// native int guiScreenWidth(void);
//
void guiScreenWidth(Context * context)
{
context->returnInteger(getGuiManager()->getScreenWidth());
}

// native int guiScreenHeight(void);
//
void guiScreenHeight(Context * context)
{
context->returnInteger(getGuiManager()->getScreenHeight());
}

// native int guiTextWidth(string text);
//
void guiTextWidth(Context * context)
{
context->returnInteger(getGuiManager()->getTextWidth(context->getStrings(0)));
}

// native int guiTextHeight(void);
//
void guiTextHeight(Context * context)
{
context->returnInteger(getGuiManager()->getCharHeight());
}

// native int guiMargin(void);
//
void guiMargin(Context * context)
{
context->returnInteger(getGuiManager()->getMargin());
}

// native void guiBell(void);
//
void guiBell(Context * /* context */)
{
getGuiManager()->bell();
}

//--------------------------------------------------------------------------//
// GuiElem functions                                                        //
//--------------------------------------------------------------------------//

// native void GuiElem::_delete(void);
//
void OGuiElem::destruct(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) delete elem->_elem;
Value * selfList=elem->accessAttribute(_childrenWord)->accessValue();
for(int i=selfList->getLen();i--;)
  {
  getSimul()->deleteAgent(selfList->accessBack()->getAgent());
  if(selfList->getLen()>i) selfList->popBack(); // not deleted !!
  }
Agent * parent=elem->accessAttribute(_parentWord)->accessValue()->getAgent();
if(parent)
  {
  Value * parentList=parent->accessAttribute(_childrenWord)->accessValue();
  TmpValue * self=TmpValue::getTmpValue(ValueType(elem->accessModel()));
  self->setAgent(elem);
  int pos=parentList->findElem(*self,false);
  self->relax();
  if(pos>=0) parentList->erase(pos);
  }
}

// native int GuiElem::getX(void);
//
void OGuiElem::getX(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) context->returnInteger(elem->_elem->getX());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiElem::getY(void);
//
void OGuiElem::getY(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) context->returnInteger(elem->_elem->getY());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiElem::getWidth(void);
//
void OGuiElem::getWidth(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) context->returnInteger(elem->_elem->getWidth());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiElem::getHeight(void);
//
void OGuiElem::getHeight(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) context->returnInteger(elem->_elem->getHeight());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiElem::getTitle(void);
//
void OGuiElem::getTitle(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) context->returnStrings(elem->_elem->getTitle());
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiElem::setX(int x);
//
void OGuiElem::setX(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) elem->_elem->setX(context->getInteger(0));
else
  {
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiElem::setY(int y);
//
void OGuiElem::setY(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) elem->_elem->setY(context->getInteger(0));
else
  {
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiElem::setWidth(int width);
//
void OGuiElem::setWidth(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) elem->_elem->setWidth(context->getInteger(0));
else
  {
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiElem::setHeight(int height);
//
void OGuiElem::setHeight(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) elem->_elem->setHeight(context->getInteger(0));
else
  {
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiElem::setTitle(string title);
//
void OGuiElem::setTitle(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem) elem->_elem->setTitle(context->getStrings(0));
else
  {
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiElem::dump(string fileName);
//
void OGuiElem::dump(Context * context) // static
{
OGuiElem * elem=(OGuiElem *)context->accessOwner();
if(elem->_elem)
  {
  context->returnInteger(elem->_elem->dump(context->getStrings(0)));
  }
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  elem->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiArea functions                                                        //
//--------------------------------------------------------------------------//

// native void GuiArea::new(GuiArea parent);
//
void OGuiArea::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiArea * area=(OGuiArea *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    area->_elem=new GuiArea((GuiArea *)parent->accessElem());
    area->_elem->setDestroyCallback(OGuiElem::destroyCB,area);
    area->_elem->setCallback(OGuiElem::orisCB,area);
    if(parent->getElem()->isVisible()) area->_elem->show();
    area->setParent(parent);
    }
  else
    {
    area->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  area->_elem=(GuiElement *)0;
  Strings message="'"+area->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiArea::getWindowID(void);
//
void OGuiArea::getWindowID(Context * context) // static
{
OGuiArea * area=(OGuiArea *)context->accessOwner();
if(area->_elem)
  context->returnInteger(((GuiArea *)area->_elem)->getWindowID());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiArea::getInWidth(void);
//
void OGuiArea::getInWidth(Context * context) // static
{
OGuiArea * area=(OGuiArea *)context->accessOwner();
if(area->_elem)
  context->returnInteger(((GuiArea *)area->_elem)->getInWidth());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiArea::getInHeight(void);
//
void OGuiArea::getInHeight(Context * context) // static
{
OGuiArea * area=(OGuiArea *)context->accessOwner();
if(area->_elem)
  context->returnInteger(((GuiArea *)area->_elem)->getInHeight());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiArea::setInWidth(int inWidth);
//
void OGuiArea::setInWidth(Context * context) // static
{
OGuiArea * area=(OGuiArea *)context->accessOwner();
if(area->_elem)
  ((GuiArea *)area->_elem)->setInWidth(context->getInteger(0));
else
  {
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiArea::setInHeight(int inWidth);
//
void OGuiArea::setInHeight(Context * context) // static
{
OGuiArea * area=(OGuiArea *)context->accessOwner();
if(area->_elem)
  ((GuiArea *)area->_elem)->setInHeight(context->getInteger(0));
else
  {
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiScrolledArea functions                                                //
//--------------------------------------------------------------------------//

// native void GuiScrolledArea::new(GuiArea parent);
//
void OGuiScrolledArea::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiScrolledArea * area=(OGuiScrolledArea *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    area->_elem=new GuiScrolledArea((GuiArea *)parent->accessElem());
    area->_elem->setDestroyCallback(OGuiElem::destroyCB,area);
    area->_elem->setCallback(OGuiElem::orisCB,area);
    if(parent->getElem()->isVisible()) area->_elem->show();
    area->setParent(parent);
    }
  else
    {
    area->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  area->_elem=(GuiElement *)0;
  Strings message="'"+area->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiHScrolledArea functions                                               //
//--------------------------------------------------------------------------//

// native void GuiHScrolledArea::new(GuiArea parent);
//
void OGuiHScrolledArea::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiHScrolledArea * area=(OGuiHScrolledArea *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    area->_elem=new GuiHScrolledArea((GuiArea *)parent->accessElem());
    area->_elem->setDestroyCallback(OGuiElem::destroyCB,area);
    area->_elem->setCallback(OGuiElem::orisCB,area);
    if(parent->getElem()->isVisible()) area->_elem->show();
    area->setParent(parent);
    }
  else
    {
    area->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  area->_elem=(GuiElement *)0;
  Strings message="'"+area->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiVScrolledArea functions                                               //
//--------------------------------------------------------------------------//

// native void GuiVScrolledArea::new(GuiArea parent);
//
void OGuiVScrolledArea::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiVScrolledArea * area=(OGuiVScrolledArea *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    area->_elem=new GuiVScrolledArea((GuiArea *)parent->accessElem());
    area->_elem->setDestroyCallback(OGuiElem::destroyCB,area);
    area->_elem->setCallback(OGuiElem::orisCB,area);
    if(parent->getElem()->isVisible()) area->_elem->show();
    area->setParent(parent);
    }
  else
    {
    area->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  area->_elem=(GuiElement *)0;
  Strings message="'"+area->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiColorArea functions                                                   //
//--------------------------------------------------------------------------//

// native void GuiColorArea::new(GuiArea parent,string color);
//
void OGuiColorArea::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiColorArea * area=(OGuiColorArea *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    area->_elem=new GuiColorArea((GuiArea *)parent->accessElem(),
                                 context->getStrings(1));
    area->_elem->setDestroyCallback(OGuiElem::destroyCB,area);
    area->_elem->setCallback(OGuiElem::orisCB,area);
    if(parent->getElem()->isVisible()) area->_elem->show();
    area->setParent(parent);
    }
  else
    {
    area->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  area->_elem=(GuiElement *)0;
  Strings message="'"+area->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}
 
// native string GuiColorArea::getColor(void);
//
void OGuiColorArea::getColor(Context * context) // static
{
OGuiColorArea * area=(OGuiColorArea *)context->accessOwner();
if(area->_elem)
  context->returnStrings(((GuiColorArea *)area->_elem)->getColor());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiColorArea::setColor(string color);
//
void OGuiColorArea::setColor(Context * context) // static
{
OGuiColorArea * area=(OGuiColorArea *)context->accessOwner();
if(area->_elem)
  ((GuiColorArea *)area->_elem)->setColor(context->getStrings(0));
else
  {
  Strings message="GUI part of '"+
                  area->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiWindow functions                                                      //
//--------------------------------------------------------------------------//

// native void GuiWindow::new(string title);
//
void OGuiWindow::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiWindow * window=(OGuiWindow *)context->accessOwner();
window->_elem=new GuiWindow(context->getStrings(0));
window->_elem->setDestroyCallback(OGuiElem::destroyCB,window);
window->_elem->setCallback(OGuiElem::orisCB,window);
((GuiWindow *)window->_elem)->setCloseCallback(OGuiWindow::orisCloseCB,
                                               window);
// shown by 'show()'
}

// native bool GuiWindow::isVisible(void);
//
void OGuiWindow::isVisible(Context * context) // static
{
OGuiWindow * window=(OGuiWindow *)context->accessOwner();
if(window->_elem)
  context->returnInteger(((GuiWindow *)window->_elem)->isVisible());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  window->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiWindow::show(void);
//
void OGuiWindow::show(Context * context) // static
{
OGuiWindow * window=(OGuiWindow *)context->accessOwner();
if(window->_elem) 
  { 
  if(!window->_elem->isVisible())
    window->_elem->show();
  }
else
  {
  Strings message="GUI part of '"+
                  window->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiWindow::hide(void);
//
void OGuiWindow::hide(Context * context) // static
{
OGuiWindow * window=(OGuiWindow *)context->accessOwner();
if(window->_elem)
  { 
  if(window->_elem->isVisible())
    window->_elem->hide();
  }
else
  {
  Strings message="GUI part of '"+
                  window->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiFrame functions                                                       //
//--------------------------------------------------------------------------//

// native void GuiFrame::new(GuiArea parent,string title);
//
void OGuiFrame::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiFrame * frame=(OGuiFrame *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    frame->_elem=new GuiFrame((GuiArea *)parent->accessElem(),
                              context->getStrings(1));
    frame->_elem->setDestroyCallback(OGuiElem::destroyCB,frame);
    frame->_elem->setCallback(OGuiElem::orisCB,frame);
    if(parent->getElem()->isVisible()) frame->_elem->show();
    frame->setParent(parent);
    }
  else
    {
    frame->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  frame->_elem=(GuiElement *)0;
  Strings message="'"+frame->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiTabGroup functions                                                    //
//--------------------------------------------------------------------------//

// native void GuiTabGroup::new(GuiArea parent);
//
void OGuiTabGroup::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiTabGroup * tabGroup=(OGuiTabGroup *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    tabGroup->_elem=new GuiTabGroup((GuiArea *)parent->accessElem());
    tabGroup->_elem->setDestroyCallback(OGuiElem::destroyCB,tabGroup);
    tabGroup->_elem->setCallback(OGuiElem::orisCB,tabGroup);
    if(parent->getElem()->isVisible()) tabGroup->_elem->show();
    tabGroup->setParent(parent);
    }
  else
    {
    tabGroup->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  tabGroup->_elem=(GuiElement *)0;
  Strings message="'"+tabGroup->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiTabGroup::getCurrentTab(void);
//
void OGuiTabGroup::getCurrentTab(Context * context) // static
{
OGuiTabGroup * tabGroup=(OGuiTabGroup *)context->accessOwner();
if(tabGroup->accessElem())
  context->returnInteger(((GuiTabGroup *)tabGroup->accessElem())
                                                 ->getCurrentTab());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  tabGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiTabGroup::getNbTabs(void);
//
void OGuiTabGroup::getNbTabs(Context * context) // static
{
OGuiTabGroup * tabGroup=(OGuiTabGroup *)context->accessOwner();
if(tabGroup->accessElem())
  context->returnInteger(((GuiTabGroup *)tabGroup->accessElem())
                                                 ->getNbTabs());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  tabGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiTabGroup::getTab(int pos);
//
void OGuiTabGroup::getTab(Context * context) // static
{
OGuiTabGroup * tabGroup=(OGuiTabGroup *)context->accessOwner();
if(tabGroup->accessElem())
  {
  int pos=context->getInteger(0);
  int nbTabs=((GuiTabGroup *)tabGroup->accessElem())->getNbTabs();
  if((pos>=0)&&(pos<nbTabs))
    context->returnStrings(((GuiTabGroup *)tabGroup->accessElem())
                                                   ->getTab(pos));
  else
    {
    context->returnStrings("");
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbTabs-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  tabGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiTabGroup::setCurrentTab(int pos,bool propagate);
//
void OGuiTabGroup::setCurrentTab(Context * context) // static
{
OGuiTabGroup * tabGroup=(OGuiTabGroup *)context->accessOwner();
if(tabGroup->accessElem())
  {
  int pos=context->getInteger(0);
  bool propagate=context->getInteger(1);
  int nbTabs=((GuiTabGroup *)tabGroup->accessElem())->getNbTabs();
  if((pos>=0)&&(pos<nbTabs))
    ((GuiTabGroup *)tabGroup->accessElem())->setCurrentTab(pos,propagate);
  else
    {
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbTabs-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  Strings message="GUI part of '"+
                  tabGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiTab functions                                                         //
//--------------------------------------------------------------------------//

// native void GuiTab::new(GuiTabGroup parent,string title);
//
void OGuiTab::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiTab * tab=(OGuiTab *)context->accessOwner();
OGuiTabGroup * parent=(OGuiTabGroup *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    tab->_elem=new GuiTab((GuiTabGroup *)parent->accessElem(),
                          context->getStrings(1));
    tab->_elem->setDestroyCallback(OGuiElem::destroyCB,tab);
    tab->_elem->setCallback(OGuiElem::orisCB,tab);
    // not shown here
    tab->setParent(parent);
    }
  else
    {
    tab->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  tab->_elem=(GuiElement *)0;
  Strings message="'"+tab->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiMenu functions                                                        //
//--------------------------------------------------------------------------//

// native void GuiMenu::new(GuiMenuItem parent,bool horizontal);
//
void OGuiMenu::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiMenu * menu=(OGuiMenu *)context->accessOwner();
OGuiMenuItem * parent=(OGuiMenuItem *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    menu->_elem=new GuiMenu((GuiMenuItem *)parent->accessElem(),
                            context->getInteger(1));
    menu->_elem->setDestroyCallback(OGuiElem::destroyCB,menu);
    menu->_elem->setCallback(OGuiElem::orisCB,menu);
    // not shown here
    menu->setParent(parent);
    }
  else
    {
    menu->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  menu->_elem=(GuiElement *)0;
  Strings message="'"+menu->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiMenuBar functions                                                     //
//--------------------------------------------------------------------------//

// native void GuiMenuBar::new(GuiArea parent,bool horizontal,bool pushLast);
//
void OGuiMenuBar::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiMenuBar * menu=(OGuiMenuBar *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    menu->_elem=new GuiMenuBar((GuiArea *)parent->accessElem(),
                               context->getInteger(1),
                               context->getInteger(2));
    menu->_elem->setDestroyCallback(OGuiElem::destroyCB,menu);
    menu->_elem->setCallback(OGuiElem::orisCB,menu);
    if(parent->getElem()->isVisible()) menu->_elem->show();
    menu->setParent(parent);
    }
  else
    {
    menu->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  menu->_elem=(GuiElement *)0;
  Strings message="'"+menu->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiMenuItem functions                                                    //
//--------------------------------------------------------------------------//

// native void GuiMenuItem::new(GuiMenu parent,string title);
//
void OGuiMenuItem::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiMenuItem * item=(OGuiMenuItem *)context->accessOwner();
OGuiMenu * parent=(OGuiMenu *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    item->_elem=new GuiMenuItem((GuiMenu *)parent->accessElem(),
                                context->getStrings(1));
    item->_elem->setDestroyCallback(OGuiElem::destroyCB,item);
    item->_elem->setCallback(OGuiElem::orisCB,item);
    if(parent->getElem()->isVisible()) item->_elem->show();
    item->setParent(parent);
    }
  else
    {
    item->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  item->_elem=(GuiElement *)0;
  Strings message="'"+item->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiMenuSepar functions                                                   //
//--------------------------------------------------------------------------//

// native void GuiMenuSepar::new(GuiMenu parent);
//
void OGuiMenuSepar::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiMenuSepar * separ=(OGuiMenuSepar *)context->accessOwner();
OGuiMenu * parent=(OGuiMenu *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    separ->_elem=new GuiMenuSepar((GuiMenu *)parent->accessElem());
    separ->_elem->setDestroyCallback(OGuiElem::destroyCB,separ);
    separ->_elem->setCallback(OGuiElem::orisCB,separ);
    if(parent->getElem()->isVisible()) separ->_elem->show();
    separ->setParent(parent);
    }
  else
    {
    separ->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    separ->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  separ->_elem=(GuiElement *)0;
  Strings message="'"+separ->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiLabel functions                                                       //
//--------------------------------------------------------------------------//

// native void GuiLabel::new(GuiArea parent,string title,bool deep);
//
void OGuiLabel::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiLabel * label=(OGuiLabel *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    label->_elem=new GuiLabel((GuiArea *)parent->accessElem(),
                              context->getStrings(1),
                              false, // not editable
                              context->getInteger(2));
    label->_elem->setDestroyCallback(OGuiElem::destroyCB,label);
    label->_elem->setCallback(OGuiElem::orisCB,label);
    if(parent->getElem()->isVisible()) label->_elem->show();
    label->setParent(parent);
    }
  else
    {
    label->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  label->_elem=(GuiElement *)0;
  Strings message="'"+label->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiEditLabel functions                                                   //
//--------------------------------------------------------------------------//

// native void GuiEditLabel::new(GuiArea parent,string title,bool deep);
//
void OGuiEditLabel::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiEditLabel * label=(OGuiEditLabel *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    label->_elem=new GuiLabel((GuiArea *)parent->accessElem(),
                              context->getStrings(1),
                              true, // editable
                              context->getInteger(2));
    label->_elem->setDestroyCallback(OGuiElem::destroyCB,label);
    label->_elem->setCallback(OGuiElem::orisCB,label);
    if(parent->getElem()->isVisible()) label->_elem->show();
    label->setParent(parent);
    }
  else
    {
    label->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  label->_elem=(GuiElement *)0;
  Strings message="'"+label->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiButton functions                                                      //
//--------------------------------------------------------------------------//

// native void GuiButton::new(GuiArea parent,string title);
//
void OGuiButton::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiButton * button=(OGuiButton *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    button->_elem=new GuiButton((GuiArea *)parent->accessElem(),
                                context->getStrings(1));
    button->_elem->setDestroyCallback(OGuiElem::destroyCB,button);
    button->_elem->setCallback(OGuiElem::orisCB,button);
    if(parent->getElem()->isVisible()) button->_elem->show();
    button->setParent(parent);
    }
  else
    {
    button->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  button->_elem=(GuiElement *)0;
  Strings message="'"+button->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiToggle functions                                                      //
//--------------------------------------------------------------------------//

// native void GuiToggle::new(GuiArea parent,string title,bool big);
//
void OGuiToggle::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiToggle * toggle=(OGuiToggle *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    toggle->_elem=new GuiToggle((GuiArea *)parent->accessElem(),
                                context->getStrings(1),
                                context->getInteger(2));
    toggle->_elem->setDestroyCallback(OGuiElem::destroyCB,toggle);
    toggle->_elem->setCallback(OGuiElem::orisCB,toggle);
    if(parent->getElem()->isVisible()) toggle->_elem->show();
    toggle->setParent(parent);
    }
  else
    {
    toggle->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  toggle->_elem=(GuiElement *)0;
  Strings message="'"+toggle->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiToggle::isPressed(void);
//
void OGuiToggle::isPressed(Context * context) // static
{
OGuiToggle * toggle=(OGuiToggle *)context->accessOwner();
if(toggle->accessElem())
  context->returnInteger(((GuiToggle *)toggle->accessElem())->isPressed());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  toggle->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiToggle::setPressed(bool pressed,bool propagate);
//
void OGuiToggle::setPressed(Context * context) // static
{
OGuiToggle * toggle=(OGuiToggle *)context->accessOwner();
if(toggle->accessElem())
  ((GuiToggle *)toggle->accessElem())->setPressed(context->getInteger(0),
                                                  context->getInteger(1));
else
  {
  Strings message="GUI part of '"+
                  toggle->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiToggleGroup functions                                                 //
//--------------------------------------------------------------------------//

// native void GuiToggleGroup::new(GuiArea parent,string[] entries,
//                                 bool horizontal,bool big);
//
void OGuiToggleGroup::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiToggleGroup * toggleGroup=(OGuiToggleGroup *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    StringsVect entries;
    const SubValueVect * vect=context->getValueVector(1);
    for(unsigned int i=0;i<vect->getSize();i++)
      entries.push_back((*vect)[i]->getStrings());
    toggleGroup->_elem=new GuiToggleGroup((GuiArea *)parent->accessElem(),
                                          entries,
                                          context->getInteger(2),
                                          context->getInteger(3));
    toggleGroup->_elem->setDestroyCallback(OGuiElem::destroyCB,toggleGroup);
    toggleGroup->_elem->setCallback(OGuiElem::orisCB,toggleGroup);
    if(parent->getElem()->isVisible()) toggleGroup->_elem->show();
    toggleGroup->setParent(parent);
    }
  else
    {
    toggleGroup->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  toggleGroup->_elem=(GuiElement *)0;
  Strings message="'"+toggleGroup->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiToggleGroup::getResult(void);
//
void OGuiToggleGroup::getResult(Context * context) // static
{
OGuiToggleGroup * toggleGroup=(OGuiToggleGroup *)context->accessOwner();
if(toggleGroup->accessElem())
  context->returnInteger(((GuiToggleGroup *)toggleGroup->accessElem())
                                                       ->getResult());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  toggleGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiToggleGroup::getNbEntries(void);
//
void OGuiToggleGroup::getNbEntries(Context * context) // static
{
OGuiToggleGroup * toggleGroup=(OGuiToggleGroup *)context->accessOwner();
if(toggleGroup->accessElem())
  context->returnInteger(((GuiToggleGroup *)toggleGroup->accessElem())
                                                       ->getNbEntries());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  toggleGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiToggleGroup::getEntry(int pos);
//
void OGuiToggleGroup::getEntry(Context * context) // static
{
OGuiToggleGroup * toggleGroup=(OGuiToggleGroup *)context->accessOwner();
if(toggleGroup->accessElem())
  {
  int pos=context->getInteger(0);
  int nbEntries=((GuiToggleGroup *)toggleGroup->accessElem())->getNbEntries();
  if((pos>=0)&&(pos<nbEntries))
    context->returnStrings(((GuiToggleGroup *)toggleGroup->accessElem())
                                                         ->getEntry(pos));
  else
    {
    context->returnStrings("");
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbEntries-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  toggleGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiToggleGroup::setActiveEntry(int pos,bool propagate);
//
void OGuiToggleGroup::setActiveEntry(Context * context) // static
{
OGuiToggleGroup * toggleGroup=(OGuiToggleGroup *)context->accessOwner();
if(toggleGroup->accessElem())
  {
  int pos=context->getInteger(0);
  int nbEntries=((GuiToggleGroup *)toggleGroup->accessElem())->getNbEntries();
  if((pos>=0)&&(pos<nbEntries))
    ((GuiToggleGroup *)toggleGroup->accessElem())
                       ->setActiveEntry(pos,context->getInteger(1));
  else
    {
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbEntries-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  Strings message="GUI part of '"+
                  toggleGroup->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiOptionMenu functions                                                  //
//--------------------------------------------------------------------------//

// native void GuiOptionMenu::new(GuiArea parent,string[] entries);
//
void OGuiOptionMenu::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiOptionMenu * option=(OGuiOptionMenu *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    StringsVect entries;
    const SubValueVect * vect=context->getValueVector(1);
    for(unsigned int i=0;i<vect->getSize();i++)
      entries.push_back((*vect)[i]->getStrings());
    option->_elem=new GuiOptionMenu((GuiArea *)parent->accessElem(),entries);
    option->_elem->setDestroyCallback(OGuiElem::destroyCB,option);
    option->_elem->setCallback(OGuiElem::orisCB,option);
    if(parent->getElem()->isVisible()) option->_elem->show();
    option->setParent(parent);
    }
  else
    {
    option->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  option->_elem=(GuiElement *)0;
  Strings message="'"+option->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiOptionMenu::getResult(void);
//
void OGuiOptionMenu::getResult(Context * context) // static
{
OGuiOptionMenu * option=(OGuiOptionMenu *)context->accessOwner();
if(option->accessElem())
  context->returnInteger(((GuiOptionMenu *)option->accessElem())
                                             ->getResult());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  option->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiOptionMenu::getNbEntries(void);
//
void OGuiOptionMenu::getNbEntries(Context * context) // static
{
OGuiOptionMenu * option=(OGuiOptionMenu *)context->accessOwner();
if(option->accessElem())
  context->returnInteger(((GuiOptionMenu *)option->accessElem())
                                             ->getNbEntries());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  option->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiOptionMenu::getEntry(int pos);
//
void OGuiOptionMenu::getEntry(Context * context) // static
{
OGuiOptionMenu * option=(OGuiOptionMenu *)context->accessOwner();
if(option->accessElem())
  {
  int pos=context->getInteger(0);
  int nbEntries=((GuiOptionMenu *)option->accessElem())->getNbEntries();
  if((pos>=0)&&(pos<nbEntries))
    context->returnStrings(((GuiOptionMenu *)option->accessElem())
                                               ->getEntry(pos));
  else
    {
    context->returnStrings("");
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbEntries-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  option->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiOptionMenu::setActiveEntry(int pos,bool propagate);
//
void OGuiOptionMenu::setActiveEntry(Context * context) // static
{
OGuiOptionMenu * option=(OGuiOptionMenu *)context->accessOwner();
if(option->accessElem())
  {
  int pos=context->getInteger(0);
  int nbEntries=((GuiOptionMenu *)option->accessElem())->getNbEntries();
  if((pos>=0)&&(pos<nbEntries))
    ((GuiOptionMenu *)option->accessElem())
                      ->setActiveEntry(pos,context->getInteger(1));
  else
    {
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbEntries-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  Strings message="GUI part of '"+
                  option->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiCursor functions                                                      //
//--------------------------------------------------------------------------//

// native void GuiCursor::new(GuiArea parent,bool horizontal);
//
void OGuiCursor::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiCursor * cursor=(OGuiCursor *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    cursor->_elem=new GuiCursor((GuiArea *)parent->accessElem(),
                                context->getInteger(1));
    cursor->_elem->setDestroyCallback(OGuiElem::destroyCB,cursor);
    cursor->_elem->setCallback(OGuiElem::orisCB,cursor);
    if(parent->getElem()->isVisible()) cursor->_elem->show();
    cursor->setParent(parent);
    }
  else
    {
    cursor->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  cursor->_elem=(GuiElement *)0;
  Strings message="'"+cursor->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native float GuiCursor::getValue(void);
//
void OGuiCursor::getValue(Context * context) // static
{
OGuiCursor * cursor=(OGuiCursor *)context->accessOwner();
if(cursor->accessElem())
  context->returnReal(((GuiCursor *)cursor->accessElem())->getValue());
else
  {
  context->returnReal(0.0);
  Strings message="GUI part of '"+
                  cursor->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiCursor::setValue(float value,bool propagate);
//
void OGuiCursor::setValue(Context * context) // static
{
OGuiCursor * cursor=(OGuiCursor *)context->accessOwner();
if(cursor->accessElem())
  ((GuiCursor *)cursor->accessElem())->setValue(context->getReal(0),
                                                context->getInteger(1));
else
  {
  Strings message="GUI part of '"+
                  cursor->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiScroller functions                                                    //
//--------------------------------------------------------------------------//

// native void GuiScroller::new(GuiArea parent,bool horizontal);
//
void OGuiScroller::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiScroller * scroller=(OGuiScroller *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    scroller->_elem=new GuiScroller((GuiArea *)parent->accessElem(),
                                    context->getInteger(1));
    scroller->_elem->setDestroyCallback(OGuiElem::destroyCB,scroller);
    scroller->_elem->setCallback(OGuiElem::orisCB,scroller);
    if(parent->getElem()->isVisible()) scroller->_elem->show();
    scroller->setParent(parent);
    }
  else
    {
    scroller->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  scroller->_elem=(GuiElement *)0;
  Strings message="'"+scroller->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native float GuiScroller::getValue(void);
//
void OGuiScroller::getValue(Context * context) // static
{
OGuiScroller * scroller=(OGuiScroller *)context->accessOwner();
if(scroller->accessElem())
  context->returnReal(((GuiScroller *)scroller->accessElem())->getValue());
else
  {
  context->returnReal(0.0);
  Strings message="GUI part of '"+
                  scroller->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native float GuiScroller::getRatio(void);
//
void OGuiScroller::getRatio(Context * context) // static
{
OGuiScroller * scroller=(OGuiScroller *)context->accessOwner();
if(scroller->accessElem())
  context->returnReal(((GuiScroller *)scroller->accessElem())->getRatio());
else
  {
  context->returnReal(0.0);
  Strings message="GUI part of '"+
                  scroller->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiScroller::setValue(float value,bool propagate);
//
void OGuiScroller::setValue(Context * context) // static
{
OGuiScroller * scroller=(OGuiScroller *)context->accessOwner();
if(scroller->accessElem())
  ((GuiScroller *)scroller->accessElem())->setValue(context->getReal(0),
                                                    context->getInteger(1));
else
  {
  Strings message="GUI part of '"+
                  scroller->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiScroller::setRatio(float ratio,bool propagate);
//
void OGuiScroller::setRatio(Context * context) // static
{
OGuiScroller * scroller=(OGuiScroller *)context->accessOwner();
if(scroller->accessElem())
  ((GuiScroller *)scroller->accessElem())->setRatio(context->getReal(0),
                                                    context->getInteger(1));
else
  {
  Strings message="GUI part of '"+
                  scroller->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiList functions                                                        //
//--------------------------------------------------------------------------//

// native void GuiList::new(GuiArea parent,string[] entries);
//
void OGuiList::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiList * guiList=(OGuiList *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    StringsVect entries;
    const SubValueVect * vect=context->getValueVector(1);
    for(unsigned int i=0;i<vect->getSize();i++)
      entries.push_back((*vect)[i]->getStrings());
    guiList->_elem=new GuiList((GuiArea *)parent->accessElem(),entries);
    guiList->_elem->setDestroyCallback(OGuiElem::destroyCB,guiList);
    guiList->_elem->setCallback(OGuiElem::orisCB,guiList);
    if(parent->getElem()->isVisible()) guiList->_elem->show();
    guiList->setParent(parent);
    }
  else
    {
    guiList->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  guiList->_elem=(GuiElement *)0;
  Strings message="'"+guiList->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiList::getResult(void);
//
void OGuiList::getResult(Context * context) // static
{
OGuiList * guiList=(OGuiList *)context->accessOwner();
if(guiList->accessElem())
  context->returnInteger(((GuiList *)guiList->accessElem())->getResult());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  guiList->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiList::isEntered(void);
//
void OGuiList::isEntered(Context * context) // static
{
OGuiList * guiList=(OGuiList *)context->accessOwner();
if(guiList->accessElem())
  context->returnInteger(((GuiList *)guiList->accessElem())->isEntered());
else
  {
  context->returnInteger(-1);
  Strings message="GUI part of '"+
                  guiList->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiList::getNbEntries(void);
//
void OGuiList::getNbEntries(Context * context) // static
{
OGuiList * guiList=(OGuiList *)context->accessOwner();
if(guiList->accessElem())
  context->returnInteger(((GuiList *)guiList->accessElem())->getNbEntries());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  guiList->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiList::getEntry(int pos);
//
void OGuiList::getEntry(Context * context) // static
{
OGuiList * guiList=(OGuiList *)context->accessOwner();
if(guiList->accessElem())
  {
  int pos=context->getInteger(0);
  int nbEntries=((GuiList *)guiList->accessElem())->getNbEntries();
  if((pos>=0)&&(pos<nbEntries))
    context->returnStrings(((GuiList *)guiList->accessElem())->getEntry(pos));
  else
    {
    context->returnStrings("");
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbEntries-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  guiList->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiList::setEntries(string[] entries);
//
void OGuiList::setEntries(Context * context) // static
{
OGuiList * guiList=(OGuiList *)context->accessOwner();
if(guiList->accessElem())
  {
  StringsVect entries;
  const SubValueVect * vect=context->getValueVector(0);
  for(unsigned int i=0;i<vect->getSize();i++)
    entries.push_back((*vect)[i]->getStrings());
  ((GuiList *)guiList->accessElem())->setEntries(entries);
  }
else
  {
  Strings message="GUI part of '"+
                  guiList->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiEditor functions                                                      //
//--------------------------------------------------------------------------//

// native void GuiEditor::new(GuiArea parent,string content,bool readOnly);
//
void OGuiEditor::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiEditor * editor=(OGuiEditor *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    editor->_elem=new GuiEditor((GuiArea *)parent->accessElem(),
                                context->getStrings(1),
                                context->getInteger(2));
    editor->_elem->setDestroyCallback(OGuiElem::destroyCB,editor);
    editor->_elem->setCallback(OGuiElem::orisCB,editor);
    if(parent->getElem()->isVisible()) editor->_elem->show();
    editor->setParent(parent);
    }
  else
    {
    editor->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  editor->_elem=(GuiElement *)0;
  Strings message="'"+editor->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiEditor::getContent(void);
//
void OGuiEditor::getContent(Context * context) // static
{
OGuiEditor * editor=(OGuiEditor *)context->accessOwner();
if(editor->accessElem())
  context->returnStrings(((GuiEditor *)editor->accessElem())->getContent());
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  editor->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiEditor::setContent(string content);
//
void OGuiEditor::setContent(Context * context) // static
{
OGuiEditor * editor=(OGuiEditor *)context->accessOwner();
if(editor->accessElem())
  ((GuiEditor *)editor->accessElem())->setContent(context->getStrings(0));
else
  {
  Strings message="GUI part of '"+
                  editor->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiViewer3d functions                                                    //
//--------------------------------------------------------------------------//

#ifdef OPEN_GL

// native void GuiViewer3d::new(GuiArea parent);
//
void OGuiViewer3d::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    GuiViewer3D * elem=new GuiViewer3D((GuiArea *)parent->accessElem());
    elem->setKeyCallback(OGuiViewer3d::orisKeyCB,viewer);
    viewer->_elem=elem;
    viewer->_elem->setDestroyCallback(OGuiElem::destroyCB,viewer);
    viewer->_elem->setCallback(OGuiElem::orisCB,viewer);
    if(parent->getElem()->isVisible()) viewer->_elem->show();
    viewer->setParent(parent);
    }
  else
    {
    viewer->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  viewer->_elem=(GuiElement *)0;
  Strings message="'"+viewer->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiViewer3d::isSelected(Object3d obj);
//
void OGuiViewer3d::isSelected(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  const Object3d * obj=(const Object3d *)context->getAgent(0);
  if(obj)
    context->returnInteger(((GuiViewer3D *)viewer->accessElem())
                           ->isSelected(obj->getShape()));
  else context->returnInteger(0);
  }
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::select(Object3d obj,bool propagate);
//
void OGuiViewer3d::select(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  Object3d * obj=(Object3d *)context->getAgent(0);
  if(obj&&obj->getShape())
    ((GuiViewer3D *)viewer->accessElem())->select(obj->accessShape(),
                                                  context->getInteger(1));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::unselect(Object3d obj,bool propagate);
//
void OGuiViewer3d::unselect(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  Object3d * obj=(Object3d *)context->getAgent(0);
  if(obj&&obj->getShape())
    ((GuiViewer3D *)viewer->accessElem())->unselect(obj->accessShape(),
                                                    context->getInteger(1));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native Object3d[] GuiViewer3d::getSelection(void);
//
void OGuiViewer3d::getSelection(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  Model * objModel=getSimul()->accessModel(_object3dWord);
  Value * result=TmpValue::getTmpValue(ValueType(objModel,1));
  SubValueVect * vect=SubValue::getSubValueVect();
  Object3d * obj;
  AgentMap::iterator it=objModel->accessAgentMap().begin();
  for(;it!=objModel->accessAgentMap().end();it++)
    {
    obj=(Object3d *)((*it).second);
    if(((const GuiViewer3D *)viewer->getElem())->isSelected(obj->getShape()))
      {
      vect->pushBack(SubValue::getSubValue(obj->accessModel(),result));
      vect->accessBack()->setAgent(obj);
      }
    }
  result->setValueVector(vect);
  context->returnValue(result);
  }
else
  {
  context->returnValue(TmpValue::getTmpValue(context
                       ->getModule()->getResultType()));
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiViewer3d::getBackground(void);
//
void OGuiViewer3d::getBackground(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  context->returnStrings(((GuiViewer3D *)viewer->accessElem())
                                                ->getBackground());
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::setBackground(string color);
//
void OGuiViewer3d::setBackground(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())
                         ->setBackground(context->getStrings(0));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::getPosition(float & x,float & y,float & z);
//
void OGuiViewer3d::getPosition(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double x,y,z;
  elem->getPosition(x,y,z);
  context->setReal(0,x);
  context->setReal(1,y);
  context->setReal(2,z);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::globalToLocalPosition(float & x,float & y,
//                                                float & z);
//
void OGuiViewer3d::globalToLocalPosition(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double x=context->getReal(0);
  double y=context->getReal(1);
  double z=context->getReal(2);
  elem->globalToLocalPosition(x,y,z);
  context->setReal(0,x);
  context->setReal(1,y);
  context->setReal(2,z);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::localToGlobalPosition(float & x,float & y,
//                                                float & z);
//
void OGuiViewer3d::localToGlobalPosition(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double x=context->getReal(0);
  double y=context->getReal(1);
  double z=context->getReal(2);
  elem->localToGlobalPosition(x,y,z);
  context->setReal(0,x);
  context->setReal(1,y);
  context->setReal(2,z);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::setPosition(float x,float y,float z);
//
void OGuiViewer3d::setPosition(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->setPosition(context->getReal(0),
                                                     context->getReal(1),
                                                     context->getReal(2));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::translate(float dx,float dy,float dz);
//
void OGuiViewer3d::translate(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->translate(context->getReal(0),
                                                   context->getReal(1),
                                                   context->getReal(2));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::getOrientation(float & roll,
//                                         float & pitch,float & yaw);
//
void OGuiViewer3d::getOrientation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double roll,pitch,yaw;
  elem->getOrientation(roll,pitch,yaw);
  context->setReal(0,roll);
  context->setReal(1,pitch);
  context->setReal(2,yaw);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::globalToLocalOrientation(float & roll,
//                                                   float & pitch,
//                                                   float & yaw);
//
void OGuiViewer3d::globalToLocalOrientation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double roll=context->getReal(0);
  double pitch=context->getReal(1);
  double yaw=context->getReal(2);
  elem->globalToLocalOrientation(roll,pitch,yaw);
  context->setReal(0,roll);
  context->setReal(1,pitch);
  context->setReal(2,yaw);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::localToGlobalOrientation(float & roll,
//                                                   float & pitch,
//                                                   float & yaw);
//
void OGuiViewer3d::localToGlobalOrientation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double roll=context->getReal(0);
  double pitch=context->getReal(1);
  double yaw=context->getReal(2);
  elem->localToGlobalOrientation(roll,pitch,yaw);
  context->setReal(0,roll);
  context->setReal(1,pitch);
  context->setReal(2,yaw);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::cancelRotation(void);
//
void OGuiViewer3d::cancelRotation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->cancelRotation();
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::setOrientation(float roll,float pitch,float yaw);
//
void OGuiViewer3d::setOrientation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->setOrientation(context->getReal(0),
                                                        context->getReal(1),
                                                        context->getReal(2));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::getLocation(float & x,float & y,float & z,
//                                      float & roll,float & pitch,
//                                      float & yaw);
//
void OGuiViewer3d::getLocation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer3D * elem=(GuiViewer3D *)viewer->accessElem();
  double x,y,z,roll,pitch,yaw;
  elem->getLocation(x,y,z,roll,pitch,yaw);
  context->setReal(0,x);
  context->setReal(1,y);
  context->setReal(2,z);
  context->setReal(3,roll);
  context->setReal(4,pitch);
  context->setReal(5,yaw);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::setLocation(float x,float y,float z,
//                                      float roll,float pitch,float yaw);
//
void OGuiViewer3d::setLocation(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->setLocation(context->getReal(0),
                                                     context->getReal(1),
                                                     context->getReal(2),
                                                     context->getReal(3),
                                                     context->getReal(4),
                                                     context->getReal(5));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::roll(float dRoll);
//
void OGuiViewer3d::roll(Context * context) // static
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->roll(context->getReal(0));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::pitch(float dPitch);
//
void OGuiViewer3d::pitch(Context * context) // static 
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->pitch(context->getReal(0));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer3d::yaw(float dYaw);
//
void OGuiViewer3d::yaw(Context * context) // static 
{
OGuiViewer3d * viewer=(OGuiViewer3d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer3D *)viewer->accessElem())->yaw(context->getReal(0));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

#endif // OPEN_GL

//--------------------------------------------------------------------------//
// GuiViewer2d functions                                                    //
//--------------------------------------------------------------------------//

// native void GuiViewer2d::new(GuiArea parent);
//
void OGuiViewer2d::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    GuiViewer2D * elem=new GuiViewer2D((GuiArea *)parent->accessElem());
    elem->setKeyCallback(OGuiViewer2d::orisKeyCB,viewer);
    viewer->_elem=elem;
    viewer->_elem->setDestroyCallback(OGuiElem::destroyCB,viewer);
    viewer->_elem->setCallback(OGuiElem::orisCB,viewer);
    if(parent->getElem()->isVisible()) viewer->_elem->show();
    viewer->setParent(parent);
    }
  else
    {
    viewer->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  viewer->_elem=(GuiElement *)0;
  Strings message="'"+viewer->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiViewer2d::isSelected(Object2d obj);
//
void OGuiViewer2d::isSelected(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  const Object2d * obj=(const Object2d *)context->getAgent(0);
  if(obj)
    context->returnInteger(((GuiViewer2D *)viewer->accessElem())
                           ->isSelected(obj->getShape()));
  else context->returnInteger(0);
  }
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native Object2d[] GuiViewer2d::getSelection(void);
//
void OGuiViewer2d::getSelection(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  Model * objModel=getSimul()->accessModel(_object2dWord);
  Value * result=TmpValue::getTmpValue(ValueType(objModel,1));
  SubValueVect * vect=SubValue::getSubValueVect();
  Object2d * obj;
  AgentMap::iterator it=objModel->accessAgentMap().begin();
  for(;it!=objModel->accessAgentMap().end();it++)
    {
    obj=(Object2d *)((*it).second);
    if(((const GuiViewer2D *)viewer->getElem())->isSelected(obj->getShape()))
      {
      vect->pushBack(SubValue::getSubValue(obj->accessModel(),result));
      vect->accessBack()->setAgent(obj);
      }
    }
  result->setValueVector(vect);
  context->returnValue(result);
  }
else
  {
  context->returnValue(TmpValue::getTmpValue(context
                       ->getModule()->getResultType()));
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer2d::select(Object2d obj,bool propagate);
//
void OGuiViewer2d::select(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  Object2d * obj=(Object2d *)context->getAgent(0);
  if(obj&&obj->getShape())
    ((GuiViewer2D *)viewer->accessElem())->select(obj->accessShape(),
                                                  context->getInteger(1));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer2d::unselect(Object2d obj,bool propagate);
//
void OGuiViewer2d::unselect(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  Object2d * obj=(Object2d *)context->getAgent(0);
  if(obj&&obj->getShape())
    ((GuiViewer2D *)viewer->accessElem())->unselect(obj->accessShape(),
                                                    context->getInteger(1));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiViewer2d::getBackground(void);
//
void OGuiViewer2d::getBackground(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  context->returnStrings(((GuiViewer2D *)viewer->accessElem())
                                                ->getBackground());
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer2d::setBackground(string color);
//
void OGuiViewer2d::setBackground(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer2D *)viewer->accessElem())
                         ->setBackground(context->getStrings(0));
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer2d::getViewPoint(float & x,float & y,float & scale);
//
void OGuiViewer2d::getViewPoint(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  GuiViewer2D * elem=(GuiViewer2D *)viewer->accessElem();
  double x,y,scale;
  elem->getViewPoint(x,y,scale);
  context->setReal(0,x);
  context->setReal(1,y);
  context->setReal(2,scale);
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer2d::setViewPoint(float x,float y,float scale);
//
void OGuiViewer2d::setViewPoint(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  if(context->getReal(2)>0.0)
    {
    ((GuiViewer2D *)viewer->accessElem())->setViewPoint(context->getReal(0),
                                                        context->getReal(1),
                                                        context->getReal(2));
    }
  else
    {
    Strings message="Parameter 'scale' must be greater than zero";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiViewer2d::autoScale(void);
//
void OGuiViewer2d::autoScale(Context * context) // static
{
OGuiViewer2d * viewer=(OGuiViewer2d *)context->accessOwner();
if(viewer->accessElem())
  {
  ((GuiViewer2D *)viewer->accessElem())->autoScale();
  }
else
  {
  Strings message="GUI part of '"+
                  viewer->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiGrapher functions                                                     //
//--------------------------------------------------------------------------//

// native void GuiGrapher::new(GuiArea parent);
//
void OGuiGrapher::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
OGuiArea * parent=(OGuiArea *)context->getAgent(0);
if(parent&&parent->isAlive())
  {
  if(parent->accessElem())
    {
    grapher->_elem=new GuiGrapher((GuiArea *)parent->accessElem());
    grapher->_elem->setDestroyCallback(OGuiElem::destroyCB,grapher);
    grapher->_elem->setCallback(OGuiElem::orisCB,grapher);
    if(parent->getElem()->isVisible()) grapher->_elem->show();
    grapher->setParent(parent);
    }
  else
    {
    grapher->_elem=(GuiElement *)0;
    Strings message="GUI part of '"+
                    parent->getName().print()+
                    "' does not exist";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  grapher->_elem=(GuiElement *)0;
  Strings message="'"+grapher->getName().print()+
                  "' must have a parent";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiGrapher::getBackground(void);
//
void OGuiGrapher::getBackground(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  context->returnStrings(((GuiGrapher *)grapher->accessElem())
                                                ->getBackground());
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::setBackground(string color);
//
void OGuiGrapher::setBackground(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())
                         ->setBackground(context->getStrings(0));
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::getViewPoint(float & xmin,float & ymin,
//                                      float & xmax,float & ymax);
//
void OGuiGrapher::getViewPoint(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  GuiGrapher * elem=(GuiGrapher *)grapher->accessElem();
  context->setReal(0,elem->getXmin());
  context->setReal(1,elem->getYmin());
  context->setReal(2,elem->getXmax());
  context->setReal(3,elem->getYmax());
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::setViewPoint(float xmin,float ymin,
//                                      float xmax,float ymax);
//
void OGuiGrapher::setViewPoint(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  if(context->getReal(0)<context->getReal(2))
    {
    if(context->getReal(1)<context->getReal(3))
      {
      ((GuiGrapher *)grapher->accessElem())
                             ->setViewPoint(context->getReal(0),
                                            context->getReal(1),
                                            context->getReal(2),
                                            context->getReal(3));
      }
    else
      {
      Strings message="Parameter 'ymax' must be greater than parameter 'ymin'";
      getSimul()->manageError(new Error(Error::RUNTIME,message));
      }
    }
  else
    {
    Strings message="Parameter 'xmax' must be greater than parameter 'xmin'";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::autoScale(void);
//
void OGuiGrapher::autoScale(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())->autoScale();
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::autoScaleX(void);
//
void OGuiGrapher::autoScaleX(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())->autoScaleX();
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::autoScaleY(void);
//
void OGuiGrapher::autoScaleY(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())->autoScaleY();
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::addPoint(string color,float x,float y);
//
void OGuiGrapher::addPoint(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())
                         ->addPoint(context->getStrings(0),
                                    context->getReal(1),
                                    context->getReal(2));
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::accumulatePoint(string color,float x,float y);
//
void OGuiGrapher::accumulatePoint(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())
                         ->accumulatePoint(context->getStrings(0),
                                           context->getReal(1),
                                           context->getReal(2));
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiGrapher::clear(string color);
//
void OGuiGrapher::clear(Context * context) // static
{
OGuiGrapher * grapher=(OGuiGrapher *)context->accessOwner();
if(grapher->accessElem())
  {
  ((GuiGrapher *)grapher->accessElem())->clear(context->getStrings(0));
  }
else
  {
  Strings message="GUI part of '"+
                  grapher->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiTextDialog functions                                                  //
//--------------------------------------------------------------------------//

// native void GuiTextDialog::new(string title,string[] message);
//
void OGuiTextDialog::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiTextDialog * dialog=(OGuiTextDialog *)context->accessOwner();
StringsVect msg;
const SubValueVect * vect=context->getValueVector(1);
for(unsigned int i=0;i<vect->getSize();i++)
  msg.push_back((*vect)[i]->getStrings());
dialog->_elem=new GuiTextDialog(context->getStrings(0),msg);
dialog->_elem->setDestroyCallback(OGuiElem::destroyCB,dialog);
// no callback
// shown by 'show()'
}

// native bool GuiTextDialog::isEntered(void);
//
void OGuiTextDialog::isEntered(Context * context) // static
{
OGuiTextDialog * dialog=(OGuiTextDialog *)context->accessOwner();
if(dialog->accessElem())
  context->returnInteger(((GuiTextDialog *)dialog->accessElem())
                                                  ->isEntered());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiTextDialog::isCanceled(void);
//
void OGuiTextDialog::isCanceled(Context * context) // static
{
OGuiTextDialog * dialog=(OGuiTextDialog *)context->accessOwner();
if(dialog->accessElem())
  context->returnInteger(((GuiTextDialog *)dialog->accessElem())
                                                  ->isCanceled());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiTextDialog::getText(void);
//
void OGuiTextDialog::getText(Context * context) // static
{
OGuiTextDialog * dialog=(OGuiTextDialog *)context->accessOwner();
if(dialog->accessElem())
  context->returnStrings(((GuiTextDialog *)dialog->accessElem())
                                                  ->getText());
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiTextDialog::setText(string text);
//
void OGuiTextDialog::setText(Context * context) // static
{
OGuiTextDialog * dialog=(OGuiTextDialog *)context->accessOwner();
if(dialog->accessElem())
  ((GuiTextDialog *)dialog->accessElem())
                           ->setInitText(context->getStrings(0));
else
  {
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiTextDialog::modalAsk(string & answer);
//
void OGuiTextDialog::modalAsk(Context * context) // static
{
OGuiTextDialog * dialog=(OGuiTextDialog *)context->accessOwner();
if(dialog->accessElem())
  {
  if(dialog->accessElem()->isVisible())
    {
    Strings answer;
    context->returnInteger(((GuiTextDialog *)dialog->accessElem())
                                                    ->ask(answer));
    context->setStrings(0,answer);
    }
  else
    {
    context->returnInteger(0);
    Strings message="GUI part of '"+
                    dialog->getName().print()+
                    "' is not visible";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiButtonDialog functions                                                //
//--------------------------------------------------------------------------//

// native void OGuiButtonDialog::new(string title,string[] message,
//                                   string[] buttons);
//
void OGuiButtonDialog::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiButtonDialog * dialog=(OGuiButtonDialog *)context->accessOwner();
unsigned int i;
StringsVect msg;
const SubValueVect * vect=context->getValueVector(1);
for(i=0;i<vect->getSize();i++)
  msg.push_back((*vect)[i]->getStrings());
StringsVect btns;
vect=context->getValueVector(2);
for(i=0;i<vect->getSize();i++)
  btns.push_back((*vect)[i]->getStrings());
dialog->_elem=new GuiButtonDialog(context->getStrings(0),msg,btns);
dialog->_elem->setDestroyCallback(OGuiElem::destroyCB,dialog);
// no callback
// shown by 'show()'
}

// native int GuiButtonDialog::getAnswer(void);
//
void OGuiButtonDialog::getAnswer(Context * context) // static
{
OGuiButtonDialog * dialog=(OGuiButtonDialog *)context->accessOwner();
if(dialog->accessElem())
  context->returnInteger(((GuiButtonDialog *)dialog->accessElem())
                                                    ->getAnswer());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiButtonDialog::getNbButtons(void);
//
void OGuiButtonDialog::getNbButtons(Context * context) // static
{
OGuiButtonDialog * dialog=(OGuiButtonDialog *)context->accessOwner();
if(dialog->accessElem())
  context->returnInteger(((GuiButtonDialog *)dialog->accessElem())
                                                    ->getNbButtons());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiButtonDialog::getButton(int pos);
//
void OGuiButtonDialog::getButton(Context * context) // static
{
OGuiButtonDialog * dialog=(OGuiButtonDialog *)context->accessOwner();
if(dialog->accessElem())
  {
  int pos=context->getInteger(0);
  int nbButtons=((GuiButtonDialog *)dialog->accessElem())->getNbButtons();
  if((pos>=0)&&(pos<nbButtons))
    context->returnStrings(((GuiButtonDialog *)dialog->accessElem())
                                                      ->getButton(pos));
  else
    {
    context->returnStrings("");
    Strings message="Can use '"+
                    context->getModule()->getCompleteName()+
                    "' only from "+Strings(0)+
                    " to "+Strings(nbButtons-1)+
                    " (called with "+Strings(pos)+")";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native int GuiButtonDialog::modalAsk(void);
//
void OGuiButtonDialog::modalAsk(Context * context) // static
{
OGuiButtonDialog * dialog=(OGuiButtonDialog *)context->accessOwner();
if(dialog->accessElem())
  {
  if(dialog->accessElem()->isVisible())
    {
    context->returnInteger(((GuiButtonDialog *)dialog->accessElem())->ask());
    }
  else
    {
    context->returnInteger(0);
    Strings message="GUI part of '"+
                    dialog->getName().print()+
                    "' is not visible";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  dialog->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiFileChooser functions                                                 //
//--------------------------------------------------------------------------//

// native void GuiFileChooser::new(string title,string message);
//
void OGuiFileChooser::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
chooser->_elem=new GuiFileChooser(context->getStrings(0),
                                  context->getStrings(1));
chooser->_elem->setDestroyCallback(OGuiElem::destroyCB,chooser);
// no callback
// shown by 'show()'
}

// native bool GuiFileChooser::isEntered(void);
//
void OGuiFileChooser::isEntered(Context * context) // static
{
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnInteger(((GuiFileChooser *)chooser->accessElem())
                                                   ->isEntered());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiFileChooser::isCanceled(void);
//
void OGuiFileChooser::isCanceled(Context * context) // static
{
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnInteger(((GuiFileChooser *)chooser->accessElem())
                                                   ->isCanceled());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiFileChooser::getFileName(void);
//
void OGuiFileChooser::getFileName(Context * context) // static
{
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnStrings(((GuiFileChooser *)chooser->accessElem())
                                                   ->getFileName());
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiFileChooser::getPath(void);
//
void OGuiFileChooser::getPath(Context * context) // static
{
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnStrings(((GuiFileChooser *)chooser->accessElem())
                                                   ->getPath());
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiFileChooser::setPath(string path);
//
void OGuiFileChooser::setPath(Context * context) // static
{
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
if(chooser->accessElem())
  ((GuiFileChooser *)chooser->accessElem())
                            ->setInitPath(context->getStrings(0));
else
  {
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiFileChooser::modalAsk(string & answer);
//
void OGuiFileChooser::modalAsk(Context * context) // static
{
OGuiFileChooser * chooser=(OGuiFileChooser *)context->accessOwner();
if(chooser->accessElem())
  {
  if(chooser->accessElem()->isVisible())
    {
    Strings answer;
    context->returnInteger(((GuiFileChooser *)chooser->accessElem())
                                                     ->ask(answer));
    context->setStrings(0,answer);
    }
  else
    {
    context->returnStrings("");
    Strings message="GUI part of '"+
                    chooser->getName().print()+
                    "' is not visible";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// GuiColorChooser functions                                                //
//--------------------------------------------------------------------------//

// native void GuiColorChooser::new(string title,string message);
//
void OGuiColorChooser::construct(Context * context) // static
{
OGuiElem::callOrisConstructor(context);
OGuiColorChooser * chooser=(OGuiColorChooser *)context->accessOwner();
chooser->_elem=new GuiColorChooser(context->getStrings(0),
                                   context->getStrings(1));
chooser->_elem->setDestroyCallback(OGuiElem::destroyCB,chooser);
// no callback
// shown by 'show()'
}

// native bool GuiColorChooser::isEntered(void);
//
void OGuiColorChooser::isEntered(Context * context) // static
{
OGuiColorChooser * chooser=(OGuiColorChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnInteger(((GuiColorChooser *)chooser->accessElem())
                                                    ->isEntered());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiColorChooser::isCanceled(void);
//
void OGuiColorChooser::isCanceled(Context * context) // static
{
OGuiColorChooser * chooser=(OGuiColorChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnInteger(((GuiColorChooser *)chooser->accessElem())
                                                    ->isCanceled());
else
  {
  context->returnInteger(0);
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native string GuiColorChooser::getColor(void);
//
void OGuiColorChooser::getColor(Context * context) // static
{
OGuiColorChooser * chooser=(OGuiColorChooser *)context->accessOwner();
if(chooser->accessElem())
  context->returnStrings(((GuiColorChooser *)chooser->accessElem())
                                                    ->getColor());
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native void GuiColorChooser::setColor(string color);
//
void OGuiColorChooser::setColor(Context * context) // static
{
OGuiColorChooser * chooser=(OGuiColorChooser *)context->accessOwner();
if(chooser->accessElem())
  ((GuiColorChooser *)chooser->accessElem())
                             ->setInitColor(context->getStrings(0));
else
  {
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

// native bool GuiColorChooser::modalAsk(string & answer);
//
void OGuiColorChooser::modalAsk(Context * context) // static
{
OGuiColorChooser * chooser=(OGuiColorChooser *)context->accessOwner();
if(chooser->accessElem())
  {
  if(chooser->accessElem()->isVisible())
    {
    Strings answer;
    context->returnInteger(((GuiColorChooser *)chooser->accessElem())
                                                      ->ask(answer));
    context->setStrings(0,answer);
    }
  else
    {
    context->returnStrings("");
    Strings message="GUI part of '"+
                    chooser->getName().print()+
                    "' is not visible";
    getSimul()->manageError(new Error(Error::RUNTIME,message));
    }
  }
else
  {
  context->returnStrings("");
  Strings message="GUI part of '"+
                  chooser->getName().print()+
                  "' does not exist";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

//--------------------------------------------------------------------------//
// class OGuiElem                                                           //
//--------------------------------------------------------------------------//

Word OGuiElem::_childrenWord(Word::create("_children"));          // static
Word OGuiElem::_parentWord(Word::create("_parent"));              // static
Word OGuiElem::_object3dWord(Word::create("Object3d"));           // static
Word OGuiElem::_object2dWord(Word::create("Object2d"));           // static
Word OGuiElem::_callbackWord(Word::create("callback"));           // static
Word OGuiElem::_closeCallbackWord(Word::create("closeCallback")); // static
Word OGuiElem::_keyPressWord(Word::create("keyPress"));           // static

OGuiElem::OGuiElem(Model * model,int instNum)
 : Agent(model,instNum), _elem((GuiElement *)0)
{}

OGuiElem::~OGuiElem(void)
{
if(_elem) delete _elem;
}

Strings OGuiElem::userSave(int) const // virtual
{
Strings str;
return(str);
}

void OGuiElem::setParent(OGuiElem * parent)
{
Value * value=accessAttribute(_parentWord)->accessValue();
value->setType(ValueType(parent->accessModel()));
value->setAgent(parent);
value=parent->accessAttribute(_childrenWord)->accessValue();
value->pushBack(Value(ValueType(accessModel())));
value->accessBack()->setAgent(this);
}

void OGuiElem::callOrisConstructor(Context * context) // static
{
Model * guiElemClass=getSimul()->accessModel(::guiElemWord);
context->accessExecution()->enterContext(guiElemClass->accessNewModule(),
                                         context->accessOwner());
}

void OGuiElem::destroyCB(GuiElement *,void * data) // static
{
OGuiElem * elem=(OGuiElem *)data;
elem->_elem=(GuiElement *)0;
}

void OGuiElem::orisCB(GuiElement *,void * data) // static
{
OGuiElem * elem=(OGuiElem *)data;
ExecModule * module=elem->accessModule(_callbackWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  getSimul()->executeModule(module,elem);
  }
}

//--------------------------------------------------------------------------//
// class OGuiArea                                                           //
//--------------------------------------------------------------------------//

OGuiArea::OGuiArea(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiArea::~OGuiArea(void)
{}

Strings OGuiArea::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiScrolledArea                                                   //
//--------------------------------------------------------------------------//

OGuiScrolledArea::OGuiScrolledArea(Model * model,int instNum)
 : OGuiArea(model,instNum)
{}

OGuiScrolledArea::~OGuiScrolledArea(void)
{}

Strings OGuiScrolledArea::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiHScrolledArea                                                  //
//--------------------------------------------------------------------------//

OGuiHScrolledArea::OGuiHScrolledArea(Model * model,int instNum)
 : OGuiScrolledArea(model,instNum)
{}

OGuiHScrolledArea::~OGuiHScrolledArea(void)
{}

Strings OGuiHScrolledArea::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiVScrolledArea                                                  //
//--------------------------------------------------------------------------//

OGuiVScrolledArea::OGuiVScrolledArea(Model * model,int instNum)
 : OGuiScrolledArea(model,instNum)
{}

OGuiVScrolledArea::~OGuiVScrolledArea(void)
{}

Strings OGuiVScrolledArea::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiColorArea                                                      //
//--------------------------------------------------------------------------//
 
OGuiColorArea::OGuiColorArea(Model * model,int instNum)
 : OGuiArea(model,instNum)
{}
 
OGuiColorArea::~OGuiColorArea(void)
{}
 
Strings OGuiColorArea::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiWindow                                                         //
//--------------------------------------------------------------------------//

OGuiWindow::OGuiWindow(Model * model,int instNum)
 : OGuiArea(model,instNum)
{}

OGuiWindow::~OGuiWindow(void)
{}

Strings OGuiWindow::userSave(int) const // virtual
{
Strings str;
return(str);
}

void OGuiWindow::orisCloseCB(GuiElement *,void * data) // static
{
Agent * agent=(Agent *)data;
ExecModule * module=agent->accessModule(_closeCallbackWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  getSimul()->executeModule(module,agent);
  }
}

//--------------------------------------------------------------------------//
// class OGuiFrame                                                          //
//--------------------------------------------------------------------------//

OGuiFrame::OGuiFrame(Model * model,int instNum)
 : OGuiArea(model,instNum)
{}

OGuiFrame::~OGuiFrame(void)
{}

Strings OGuiFrame::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiTabGroup                                                       //
//--------------------------------------------------------------------------//

OGuiTabGroup::OGuiTabGroup(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiTabGroup::~OGuiTabGroup(void)
{}

Strings OGuiTabGroup::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiTab                                                            //
//--------------------------------------------------------------------------//

OGuiTab::OGuiTab(Model * model,int instNum)
 : OGuiArea(model,instNum)
{}

OGuiTab::~OGuiTab(void)
{}

Strings OGuiTab::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiMenu                                                           //
//--------------------------------------------------------------------------//

OGuiMenu::OGuiMenu(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiMenu::~OGuiMenu(void)
{}

Strings OGuiMenu::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiMenuBar                                                        //
//--------------------------------------------------------------------------//

OGuiMenuBar::OGuiMenuBar(Model * model,int instNum)
 : OGuiMenu(model,instNum)
{}

OGuiMenuBar::~OGuiMenuBar(void)
{}

Strings OGuiMenuBar::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiMenuItem                                                       //
//--------------------------------------------------------------------------//

OGuiMenuItem::OGuiMenuItem(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiMenuItem::~OGuiMenuItem(void)
{}

Strings OGuiMenuItem::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiMenuSepar                                                      //
//--------------------------------------------------------------------------//

OGuiMenuSepar::OGuiMenuSepar(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiMenuSepar::~OGuiMenuSepar(void)
{}

Strings OGuiMenuSepar::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiLabel                                                          //
//--------------------------------------------------------------------------//

OGuiLabel::OGuiLabel(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiLabel::~OGuiLabel(void)
{}

Strings OGuiLabel::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiEditLabel                                                      //
//--------------------------------------------------------------------------//

OGuiEditLabel::OGuiEditLabel(Model * model,int instNum)
 : OGuiLabel(model,instNum)
{}

OGuiEditLabel::~OGuiEditLabel(void)
{}

Strings OGuiEditLabel::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiButton                                                         //
//--------------------------------------------------------------------------//

OGuiButton::OGuiButton(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiButton::~OGuiButton(void)
{}

Strings OGuiButton::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiToggle                                                         //
//--------------------------------------------------------------------------//

OGuiToggle::OGuiToggle(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiToggle::~OGuiToggle(void)
{}

Strings OGuiToggle::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiToggleGroup                                                    //
//--------------------------------------------------------------------------//

OGuiToggleGroup::OGuiToggleGroup(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiToggleGroup::~OGuiToggleGroup(void)
{}

Strings OGuiToggleGroup::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiOptionMenu                                                     //
//--------------------------------------------------------------------------//

OGuiOptionMenu::OGuiOptionMenu(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiOptionMenu::~OGuiOptionMenu(void)
{}

Strings OGuiOptionMenu::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiCursor                                                         //
//--------------------------------------------------------------------------//

OGuiCursor::OGuiCursor(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiCursor::~OGuiCursor(void)
{}

Strings OGuiCursor::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiScroller                                                       //
//--------------------------------------------------------------------------//

OGuiScroller::OGuiScroller(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiScroller::~OGuiScroller(void)
{}

Strings OGuiScroller::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiList                                                           //
//--------------------------------------------------------------------------//

OGuiList::OGuiList(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiList::~OGuiList(void)
{}

Strings OGuiList::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiEditor                                                         //
//--------------------------------------------------------------------------//

OGuiEditor::OGuiEditor(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiEditor::~OGuiEditor(void)
{}

Strings OGuiEditor::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiViewer3d                                                       //
//--------------------------------------------------------------------------//

#ifdef OPEN_GL

OGuiViewer3d::OGuiViewer3d(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiViewer3d::~OGuiViewer3d(void)
{}

Strings OGuiViewer3d::userSave(int) const // virtual
{
Strings str;
return(str);
}

void OGuiViewer3d::orisKeyCB(GuiViewer3D *,const Strings & key,void * data)
{                                                                 // static
OGuiViewer3d * elem=(OGuiViewer3d *)data;
ExecModule * module=elem->accessModule(_keyPressWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  Execution * initExec=Execution::getExecution(elem,ExecModule::NORMAL);
  Value * value=TmpValue::getTmpValue(ValueType(ValueType::STRING));
  value->setStrings(key);
  initExec->pushValue(value);
  getSimul()->executeModule(module,elem,initExec);
  Execution::relaxExecution(initExec);
  }
}

#endif // OPEN_GL

//--------------------------------------------------------------------------//
// class OGuiViewer2d                                                       //
//--------------------------------------------------------------------------//

OGuiViewer2d::OGuiViewer2d(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiViewer2d::~OGuiViewer2d(void)
{}

Strings OGuiViewer2d::userSave(int) const // virtual
{
Strings str;
return(str);
}

void OGuiViewer2d::orisKeyCB(GuiViewer2D *,const Strings & key,void * data)
{                                                                 // static
OGuiViewer2d * elem=(OGuiViewer2d *)data;
ExecModule * module=elem->accessModule(_keyPressWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  Execution * initExec=Execution::getExecution(elem,ExecModule::NORMAL);
  Value * value=TmpValue::getTmpValue(ValueType(ValueType::STRING));
  value->setStrings(key);
  initExec->pushValue(value);
  getSimul()->executeModule(module,elem,initExec);
  Execution::relaxExecution(initExec);
  }
}

//--------------------------------------------------------------------------//
// class OGuiGrapher                                                        //
//--------------------------------------------------------------------------//

OGuiGrapher::OGuiGrapher(Model * model,int instNum)
 : OGuiElem(model,instNum)
{}

OGuiGrapher::~OGuiGrapher(void)
{}

Strings OGuiGrapher::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiTextDialog                                                     //
//--------------------------------------------------------------------------//

OGuiTextDialog::OGuiTextDialog(Model * model,int instNum)
 : OGuiWindow(model,instNum)
{}

OGuiTextDialog::~OGuiTextDialog(void)
{}

Strings OGuiTextDialog::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiButtonDialog                                                   //
//--------------------------------------------------------------------------//

OGuiButtonDialog::OGuiButtonDialog(Model * model,int instNum)
 : OGuiWindow(model,instNum)
{}

OGuiButtonDialog::~OGuiButtonDialog(void)
{}

Strings OGuiButtonDialog::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiFileChooser                                                    //
//--------------------------------------------------------------------------//

OGuiFileChooser::OGuiFileChooser(Model * model,int instNum)
 : OGuiWindow(model,instNum)
{}

OGuiFileChooser::~OGuiFileChooser(void)
{}

Strings OGuiFileChooser::userSave(int) const // virtual
{
Strings str;
return(str);
}

//--------------------------------------------------------------------------//
// class OGuiColorChooser                                                   //
//--------------------------------------------------------------------------//

OGuiColorChooser::OGuiColorChooser(Model * model,int instNum)
 : OGuiWindow(model,instNum)
{}

OGuiColorChooser::~OGuiColorChooser(void)
{}

Strings OGuiColorChooser::userSave(int) const // virtual
{
Strings str;
return(str);
}

#endif // X_GUI || W_GUI

