// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : ipcPkg.h                                                   //
// description : header file for the ENIB/LI2 oRis package ipc.pkg          //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef IPCPKG_H
#define IPCPKG_H

#include "oRis/Main/agent.h"

#include "Utility/ipcShMem.h"
#include "Utility/ipcMutex.h"

//--------------------------------------------------------------------------//
// class IPCMemory                                                          //
//--------------------------------------------------------------------------//

class OIPCMemory : public Agent
{
public:
  OIPCMemory(Model * model,int instNum);
  virtual ~OIPCMemory(void);
  virtual Strings userSave(int column=0) const;

  // native void IPCMemory::_new(bool create,int sizeOrId);
  //
  static void construct(Context * context);

  // native void IPCMemory::_delete(void);
  //
  static void destruct(Context * context);

  // native bool IPCMemory::fail(void);
  //
  static void fail(Context * context);

  // native int IPCMemory::getId(void);
  //
  static void getId(Context * context);

  // native int IPCMemory::getSize(void);
  //
  static void getSize(Context * context);

  // native string IPCMemory::getContent(void);
  //
  static void getContent(Context * context);

  // native void IPCMemory::setContent(string content);
  //
  static void setContent(Context * context);

//---- Attributes ----
protected:
  IPCSharedMemory * _mem;
};

//--------------------------------------------------------------------------//
// class IPCMutex                                                           //
//--------------------------------------------------------------------------//

class OIPCMutex : public Agent
{
public:
  OIPCMutex(Model * model,int instNum);
  virtual ~OIPCMutex(void);
  virtual Strings userSave(int column=0) const;
 
  // native void IPCMutex::_new(int id);
  //
  static void construct(Context * context);                                     

  // native void IPCMutex::_delete(void);
  //
  static void destruct(Context * context);

  // native bool IPCMutex::fail(void);
  //
  static void fail(Context * context);
 
  // native int IPCMutex::getId(void);
  //
  static void getId(Context * context);

  // native void IPCMutex::lock(void);
  //
  static void lock(Context * context);

  // native bool IPCMutex::tryLock(void);
  //
  static void tryLock(Context * context);

  // native void IPCMutex::unlock(void);
  //
  static void unlock(Context * context);

//---- Attributes ----
protected:
  static void _lockTask(Context * context);
  IPCMutex * _mutex;
};

#endif // IPCPKG_H

