
import bsh.Interpreter;
import java.lang.reflect.Array;
import java.util.Hashtable;
import java.net.Socket;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.FileWriter ;
// import JavaConsole;

public class oRisJava
{
//---- Public Part ----
public static String eval(String command)
  {
  synchronized(_toORis)
    {
    String result;
    try
      {
      _toORis.writeString(command);
      result=_toORis.readString();
      }
    catch(Throwable t)
      {
      result="";
      manageError(t);
      }
    return(result);
    }
  }
public static int intEval(String command)
  {
  try
    {
    return(Integer.parseInt(eval(command)));
    }
  catch(Throwable t)
    {
    manageError(t);
    return(0);
    }
  }
public static double floatEval(String command)
  {
  try
    {
    return(Double.parseDouble(eval(command)));
    }
  catch(Throwable t)
    {
    manageError(t);
    return(0.0);
    }
  }
public static String oRisRef(Object obj)
  {
  return(eval("Object "+_oRisInterface+
              "::execute{return(oRisRef("+ref(obj)+",false));}"));
  }
public static int ref(Object obj)
  {
  synchronized(_objects)
    {
    if(obj==null) return(0);
    int objID=System.identityHashCode(obj);
    Integer key=new Integer(objID);
    ObjectRef objRef=(ObjectRef)_objects.get(key);
    if(objRef==null)
      _objects.put(key,new ObjectRef(obj));
    else
      ++objRef.nbRefs;
    return(objID);
    }
  }
public static void unref(int objID)
  {
  synchronized(_objects)
    {
    Integer key=new Integer(objID);
    ObjectRef objRef=(ObjectRef)_objects.get(key);
    if((objRef!=null)&&(--objRef.nbRefs==0))
      {
      objRef.ref=null;
      _objects.remove(key);
      }
    }
  }
public static Object access(int objID)
  {
  synchronized(_objects)
    {
    Integer key=new Integer(objID);
    ObjectRef objRef=(ObjectRef)_objects.get(key);
    if(objRef==null) return(null);
    else return(objRef.ref);
    }
  }
public static void print(String str)
  {
  _console.print(str);
  }
public static void println(String str)
  {
  _console.println(str);
  }
public static void manageError(Throwable t)
  {
  _console.println(t.toString());
  }
//---- Private Part ----
private static String _oRisInterface;
private static InOut _fromORis;
private static InOut _toORis;
private static Interpreter _inter;
private static Hashtable _objects;
private static Class _booleanClass;
private static Class _stringClass;
private static JavaConsole _console;
private static class ObjectRef
  {
  public int nbRefs;
  public Object ref;
  public ObjectRef(Object obj)
    {
    nbRefs=1;
    ref=obj;
    }
  }
private static interface InOut
  {
  public void writeString(String str) throws java.io.IOException;
  public String readString() throws java.io.IOException;
  }
private static class TCPInOut implements InOut
  {
  private Socket _socket;
  private DataInputStream _in;
  private DataOutputStream _out;
  public TCPInOut(String host,int port) throws java.io.IOException
    {
    _socket=new Socket(host,port);
    _in=new DataInputStream(_socket.getInputStream());
    _out=new DataOutputStream(_socket.getOutputStream());
    }
  public void writeString(String str) throws java.io.IOException
    {
    _out.writeInt(str.length()+1);
    _out.writeBytes(str);
    _out.writeByte(0); // add final '\0'
    }
  public String readString() throws java.io.IOException
    {
    int nBytes=_in.readInt();
    byte[] buffer=new byte[nBytes-1];
    _in.read(buffer);
    _in.readByte(); // read final '\0'
    return(new String(buffer));
    }
  }
private static class UDPInOut implements InOut
  {
  private DatagramSocket _socket;
  private InetAddress _host;
  private int _port;
  private byte[] _buffer;
  public UDPInOut(String host,int port) throws java.io.IOException
    {
    _host=InetAddress.getByName(host);
    _port=port;
    _buffer=new byte[65535];
    _socket=new DatagramSocket();
    }
  public void writeString(String str) throws java.io.IOException
    {
    byte[] strBytes=str.getBytes();
    int nb=strBytes.length;
    System.arraycopy(strBytes,0,_buffer,0,nb);
    _buffer[nb]=0; // add final '\0'
    DatagramPacket p=new DatagramPacket(_buffer,0,nb+1,
                                        _host,_port);
    _socket.send(p);
    }
  public String readString() throws java.io.IOException
    {
    DatagramPacket p=new DatagramPacket(_buffer,_buffer.length);
    _socket.receive(p);
    return(new String(p.getData(),0,p.getLength()-1)); // remove final '\0'
    }
  }
private static boolean _init(String oRisInterface,boolean udp,
                             String host,int port1,int port2)
  {
  boolean ok=true;
  try
    {
    _oRisInterface=oRisInterface;
    if(udp)
      {
      _fromORis=new UDPInOut(host,port1);
      _fromORis.writeString("oRis to Java");
      _toORis=new UDPInOut(host,port2);
      _toORis.writeString("Java to oRis");
      }
    else
      {
      _fromORis=new TCPInOut(host,port1);
      _toORis=new TCPInOut(host,port1);
      }
    _inter=new Interpreter();
    _objects=new Hashtable();
    _booleanClass=Class.forName("java.lang.Boolean");
    _stringClass=Class.forName("java.lang.String");
    }
  catch(Throwable t)
    {
    manageError(t);
    ok=false;
    }
  return(ok);
  }
private static boolean _waitCommands()
  {
  boolean ok=true;
  try
    {
    String command;
    try
      {
      command=_fromORis.readString();
      }
    catch(IOException e)
      {
      command="";
      ok=false;
      }
    if(ok)
      {
      String result;
      try
        {
        result=_printResult(_inter.eval(command));
        }
      catch(Throwable t)
        {
        result="";
        manageError(t);
        }
      try
        {
        _fromORis.writeString(result);
        Thread.yield();
        }
      catch(IOException e)
        {
        ok=false;
        }
      }
    }
  catch(Throwable t)
    {
    manageError(t);
    ok=false;
    }
  return(ok);
  }
private static String _printResult(Object obj)
  {
  String result;
  if(obj==null)
    {
    result="";
    }
  else
    {
    Class cls=obj.getClass();
    if(cls.isArray())
      {
      result="[";
      int nb=Array.getLength(obj);
      for(int i=0;i<nb;i++)
        {
        if(i!=0) result+=",";
        result+=_printResult(Array.get(obj,i));
        }
      result+="]";
      }
    else if(cls==_booleanClass)
      {
      result=(((Boolean)obj).booleanValue() ? "1" : "0");
      }
    else if(cls==_stringClass)
      {
      result=(String)obj;
      }
    else
      {
      result=obj.toString();
      }
    }
  return(result);
  }
//---- Entry Point ----
public static void main(String[] args)
  {
  String oRisInterface="";
  String host="";
  int port1=-1,port2=-1;
  boolean ok=true;
  boolean udp=false;
  boolean graphic=false;
  try
    {
    oRisInterface=args[0];
    if(args[1].equals("UDP")) udp=true;
    else if(args[1].equals("TCP")) udp=false;
    else ok=false;
    if(ok)
      {
      if(udp)
        {
        host=args[2];
        port1=new Integer(args[3]).intValue();
        port2=new Integer(args[4]).intValue();
        if(args.length>=5)
          {
          graphic=new Boolean(args[5]).booleanValue();
          }
        }
      else
        {
        host=args[2];
        port1=new Integer(args[3]).intValue();
        if(args.length>=4)
          {
          graphic=new Boolean(args[4]).booleanValue();
          }
        }
      }
    }
  catch(Throwable t)
    {
    ok=false;
    }
  _console=new JavaConsole(graphic);
  if(graphic)
    {
    _console.setSize(300,200);
    _console.show();
    }
  if(ok)
    {
    _console.print("oRisJava: Initializing connection to oRis ");
    if(udp) _console.println("("+host+":"+port1+"/"+port2+")");
    else _console.println("("+host+":"+port1+")");
    if(_init(oRisInterface,udp,host,port1,port2))
      {
      _console.println("Initialization ok");
      while(_waitCommands());
      _console.print("oRisJava: Connection closed to oRis ");
      if(udp) _console.println("("+host+":"+port1+"/"+port2+")");
      else _console.println("("+host+":"+port1+")");
      }
    else
      {
      _console.print("oRisJava: Can't connect to oRis ");
      if(udp) _console.println("("+host+":"+port1+"/"+port2+")");
      else _console.println("("+host+":"+port1+")");
      }
    }
  else
    {
    _console.println("usage: java oRisJava TCP <oRisInterface> "+
                     "<hostname> <portnumber> "+
                     "[console(true/false)]");
    _console.println("       java oRisJava UDP <oRisInterface> "+
                     "<hostname> <portnumber_to> <portnumber_from> "+
                     "[console(true/false)]");
    }
  System.exit(0); // terminate all threads
  }
}

