// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : mathsPkg.h                                                 //
// description : header file for the ENIB/LI2 oRis package maths.pkg        //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef MATHSPKG_H
#define MATHSPKG_H

#include "oRis/Main/context.h"

//--------------------------------------------------------------------------//
// Maths functions                                                          //
//--------------------------------------------------------------------------//

// native float acos(float x);
//
void acos(Context * context);

// native float asin(float x);
//
void asin(Context * context);

// native float atan(float x);
//
void atan(Context * context);

// native float cosh(float x);
//
void cosh(Context * context);

// native float cos(float x);
//
void cos(Context * context);

// native float sinh(float x);
//
void sinh(Context * context);

// native float sin(float x);
//
void sin(Context * context);

// native float tanh(float x);
//
void tanh(Context * context);

// native float tan(float x);
//
void tan(Context * context);

// native float exp(float x);
//
void exp(Context * context);

// native float abs(float x);
//
void abs(Context * context);

// native float ln(float x);
//
void ln(Context * context);

// native float log(float x);
//
void log(Context * context);

// native float pow(float x,float y);
//
void pow(Context * context);

// native float square(float x);
//
void square(Context * context);

// native float signedSquare(float x);
//
void signedSquare(Context * context);

// native float sqrt(float x);
//
void sqrt(Context * context);

// native float signedSqrt(float x);
//
void signedSqrt(Context * context);

// native float floor(float x);
//
void floor(Context * context);

// native float ceil(float x);
//
void ceil(Context * context);

//--------------------------------------------------------------------------//
// Cartesian <===> Polar / Spherical                                        //
//--------------------------------------------------------------------------//

// native float cartToAngle(float x,float y);
//
void cartToAngle(Context * context);

// native float cartToDist(float x,float y);
//
void cartToDist(Context * context);

// native float polToX(float d,float a);
//
void polToX(Context * context);

// native float polToY(float d,float a);
//
void polToY(Context * context);

// native void cartToPol(float & d,float & a,float x,float y);
//
void cartToPol(Context * context);

// native void polToCart(float & x,float & y,float d,float a);
//
void polToCart(Context * context);

// native void cartToSphere(float & d,float & xyAngle,float & zAngle,
//                          float x,float y,float z);
//
void cartToSphere(Context * context);

// native void sphereToCart(float & x,float & y,float & z,
//                          float d,float xyAngle,float zAngle);
//
void sphereToCart(Context * context);

// native float betweenPi(float a);
//
void betweenPi(Context * context);

#endif // MATHSPKG_H

