// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : memoryPkg.h                                                //
// description : header file for the ENIB/LI2 oRis package memory.pkg       //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef MEMORYPKG_H
#define MEMORYPKG_H

#include "oRis/Main/agent.h"

//--------------------------------------------------------------------------//
// class OMemory                                                            //
//--------------------------------------------------------------------------//

class OMemory : public Agent
{
public:
  OMemory(Model * model,int instNum);
  virtual ~OMemory(void);
  virtual Strings userSave(int column=0) const;
  inline size_t getSize(void) const
         {
         return(_size);
         }
  inline void setSize(size_t size)
         {
         _size=size;
         }
  inline void * getBlock(void) const
         {
         return(_block);
         }
  inline void setBlock(void * block)
         {
         _block=block;
         }

//---- Attributes ----
protected:
  size_t _size;
  void * _block;
};

#endif // MEMORYPKG_H

