// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : obj2dPkg.cpp                                               //
// description : source file for the ENIB/LI2 oRis package object2d.pkg     //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#if defined(X_GUI) || defined(W_GUI)

#include "Object2d/obj2dPkg.h"
#include "Gui/guiPkg.h"
#include "oRis/Main/simul.h"
#include "oRis/Main/tmpVal.h"
#include "oRis/Main/context.h"
#include "oRis/Main/errors.h"
#include "Utility/stlList.h"

#ifndef __MSDOS__
#define EXPORT_PREFIX extern "C"
#else
#include <windows.h>
#define EXPORT_PREFIX extern "C" __declspec(dllexport)
#define openingLibrary    openingObj2dLibrary
#define closingLibrary    closingObj2dLibrary
#define getExternFunction getExternObj2dFunction
#define getNewAgent       getNewObj2dAgent
#endif
 
//--------------------------------------------------------------------------//
// Opening and closing the library                                          //
//--------------------------------------------------------------------------//
 
EXPORT_PREFIX void openingLibrary(void)
{
  // nothing to do
}
 
EXPORT_PREFIX void closingLibrary(void)
{
  // nothing to do
}

//--------------------------------------------------------------------------//
// LookUp table for functions                                               //
//--------------------------------------------------------------------------//

EXPORT_PREFIX ExternFunction getExternFunction(const Strings & name)
{
if(name==Strings("Object2d::isSelectedIn()"))  return(Object2d::isSelectedIn);
if(name==Strings("Object2d::getX()"))          return(Object2d::getX);
if(name==Strings("Object2d::getY()"))          return(Object2d::getY);
if(name==Strings("Object2d::getTheta()"))      return(Object2d::getTheta);
if(name==Strings("Object2d::getLocation()"))   return(Object2d::getLocation);
if(name==Strings("Object2d::getLocalBoundingBox()"))
                                      return(Object2d::getLocalBoundingBox);
if(name==Strings("Object2d::getGlobalBoundingBox()"))
                                      return(Object2d::getGlobalBoundingBox);
if(name==Strings("Object2d::globalToLocalPosition()"))
                                      return(Object2d::globalToLocalPosition);
if(name==Strings("Object2d::localToGlobalPosition()"))
                                      return(Object2d::localToGlobalPosition);
if(name==Strings("Object2d::globalToLocalAngle()"))
                                      return(Object2d::globalToLocalAngle);
if(name==Strings("Object2d::localToGlobalAngle()"))
                                      return(Object2d::localToGlobalAngle);
if(name==Strings("Object2d::setX()"))          return(Object2d::setX);
if(name==Strings("Object2d::setY()"))          return(Object2d::setY);
if(name==Strings("Object2d::setTheta()"))      return(Object2d::setTheta);
if(name==Strings("Object2d::setLocation()"))   return(Object2d::setLocation);
if(name==Strings("Object2d::translate()"))     return(Object2d::translate);
if(name==Strings("Object2d::rotate()"))        return(Object2d::rotate);
if(name==Strings("Object2d::isAttachedTo()"))
                                      return(Object2d::stIsAttachedTo);
if(name==Strings("Object2d::getContent()"))    return(Object2d::stGetContent);
if(name==Strings("Object2d::viewFirst()"))     return(Object2d::viewFirst);
if(name==Strings("Object2d::view()"))          return(Object2d::view);
if(name==Strings("Object2d::throwRay()"))      return(Object2d::throwRay);
if(name==Strings("Object2d::intersectRay()"))  return(Object2d::intersectRay);
if(name==Strings("Object2d::inside()"))        return(Object2d::inside);
if(name==Strings("Object2d::getColor()"))      return(Object2d::getColor);
if(name==Strings("Object2d::setColor()"))      return(Object2d::setColor);
if(name==Strings("Object2d::getLayer()"))      return(Object2d::getLayer);
if(name==Strings("Object2d::setLayer()"))      return(Object2d::setLayer);
if(name==Strings("Object2d::noShape()"))       return(Object2d::noShape);
if(name==Strings("Object2d::point()"))         return(Object2d::point);
if(name==Strings("Object2d::text()"))          return(Object2d::text);
if(name==Strings("Object2d::line()"))          return(Object2d::line);
if(name==Strings("Object2d::square()"))        return(Object2d::square);
if(name==Strings("Object2d::rectangle()"))     return(Object2d::rectangle);
if(name==Strings("Object2d::polyline()"))      return(Object2d::polyline);
if(name==Strings("Object2d::polygon()"))       return(Object2d::polygon);
if(name==Strings("Object2d::circle()"))        return(Object2d::circle);
if(name==Strings("Object2d::image()"))         return(Object2d::image);
if(name==Strings("Object2d::getNbColumns()"))  return(Object2d::getNbColumns);
if(name==Strings("Object2d::getNbLines()"))    return(Object2d::getNbLines);
if(name==Strings("Object2d::getFileName()"))   return(Object2d::getFileName);
if(name==Strings("Object2d::getPixelScale()")) return(Object2d::getPixelScale);
if(name==Strings("Object2d::getNbColors()"))   return(Object2d::getNbColors);
if(name==Strings("Object2d::sortColors()"))    return(Object2d::sortColors);
if(name==Strings("Object2d::getPixel()"))      return(Object2d::getPixel);
if(name==Strings("Object2d::setPixel()"))      return(Object2d::setPixel);
if(name==Strings("Object2d::getPixelAt()"))    return(Object2d::getPixelAt);
if(name==Strings("Object2d::setPixelAt()"))    return(Object2d::setPixelAt);
if(name==Strings("Object2d::getRGB()"))        return(Object2d::getRGB);
return((ExternFunction)0); // not found
}

//--------------------------------------------------------------------------//
// LookUp table for agents                                                  //
//--------------------------------------------------------------------------//

static Word object2dWord(Word::create("Object2d"));

EXPORT_PREFIX Agent * getNewAgent(Model * model,long instNum)
{
if(model->isA(::object2dWord)) return(new Object2d(model,instNum));
return((Agent *)0); // not found
}

//--------------------------------------------------------------------------//
// Object2d functions                                                       //
//--------------------------------------------------------------------------//

// native GuiViewer2d[] Object2d::isSelectedIn(void);
//
void Object2d::isSelectedIn(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
Model * viewerModel=getSimul()->accessModel(_guiViewer2dWord);
Value * result=TmpValue::getTmpValue(ValueType(viewerModel,1));
SubValueVect * vect=SubValue::getSubValueVect();
OGuiViewer2d * viewer;
AgentMap::iterator it=viewerModel->accessAgentMap().begin();
for(;it!=viewerModel->accessAgentMap().end();it++)
  {
  viewer=(OGuiViewer2d *)(*it).second;
  if(((const GuiViewer2D *)viewer->getElem())->isSelected(obj->_shape))
    {
    vect->pushBack(SubValue::getSubValue(viewer->accessModel(),result));
    vect->accessBack()->setAgent(viewer);
    }
  }
result->setValueVector(vect);
context->returnValue(result);
}

// native float Object2d::getX(void);
//
void Object2d::getX(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnReal(obj->_x);
}

// native float Object2d::getY(void);
//
void Object2d::getY(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnReal(obj->_y);
}

// native float Object2d::getTheta(void);
//
void Object2d::getTheta(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnReal(obj->_theta);
}

// native void Object2d::getLocation(float & x,float & y,float & theta);
//
void Object2d::getLocation(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->setReal(0,obj->_x);
context->setReal(1,obj->_y);
context->setReal(2,obj->_theta);
}

// native bool Object2d::getLocalBoundingBox(float & xmin,float & ymin,
//                                           float & xmax,float & ymax);
//
void Object2d::getLocalBoundingBox(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shape&&obj->_shape->isScalable())
  {
  double xmin,ymin,xmax,ymax;
  obj->_shape->getLocalBoundingBox(xmin,ymin,xmax,ymax);
  context->setReal(0,xmin);
  context->setReal(1,ymin);
  context->setReal(2,xmax);
  context->setReal(3,ymax);
  context->returnInteger(1);
  }
else context->returnInteger(0);
}

// native bool Object2d::getGlobalBoundingBox(float & xmin,float & ymin,
//                                            float & xmax,float & ymax);
//
void Object2d::getGlobalBoundingBox(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shape&&obj->_shape->isScalable())
  {
  double xmin,ymin,xmax,ymax;
  if(obj->_shape->hasMoved()) obj->_shape->computePosition();
  obj->_shape->getBoundingBox(xmin,ymin,xmax,ymax,(const GuiViewer2D *)0);
  context->setReal(0,xmin);
  context->setReal(1,ymin);
  context->setReal(2,xmax);
  context->setReal(3,ymax);
  context->returnInteger(1);
  }
else context->returnInteger(0);
}

// native void Object2d::globalToLocalPosition(float & x,float & y);
//
void Object2d::globalToLocalPosition(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
double x=context->getReal(0)-obj->_x;
double y=context->getReal(1)-obj->_y;
double angle,distance;
Simulator::cartToPol(distance,angle,x,y);
Simulator::polToCart(x,y,distance,angle-obj->_theta);
context->setReal(0,x);
context->setReal(1,y);
}

// native void Object2d::localToGlobalPosition(float & x,float & y);
//
void Object2d::localToGlobalPosition(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
double x=context->getReal(0);
double y=context->getReal(1);
double angle,distance;
Simulator::cartToPol(distance,angle,x,y);
Simulator::polToCart(x,y,distance,angle+obj->_theta);
context->setReal(0,x+obj->_x);
context->setReal(1,y+obj->_y);
}

// native float Object2d::globalToLocalAngle(float angle);
//
void Object2d::globalToLocalAngle(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnReal(Simulator::betweenPi(context->getReal(0)-obj->_theta));
}

// native float Object2d::localToGlobalAngle(float angle);
//
void Object2d::localToGlobalAngle(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnReal(Simulator::betweenPi(context->getReal(0)+obj->_theta));
}

// native void Object2d::setX(float x);
//
void Object2d::setX(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_x=context->getReal(0);
if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
obj->writeLocation();
}

// native void Object2d::setY(float y);
//
void Object2d::setY(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_y=context->getReal(0);
if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
obj->writeLocation();
}

// native void Object2d::setTheta(float theta);
//
void Object2d::setTheta(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_theta=context->getReal(0);
if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
obj->writeLocation();
}

// native void Object2d::setLocation(float x,float y,float theta);
//
void Object2d::setLocation(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_x=context->getReal(0);
obj->_y=context->getReal(1);
obj->_theta=context->getReal(2);
if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
obj->writeLocation();
}

// native void Object2d::translate(float dx,float dy);
//
void Object2d::translate(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
double dx=context->getReal(0);
double dy=context->getReal(1);
double c=::cos(obj->_theta);
double s=::sin(obj->_theta);
obj->_x+=dx*c-dy*s;
obj->_y+=dx*s+dy*c;
if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
obj->writeLocation();
}

// native void Object2d::rotate(float dtheta);
//
void Object2d::rotate(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_theta=Simulator::betweenPi(obj->_theta+context->getReal(0));
if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
obj->writeLocation();
}

// native bool Object2d::isAttachedTo(Object2d container)
//
void Object2d::stIsAttachedTo(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnInteger(obj->isAttachedTo((const Object2d *)
                                         context->getAgent(0)));
}

// native void Object2d::getContent(string className,bool recursive)
//
void Object2d::stGetContent(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
Model * model;
if(context->getStrings(0).len())
  model=getSimul()->accessModel(Word::create(context->getStrings(0)));
else model=getSimul()->accessModel(::object2dWord);
if(model)
  {
  Value * result=TmpValue::getTmpValue(ValueType(model,1));
  obj->getContent(*result,model,context->getInteger(1));
  context->returnValue(result);
  }
else
  {
  Value * result=TmpValue::getTmpValue(context->getModule()->getResultType());
  context->returnValue(result);
  }
}

// native Object2d Object2d::viewFirst(float & angle,float & distance,
//                                     string className,float vision,
//                                     float range,float turn);
//
void Object2d::viewFirst(Context * context) // static
{
Word modelName(Word::create(context->getStrings(2)));
const AgentMap * m=(const AgentMap *)0;
Model * model=(Model *)0;
if(modelName.getStrings().len())
  {
  model=getSimul()->accessModel(modelName);
  if(model&&model->isA(::object2dWord))
    m=&model->getAgentMap();
  }
else
  {
  model=getSimul()->accessModel(::object2dWord);
  if(model) m=&model->getAgentMap(); // all visible agents
  }
if(m)
  {
  double turn=context->getReal(5);
  double v2=context->getReal(3);
  v2=(v2 ? v2/2.0 : Constant_PI);
  double range=context->getReal(4);
  range*=range;
  double x0=((const Object2d *)context->getOwner())->_x;
  double y0=((const Object2d *)context->getOwner())->_y;
  double a0=((const Object2d *)context->getOwner())->_theta+turn;
  double x,y;
  double d,a;
  const Object2d * obj;
  bool firstTime=true;
  double dMin=0.0;
  double aMin=0.0;
  const Object2d * objMin=(const Object2d *)0;
  AgentMap::const_iterator i=m->begin();
  for(;!(i==m->end());i++)
    {
    obj=(const Object2d *)(*i).second;
    if(obj!=context->getOwner())
      {
      x=obj->_x-x0;
      y=obj->_y-y0;
      d=x*x+y*y;
      if((!range||d<range)&&(firstTime||d<dMin))
        {
        a=Simulator::betweenPi(Simulator::cartToAngle(x,y)-a0);
        if(::fabs(a)<=v2)
          {
          dMin=d;
          aMin=a;
          objMin=obj;
          firstTime=false;
          }
        }
      }
    }
  if(firstTime) // no agent found
    {
    context->setReal(0,0.0);
    context->setReal(1,0.0);
    context->returnAgent((Agent *)0,model);
    }
  else
    {
    context->setReal(0,Simulator::betweenPi(aMin-turn));
    context->setReal(1,::sqrt(dMin));
    context->returnAgent((Agent *)objMin,((Agent *)objMin)->accessModel());
    }
  }
else
  {
  context->setReal(0,0.0);
  context->setReal(1,0.0);
  context->returnAgent((Agent *)0,context->getModule()
                                         ->getResultType().getModel());
  }
}

// native Object2d[] Object2d::view(float[] & angle,float[] & distance,
//                                  string className,float vision,
//                                  float range,float turn);
//
void Object2d::view(Context * context) // static
{
SubValueVect * angleVect=SubValue::getSubValueVect();
SubValueVect * distVect=SubValue::getSubValueVect();
SubValueVect * agtVect=SubValue::getSubValueVect();
Word modelName(Word::create(context->getStrings(2)));
const AgentMap * m=(const AgentMap *)0;
Model * model=(Model *)0;
if(modelName.getStrings().len())
  {
  model=getSimul()->accessModel(modelName);
  if(model&&model->isA(::object2dWord))
    m=&model->getAgentMap();
  }
else
  {
  model=getSimul()->accessModel(::object2dWord);
  if(model) m=&model->getAgentMap(); // all visible agents
  }
if(m)
  {
  Value * result=TmpValue::getTmpValue(ValueType(model,1));
  double turn=context->getReal(5);
  double v2=context->getReal(3);
  v2=(v2 ? v2/2.0 : Constant_PI);
  double range=context->getReal(4);
  range*=range;
  double x0=((Object2d *)(context->getOwner()))->_x;
  double y0=((Object2d *)(context->getOwner()))->_y;
  double a0=((Object2d *)(context->getOwner()))->_theta+turn;
  double x,y;
  double d,a;
  const Object2d * obj;
  int j;
  int nbFound=0;
  SubValue * value;
  StlList<SubValue *> agtList;
  StlList<SubValue *> distList;
  StlList<SubValue *> angleList;
  StlList<SubValue *>::iterator agtIter;
  StlList<SubValue *>::iterator distIter;
  StlList<SubValue *>::iterator angleIter;
  AgentMap::const_iterator i=m->begin();
  for(;!(i==m->end());i++)
    {
    obj=(const Object2d *)(*i).second;
    if(obj!=context->getOwner())
      {
      x=obj->_x-x0;
      y=obj->_y-y0;
      d=x*x+y*y;
      if(!range||d<range)
        {
        a=Simulator::betweenPi(Simulator::cartToAngle(x,y)-a0);
        if(::fabs(a)<=v2)
          {
          agtIter=agtList.begin();
          distIter=distList.begin();
          angleIter=angleList.begin();
          d=::sqrt(d);
          for(j=0;j<nbFound;j++)
            {
            if(d<(*distIter)->getReal()) break; // insert here
            else
              {
              agtIter++;
              distIter++;
              angleIter++;
              }
            }
          value=SubValue::getSubValue(ValueType(((Agent *)obj)->accessModel()),
                                      result);
          value->setAgent((Agent *)obj);
          agtList.insert(agtIter,value);
          value=SubValue::getSubValue(ValueType(ValueType::REAL),
                                      context->accessLocal(1));
          value->setReal(d);
          distList.insert(distIter,value);
          value=SubValue::getSubValue(ValueType(ValueType::REAL),
                                      context->accessLocal(0));
          value->setReal(Simulator::betweenPi(a-turn));
          angleList.insert(angleIter,value);
          nbFound++;
          }
        }
      }
    }
  agtVect->resizeIfNeeded(nbFound);
  distVect->resizeIfNeeded(nbFound);
  angleVect->resizeIfNeeded(nbFound);
  agtIter=agtList.begin();
  distIter=distList.begin();
  angleIter=angleList.begin();
  for(j=0;j<nbFound;j++,agtIter++,distIter++,angleIter++)
    {
    agtVect->pushBack(*agtIter);
    distVect->pushBack(*distIter);
    angleVect->pushBack(*angleIter);
    }
  context->setValueVector(0,angleVect,ValueType(ValueType::REAL,1));
  context->setValueVector(1,distVect,ValueType(ValueType::REAL,1));
  result->setValueVector(agtVect);
  context->returnValue(result);
  }
else
  {
  context->setValueVector(0,angleVect,ValueType(ValueType::REAL,1));
  context->setValueVector(1,distVect,ValueType(ValueType::REAL,1));
  Value * result=TmpValue::getTmpValue(context->getModule()->getResultType());
  result->setValueVector(agtVect);
  context->returnValue(result);
  }
}

// native Object2d Object2d::throwRay(float & xInter,float & yInter,
//                                    string className);
//
void Object2d::throwRay(Context * context) // static
{
Word modelName(Word::create(context->getStrings(2)));
AgentMap * m=(AgentMap *)0;
Model * model=(Model *)0;
if(modelName.getStrings().len())
  {
  model=getSimul()->accessModel(modelName);
  if(model&&model->isA(::object2dWord))
    m=&model->accessAgentMap();
  }
else
  {
  model=getSimul()->accessModel(object2dWord);
  if(model) m=&model->accessAgentMap(); // all visible agents
  }
double xInter=0.0,yInter=0.0;
Object2d * found=(Object2d *)0;
if(m)
  {
  Object2d * obj=(Object2d *)context->accessOwner();
  Object2d * other;
  double xDir=::cos(obj->_theta);
  double yDir=::sin(obj->_theta);
  double x,y,dx,dy,d,dmin=0.0;
  AgentMap::iterator i=m->begin();
  for(;!(i==m->end());i++)
    {
    other=(Object2d *)(*i).second;
    if((other!=obj)&&other->_shape)
      {
      if(other->_shape->hasMoved()) other->_shape->computePosition();
      if(other->_shape->intersectRay(obj->_x,obj->_y,xDir,yDir,x,y))
        {
        dx=x-obj->_x;
        dy=y-obj->_y;
        d=dx*dx+dy*dy;
        if(!found||(d<dmin))
          {
          dmin=d;
          xInter=x;
          yInter=y;
          found=other;
          }
        }
      }
    }
  }
if(found)
  {
  context->setReal(0,xInter);
  context->setReal(1,yInter);
  context->returnAgent(found,found->accessModel());
  }
else
  context->returnAgent((Agent *)0,context->getModule()
                                         ->getResultType().getModel());
}

// native bool Object2d::intersectRay(float & xInter,float & yInter,
//                                    float xRay,float yRay,float thetaRay);
//
void Object2d::intersectRay(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
if(obj->_shape)
  {
  double xRay=context->getReal(2);
  double yRay=context->getReal(3);
  double thetaRay=context->getReal(4);
  double xDir=::cos(thetaRay);
  double yDir=::sin(thetaRay);
  double xInter,yInter;
  if(obj->_shape->hasMoved()) obj->_shape->computePosition();
  if(obj->_shape->intersectRay(xRay,yRay,xDir,yDir,xInter,yInter))
    {
    context->setReal(0,xInter);
    context->setReal(1,yInter);
    context->returnInteger(1);
    }
  else context->returnInteger(0);
  }
else context->returnInteger(0);
}

// native bool Object2d::inside(float x,float y);
//
void Object2d::inside(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
if(obj->_shape)
  {
  if(obj->_shape->hasMoved()) obj->_shape->computePosition();
  if(obj->_shape->isInside(context->getReal(0),context->getReal(1)))
    context->returnInteger(1);
  else
    context->returnInteger(0);
  }
else
  context->returnInteger(0);
}

// native string Object2d::getColor(void);
//
void Object2d::getColor(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnStrings(obj->_color);
}

// native void Object2d::setColor(string color);
//
void Object2d::setColor(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_color=context->getStrings(0);
if(obj->_shape) obj->_shape->setColor(obj->_color);
}

// native int Object2d::getLayer(void);
//
void Object2d::getLayer(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
context->returnInteger(obj->_layer);
}

// native void Object2d::setLayer(int layer);
//
void Object2d::setLayer(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->_layer=context->getInteger(0);
if(obj->_shape) obj->_shape->setLayer(obj->_layer);
}

// native void Object2d::noShape(void);
//
void Object2d::noShape(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->setShape(Object2d::NOSHAPE,(GuiShape2D *)0);
}

// native void Object2d::point(void);
//
void Object2d::point(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->setShape(Object2d::POINT,
              new GuiPoint(obj->_x,obj->_y,obj->_theta,obj->_color));
}

// native void Object2d::text(string text);
//
void Object2d::text(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
if(obj->_shapeType==Object2d::TEXT)
  {
  ((GuiText *)obj->_shape)->setText(context->getStrings(0));
  }
else
  {
  obj->setShape(Object2d::TEXT,
                new GuiText(obj->_x,obj->_y,obj->_theta,obj->_color,
                            context->getStrings(0)));
  }
}

// native void Object2d::line(float length);
//
void Object2d::line(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->setShape(Object2d::LINE,
              new GuiLine(obj->_x,obj->_y,obj->_theta,obj->_color,
                          context->getReal(0)));
}

// native void Object2d::square(float side,bool filled);
//
void Object2d::square(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->setShape(Object2d::SQUARE,
              new GuiSquare(obj->_x,obj->_y,obj->_theta,obj->_color,
                            context->getReal(0),
                            context->getInteger(1)));
}

// native void Object2d::rectangle(float length,float width,bool filled);
//
void Object2d::rectangle(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->setShape(Object2d::RECTANGLE,
              new GuiRectangle(obj->_x,obj->_y,obj->_theta,obj->_color,
                               context->getReal(0),
                               context->getReal(1),
                               context->getInteger(2)));
}

// native void Object2d::polyline(float[][] points);
//
void Object2d::polyline(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
const SubValueVect & pointVect=*context->getValueVector(0);
int nb=pointVect.getSize();
if(nb)
  {
  double * x=new double[nb];
  double * y=new double[nb];
  while(nb--)
    {
    switch(pointVect[nb]->getLen())
      {
      case 0:
        x[nb]=0.0;
        y[nb]=0.0;
        break;
      case 1:
        x[nb]=pointVect[nb]->getElem(0).getReal();
        y[nb]=0.0;
        break;
      default:
        x[nb]=pointVect[nb]->getElem(0).getReal();
        y[nb]=pointVect[nb]->getElem(1).getReal();
      }
    }
  obj->setShape(Object2d::POLYLINE,
                new GuiPolyline(obj->_x,obj->_y,obj->_theta,obj->_color,
                                pointVect.getSize(),x,y));
  delete []x;
  delete []y;
  }
}

// native void Object2d::polygon(float[][] points,bool filled);
//
void Object2d::polygon(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
const SubValueVect & pointVect=*context->getValueVector(0);
int nb=pointVect.getSize();
if(nb)
  {
  double * x=new double[nb];
  double * y=new double[nb];
  while(nb--)
    {
    switch(pointVect[nb]->getLen())
      {
      case 0:
        x[nb]=0.0;
        y[nb]=0.0;
        break;
      case 1:
        x[nb]=pointVect[nb]->getElem(0).getReal();
        y[nb]=0.0;
        break;
      default:
        x[nb]=pointVect[nb]->getElem(0).getReal();
        y[nb]=pointVect[nb]->getElem(1).getReal();
      }
    }
  obj->setShape(Object2d::POLYGON,
                new GuiPolygon(obj->_x,obj->_y,obj->_theta,obj->_color,
                               pointVect.getSize(),x,y,
                               context->getInteger(1)));
  delete []x;
  delete []y;
  }
}

// native void Object2d::circle(float radius,bool filled);
//
void Object2d::circle(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
obj->setShape(Object2d::CIRCLE,
              new GuiCircle(obj->_x,obj->_y,obj->_theta,obj->_color,
                            context->getReal(0),
                            context->getInteger(1)));
}

// native void Object2d::image(string fileName,float pixelScale);
//
void Object2d::image(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
GuiImage * shape=new GuiImage(obj->_x,obj->_y,obj->_theta,obj->_color,
                              context->getStrings(0),
                              &getSimul()->getPathVect(),
                              context->getReal(1));
if(shape->fail()) delete shape;
else obj->setShape(Object2d::IMAGE,shape);
}

// native int Object2d::getNbColumns(void);
//
void Object2d::getNbColumns(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  context->returnInteger(((const GuiImage *)obj->_shape)->getNbColumns());
else context->returnInteger(0);
}

// native int Object2d::getNbLines(void);
//
void Object2d::getNbLines(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  context->returnInteger(((const GuiImage *)obj->_shape)->getNbLines());
else context->returnInteger(0);
}

// native string Object2d::getFileName(void);
//
void Object2d::getFileName(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  context->returnStrings(((const GuiImage *)obj->_shape)->getFileName());
else context->returnReal(1.0);
}

// native float Object2d::getPixelScale(void);
//
void Object2d::getPixelScale(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  context->returnReal(((const GuiImage *)obj->_shape)->getScale());
else context->returnReal(1.0);
}

// native int Object2d::getNbColors(void);
//
void Object2d::getNbColors(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  context->returnInteger(((const GuiImage *)obj->_shape)->getNbColors());
else context->returnInteger(0);
}

// native void Object2d::sortColors(void);
//
void Object2d::sortColors(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
if(obj->_shapeType==Object2d::IMAGE)
  ((GuiImage *)obj->_shape)->sortColors();
}

// native int Object2d::getPixel(int x,int y);
//
void Object2d::getPixel(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  {
  const GuiImage * shape=(const GuiImage *)obj->_shape;
  int x=context->getInteger(0);
  int y=context->getInteger(1);
  if((x>=0)&&(x<shape->getNbColumns())&&
     (y>=0)&&(y<shape->getNbLines()))
    context->returnInteger(shape->getPixel(x,y));
  else context->returnInteger(-1);
  }
else context->returnInteger(-1);
}

// native void Object2d::setPixel(int x,int y,int color);
//
void Object2d::setPixel(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
if(obj->_shapeType==Object2d::IMAGE)
  {
  GuiImage * shape=(GuiImage *)obj->_shape;
  int x=context->getInteger(0);
  int y=context->getInteger(1);
  if((x>=0)&&(x<shape->getNbColumns())&&
     (y>=0)&&(y<shape->getNbLines()))
    {
    int color=context->getInteger(2);
    if(color>=shape->getNbColors()) color=shape->getNbColors()-1;
    else if(color<0) color=0;
    shape->setPixel(x,y,color);
    }
  }
}
 
// native int Object2d::getPixelAt(float x,float y);
//
void Object2d::getPixelAt(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  {
  const GuiImage * shape=(const GuiImage *)obj->_shape;
  double xx=context->getReal(0)-obj->_x;
  double yy=context->getReal(1)-obj->_y;
  double sinTh=::sin(obj->_theta);
  double cosTh=::cos(obj->_theta);
  int x=(int)::floor(shape->getNbColumns()*0.5+
                     (xx*cosTh+yy*sinTh)/shape->getScale());
  int y=(int)::floor(shape->getNbLines()*0.5+
                     (yy*cosTh-xx*sinTh)/shape->getScale());
  if((x>=0)&&(x<shape->getNbColumns())&&
     (y>=0)&&(y<shape->getNbLines()))
    context->returnInteger(shape->getPixel(x,y));
  else context->returnInteger(-1);
  }
else context->returnInteger(-1);
}

// native void Object2d::setPixelAt(float x,float y,int color);
//
void Object2d::setPixelAt(Context * context) // static
{
Object2d * obj=(Object2d *)context->accessOwner();
if(obj->_shapeType==Object2d::IMAGE)
  {
  GuiImage * shape=(GuiImage *)obj->_shape;
  double xx=context->getReal(0)-obj->_x;
  double yy=context->getReal(1)-obj->_y;
  double sinTh=::sin(obj->_theta);
  double cosTh=::cos(obj->_theta);
  int x=(int)::floor(shape->getNbColumns()*0.5+
                     (xx*cosTh+yy*sinTh)/shape->getScale());
  int y=(int)::floor(shape->getNbLines()*0.5+
                     (yy*cosTh-xx*sinTh)/shape->getScale());
  if((x>=0)&&(x<shape->getNbColumns())&&
     (y>=0)&&(y<shape->getNbLines()))
    {
    int color=context->getInteger(2);
    if(color>=shape->getNbColors()) color=shape->getNbColors()-1;
    else if(color<0) color=0;
    shape->setPixel(x,y,color);
    }
  }
}

// native void Object2d::getRGB(int pixel,int & r,int & g,int & b);
//
void Object2d::getRGB(Context * context) // static
{
const Object2d * obj=(const Object2d *)context->getOwner();
if(obj->_shapeType==Object2d::IMAGE)
  {
  const GuiImage * shape=(const GuiImage *)obj->_shape;
  int color=context->getInteger(0);
  if(color>=shape->getNbColors()) color=shape->getNbColors()-1;
  else if(color<0) color=0;
  unsigned char r,g,b;
  shape->getRGB(color,r,g,b);
  context->setInteger(1,r);
  context->setInteger(2,g);
  context->setInteger(3,b);
  }
}

//--------------------------------------------------------------------------//
// class Object2d                                                           //
//--------------------------------------------------------------------------//

Word Object2d::_guiViewer2dWord(Word::create("GuiViewer2d")); // static
Word Object2d::_locationWord(Word::create("location"));       // static
Word Object2d::_containerWord(Word::create("_container"));    // static
Word Object2d::_contentWord(Word::create("_content"));        // static
Word Object2d::_keyPressWord(Word::create("keyPress"));       // static
Word Object2d::_mouseDragWord(Word::create("mouseDrag"));     // static
Word Object2d::_onSelectWord(Word::create("onSelect"));       // static
Word Object2d::_onUnselectWord(Word::create("onUnselect"));   // static

Object2d::Object2d(Model * model,int instNum)
 : Agent(model,instNum),
   _locValue((Value *)0), _supValue((Value *)0), _subsValue((Value *)0),
   _locCB(new Obj2dCB(this,&Object2d::beforeLoc,&Object2d::afterLoc)),
   _oldX(0.0), _oldY(0.0), _oldT(0.0),
   _x(0.0), _y(0.0), _theta(0.0),
   _shape((GuiShape2D *)0), _shapeType(Object2d::NOSHAPE),
   _layer(0), _color("white")
{
_locValue=accessAttribute(_locationWord)->accessValue();
_supValue=accessAttribute(_containerWord)->accessValue();
_subsValue=accessAttribute(_contentWord)->accessValue();
for(int i=3;i--;) // the location vector must contain 3 floats
  {
  _locValue->pushBack(SubValue::getSubValue(ValueType(ValueType::REAL),
                                            _locValue));
  }
writeLocation();
_locCB->connect((AttrValue *)_locValue);
}

Object2d::~Object2d(void)
{
delete _locCB;
if(_shape) delete _shape;
}

Strings Object2d::userSave(int column) const // virtual
{
Strings str;
int i;
for(i=0;i<column;i++) str+=" ";
str+=getName().print()+"->setLocation("+
     Strings(_x)+","+Strings(_y)+","+Strings(_theta)+");\n";
if(_layer)
  {
  for(i=0;i<column;i++) str+=" ";
  str+=getName().print()+"->setLayer("+Strings(_layer)+");\n";
  }
if(_shape)
  {
  for(i=0;i<column;i++) str+=" ";
  str+=getName().print()+"->"+_shape->print()+";\n";
  }
return(str);
}

void Object2d::setShape(Object2d::ShapeType shapeType,GuiShape2D * shape)
{
SimpleVector<GuiViewer2D *> selection;                   // save selection
if(_shape)
  {
  Model * viewerModel=getSimul()->accessModel(_guiViewer2dWord);
  OGuiViewer2d * viewer;
  GuiViewer2D * view;
  AgentMap::iterator it=viewerModel->accessAgentMap().begin();
  for(;it!=viewerModel->accessAgentMap().end();it++)
    {
    viewer=(OGuiViewer2d *)(*it).second;
    view=(GuiViewer2D *)viewer->accessElem();
    if(view->isSelected(_shape)) selection.pushBack(view);
    }
  if(shape) _shape->setSelectCallback((void (*)(GuiShape2D *,GuiViewer2D *,
                                                bool,void *))0); // avoid CB
  delete _shape;
  }
_shape=shape;
_shapeType=shapeType;
if(_shape)
  {
  for(int i=selection.getSize();i--;) // restore selection
    selection[i]->select(_shape,false);
  if(_layer) _shape->setLayer(_layer);
  _shape->setKeyCallback(keyNotify,this);
  _shape->setMotionCallback(motionNotify,this);
  _shape->setSelectCallback(selectNotify,this);
  }
}

void Object2d::writeLocation(void)
{
if(_locValue->preset())
  {
  _locValue->accessElem(0)->setReal(_x);
  _locValue->accessElem(1)->setReal(_y);
  _locValue->accessElem(2)->setReal(_theta);
  _locValue->postset();
  }
}

void Object2d::beforeLoc(void)
{
if(_locValue->getLen()==3)
  {
  _oldX=_locValue->getElem(0).getReal();
  _oldY=_locValue->getElem(1).getReal();
  _oldT=_locValue->getElem(2).getReal();
  }
else
  {
  Strings message="Attribute 'location' of '"+
                  getName().print()+
                  "' must contain 3 'float'";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

void Object2d::afterLoc(void)
{
if(_locValue->getLen()==3)
  {
  _x=_locValue->getElem(0).getReal();
  _y=_locValue->getElem(1).getReal();
  _theta=_locValue->getElem(2).getReal();
  if(_subsValue->getLen())
    {
    Object2d * obj;
    double dx,dy,dTheta,a,d;
    Value * tmp=TmpValue::getTmpValue(_subsValue->getType());
    *tmp=*_subsValue;
    while(tmp->getLen())
      {
      for(int i=_subsValue->getLen();i--;)
        {
        obj=(Object2d *)_subsValue->accessElem(i)->getAgent();
        if(obj==tmp->getBack().getAgent())
          {
          obj->_x+=_x-_oldX;
          obj->_y+=_y-_oldY;
          dx=obj->_x-_x;
          dy=obj->_y-_y;
          dTheta=_theta-_oldT;
          Simulator::cartToPol(d,a,dx,dy);
          Simulator::polToCart(dx,dy,d,a+dTheta);
          obj->_x=_x+dx;
          obj->_y=_y+dy;
          obj->_theta=Simulator::betweenPi(obj->_theta+dTheta);
          if(obj->_shape) obj->_shape->move(obj->_x,obj->_y,obj->_theta);
          obj->writeLocation();
          break;
          }
        }
      tmp->popBack();
      }
    tmp->relax();
    }
  if(_shape) _shape->move(_x,_y,_theta);
  }
else
  {
  Strings message="Attribute 'location' of '"+
                  getName().print()+
                  "' must contain 3 'float'";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

bool Object2d::isAttachedTo(const Object2d * obj) const
{
const Object2d * sup=(Object2d *)_supValue->getAgent();
if(sup==obj) return(true);
if(sup) return(sup->isAttachedTo(obj));
return(false);
}

void Object2d::getContent(Value & result,Model * model,bool recursive)
{
Object2d * obj;
for(int i=_subsValue->getLen();i--;)
  {
  obj=(Object2d *)_subsValue->accessElem(i)->getAgent();
  if(obj&&obj->getModel()->isA(model))
    {
    result.pushBack(SubValue::getSubValue(ValueType(obj->accessModel()),
                                          &result));
    result.accessBack()->setAgent(obj);
    if(recursive) obj->getContent(result,model,true);
    }
  }
}

void Object2d::keyNotify(GuiShape2D *,const Strings & key,void * data)
{                                                                   // static
Object2d * obj=(Object2d *)data;
ExecModule * module=obj->accessModule(_keyPressWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  Execution * initExec=Execution::getExecution(obj,ExecModule::NORMAL);
  Value * value=TmpValue::getTmpValue(ValueType(ValueType::STRING));
  value->setStrings(key);
  initExec->pushValue(value);
  getSimul()->executeModule(module,obj,initExec);
  Execution::relaxExecution(initExec);
  }
}

void Object2d::motionNotify(GuiShape2D *,double dx,double dy,void * data)
{                                                                    // static
Object2d * obj=(Object2d *)data;
ExecModule * module=obj->accessModule(_mouseDragWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  Execution * initExec=Execution::getExecution(obj,ExecModule::NORMAL);
  Value * value=TmpValue::getTmpValue(ValueType(ValueType::REAL));
  value->setReal(dy);
  initExec->pushValue(value);
  value=TmpValue::getTmpValue(ValueType(ValueType::REAL));
  value->setReal(dx);
  initExec->pushValue(value);
  getSimul()->executeModule(module,obj,initExec);
  Execution::relaxExecution(initExec);
  }
}

void Object2d::selectNotify(GuiShape2D *,GuiViewer2D * viewer,
                            bool selected,void * data) // static
{
if(getSimul()->isBad()) return;
Object2d * obj=(Object2d *)data;
Model * objectModel=getSimul()->accessModel(::object2dWord);
AgentMap::iterator it=objectModel->accessAgentMap().begin();
for(;it!=objectModel->accessAgentMap().end();it++)
  if((Object2d *)(*it).second==obj) break;
if(it==objectModel->accessAgentMap().end()) return; // obj has been destroyed
ExecModule * module=obj->accessModule(selected ? _onSelectWord
                                               : _onUnselectWord);
if(module->getType()==ExecModule::PROTOTYPE) return;
Model * viewerModel=getSimul()->accessModel(_guiViewer2dWord);
OGuiViewer2d * viewerObj=(OGuiViewer2d *)0;
for(it=viewerModel->accessAgentMap().begin();
    it!=viewerModel->accessAgentMap().end();it++)
  {
  if(((OGuiViewer2d *)(*it).second)->getElem()==viewer)
    {
    viewerObj=(OGuiViewer2d *)(*it).second;
    break;
    }
  }
if(!viewerObj) return;
Execution * initExec=Execution::getExecution(obj,ExecModule::NORMAL);
Value * value=TmpValue::getTmpValue(ValueType(viewerObj->accessModel()));
value->setAgent(viewerObj);
initExec->pushValue(value);
getSimul()->executeModule(module,obj,initExec);
Execution::relaxExecution(initExec);
}

#endif // X_GUI || W_GUI

