// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : obj3dPkg.cpp                                               //
// description : source file for the ENIB/LI2 oRis package object3d.pkg     //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#if defined(X_GUI) || defined(W_GUI)
#ifdef OPEN_GL

#include "Object3d/obj3dPkg.h"
#include "Gui/guiPkg.h"
#include "oRis/Main/simul.h"
#include "oRis/Main/tmpVal.h"
#include "oRis/Main/context.h"
#include "oRis/Main/errors.h"
#include "Utility/stlList.h"

#include <stdio.h>

#ifndef __MSDOS__
#define EXPORT_PREFIX extern "C"
#else
#include <windows.h>
#define EXPORT_PREFIX extern "C" __declspec(dllexport)
#define openingLibrary    openingObj3dLibrary
#define closingLibrary    closingObj3dLibrary
#define getExternFunction getExternObj3dFunction
#define getNewAgent       getNewObj3dAgent
#endif
 
//--------------------------------------------------------------------------//
// Opening and closing the library                                          //
//--------------------------------------------------------------------------//
 
EXPORT_PREFIX void openingLibrary(void)
{
  // nothing to do
}
 
EXPORT_PREFIX void closingLibrary(void)
{
  // nothing to do
}

//--------------------------------------------------------------------------//
// LookUp table for functions                                               //
//--------------------------------------------------------------------------//

EXPORT_PREFIX ExternFunction getExternFunction(const Strings & name)
{
if(name==Strings("Object3d::isSelectedIn()")) return(Object3d::isSelectedIn);
if(name==Strings("Object3d::getPosition()"))  return(Object3d::getPosition);
if(name==Strings("Object3d::globalToLocalPosition()"))
                                      return(Object3d::globalToLocalPosition);
if(name==Strings("Object3d::localToGlobalPosition()"))
                                      return(Object3d::localToGlobalPosition);
if(name==Strings("Object3d::getOrientation()"))
                                              return(Object3d::getOrientation);
if(name==Strings("Object3d::globalToLocalOrientation()"))
                                    return(Object3d::globalToLocalOrientation);
if(name==Strings("Object3d::localToGlobalOrientation()"))
                                    return(Object3d::localToGlobalOrientation);
if(name==Strings("Object3d::getLocalBoundingBox()"))
                                    return(Object3d::getLocalBoundingBox);
if(name==Strings("Object3d::getGlobalBoundingBox()"))
                                    return(Object3d::getGlobalBoundingBox);
if(name==Strings("Object3d::getNbPoints()"))  return(Object3d::getNbPoints);
if(name==Strings("Object3d::getNbTriangles()"))
                                    return(Object3d::getNbTriangles);
if(name==Strings("Object3d::setPosition()"))  return(Object3d::setPosition);
if(name==Strings("Object3d::cancelRotation()"))
                                    return(Object3d::cancelRotation);
if(name==Strings("Object3d::setOrientation()"))
                                              return(Object3d::setOrientation);
if(name==Strings("Object3d::translate()"))    return(Object3d::translate);
if(name==Strings("Object3d::roll()"))         return(Object3d::roll);
if(name==Strings("Object3d::pitch()"))        return(Object3d::pitch);
if(name==Strings("Object3d::yaw()"))          return(Object3d::yaw);
if(name==Strings("Object3d::isAttachedTo()"))
                                    return(Object3d::stIsAttachedTo);
if(name==Strings("Object3d::getContent()"))   return(Object3d::stGetContent);
if(name==Strings("Object3d::viewFirst()"))    return(Object3d::viewFirst);
if(name==Strings("Object3d::view()"))         return(Object3d::view);
if(name==Strings("Object3d::throwRay()"))     return(Object3d::throwRay);
if(name==Strings("Object3d::intersectRay()")) return(Object3d::intersectRay);
if(name==Strings("Object3d::inside()"))       return(Object3d::inside);
if(name==Strings("Object3d::readShape()"))    return(Object3d::readShape);

if(name==Strings("Shape3d::getPoints()"))     return(Shape3d::stGetPoints);
if(name==Strings("Shape3d::addPoints()"))     return(Shape3d::addPoints);
if(name==Strings("Shape3d::erasePoints()"))   return(Shape3d::erasePoints);
if(name==Strings("Shape3d::getTriangles()"))  return(Shape3d::getTriangles);
if(name==Strings("Shape3d::addTriangles()"))  return(Shape3d::addTriangles);
if(name==Strings("Shape3d::eraseTriangles()"))
                                              return(Shape3d::eraseTriangles);
if(name==Strings("Shape3d::addCube()"))       return(Shape3d::addCube);
if(name==Strings("Shape3d::addCone()"))       return(Shape3d::addCone);
if(name==Strings("Shape3d::addCylinder()"))   return(Shape3d::addCylinder);
if(name==Strings("Shape3d::addTube()"))       return(Shape3d::addTube);
if(name==Strings("Shape3d::addSquareTube()")) return(Shape3d::addSquareTube);
if(name==Strings("Shape3d::addSphere()"))     return(Shape3d::addSphere);
if(name==Strings("Shape3d::addGeode()"))      return(Shape3d::addGeode);
if(name==Strings("Shape3d::addText()"))       return(Shape3d::addText);
if(name==Strings("Shape3d::erase()"))         return(Shape3d::erase);
if(name==Strings("Shape3d::addShape()"))      return(Shape3d::addShape);
if(name==Strings("Shape3d::setColor()"))      return(Shape3d::setColor);
if(name==Strings("Shape3d::setTexture()"))    return(Shape3d::setTexture);
if(name==Strings("Shape3d::setCubeTexture()"))
                                              return(Shape3d::setCubeTexture);
if(name==Strings("Shape3d::mapTexture()"))    return(Shape3d::mapTexture);
if(name==Strings("Shape3d::reverseTriangles()"))
                                             return(Shape3d::reverseTriangles);
if(name==Strings("Shape3d::translatePoints()"))
                                              return(Shape3d::translatePoints);
if(name==Strings("Shape3d::rollPoints()"))    return(Shape3d::rollPoints);
if(name==Strings("Shape3d::pitchPoints()"))   return(Shape3d::pitchPoints);
if(name==Strings("Shape3d::yawPoints()"))     return(Shape3d::yawPoints);
if(name==Strings("Shape3d::scalePoints()"))   return(Shape3d::scalePoints);

return((ExternFunction)0); // not found
}

//--------------------------------------------------------------------------//
// LookUp table for agents                                                  //
//--------------------------------------------------------------------------//

static Word object3dWord(Word::create("Object3d"));
static Word shape3dWord(Word::create("Shape3d"));

EXPORT_PREFIX Agent * getNewAgent(Model * model,long instNum)
{
if(model->isA(::object3dWord)) return(new Object3d(model,instNum));
if(model->isA(::shape3dWord))  return(new Shape3d(model,instNum));
return((Agent *)0); // not found
}

//--------------------------------------------------------------------------//
// Object3d functions                                                       //
//--------------------------------------------------------------------------//

// native GuiViewer3d[] Object3d::isSelectedIn(void);
//
void Object3d::isSelectedIn(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
Model * viewerModel=getSimul()->accessModel(_guiViewer3dWord);
Value * result=TmpValue::getTmpValue(ValueType(viewerModel,1));
SubValueVect * vect=SubValue::getSubValueVect();
OGuiViewer3d * viewer;
AgentMap::iterator it=viewerModel->accessAgentMap().begin();
for(;it!=viewerModel->accessAgentMap().end();it++)
  {
  viewer=(OGuiViewer3d *)(*it).second;
  if(((const GuiViewer3D *)viewer->getElem())->isSelected(obj->_shape))
    {
    vect->pushBack(SubValue::getSubValue(viewer->accessModel(),result));
    vect->accessBack()->setAgent(viewer);
    }
  }
result->setValueVector(vect);
context->returnValue(result);
}

// native void Object3d::getPosition(float & x,float & y,float & z);
//
void Object3d::getPosition(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double x,y,z;
obj->_shape->getPosition(x,y,z);
context->setReal(0,x);
context->setReal(1,y);
context->setReal(2,z);
}

// native void Object3d::globalToLocalPosition(float & x,float & y,float & z);
//
void Object3d::globalToLocalPosition(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double x=context->getReal(0);
double y=context->getReal(1);
double z=context->getReal(2);
obj->_shape->globalToLocalPosition(x,y,z);
context->setReal(0,x);
context->setReal(1,y);
context->setReal(2,z);
}

// native void Object3d::localToGlobalPosition(float & x,float & y,float & z);
//
void Object3d::localToGlobalPosition(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double x=context->getReal(0);
double y=context->getReal(1);
double z=context->getReal(2);
obj->_shape->localToGlobalPosition(x,y,z);
context->setReal(0,x);
context->setReal(1,y);
context->setReal(2,z);
}

// native void Object3d::getOrientation(float & roll,float & pitch,
//                                      float & yaw);
//
void Object3d::getOrientation(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double roll,pitch,yaw;
obj->_shape->getOrientation(roll,pitch,yaw);
context->setReal(0,roll);
context->setReal(1,pitch);
context->setReal(2,yaw);
}

// native void Object3d::globalToLocalOrientation(float & roll,
//                                                float & pitch,float & yaw);
//
void Object3d::globalToLocalOrientation(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double roll=context->getReal(0);
double pitch=context->getReal(1);
double yaw=context->getReal(2);
obj->_shape->globalToLocalOrientation(roll,pitch,yaw);
context->setReal(0,roll);
context->setReal(1,pitch);
context->setReal(2,yaw);
}

// native void Object3d::localToGlobalOrientation(float & roll,
//                                                float & pitch,float & yaw);
//
void Object3d::localToGlobalOrientation(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double roll=context->getReal(0);
double pitch=context->getReal(1);
double yaw=context->getReal(2);
obj->_shape->localToGlobalOrientation(roll,pitch,yaw);
context->setReal(0,roll);
context->setReal(1,pitch);
context->setReal(2,yaw);
}

// native bool Object3d::getLocalBoundingBox(
//                       float & xmin,float & ymin,float & zmin,
//                       float & xmax,float & ymax,float & zmax);
//
void Object3d::getLocalBoundingBox(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double xmin,ymin,zmin,xmax,ymax,zmax;
if(obj->_shape->getLocalBoundingBox(xmin,ymin,zmin,xmax,ymax,zmax))
  {
  context->setReal(0,xmin);
  context->setReal(1,ymin);
  context->setReal(2,zmin);
  context->setReal(3,xmax);
  context->setReal(4,ymax);
  context->setReal(5,zmax);
  context->returnInteger(1);
  }
else context->returnInteger(0);
}

// native bool Object3d::getGlobalBoundingBox(
//                       float & xmin,float & ymin,float & zmin,
//                       float & xmax,float & ymax,float & zmax);
//
void Object3d::getGlobalBoundingBox(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
double xmin,ymin,zmin,xmax,ymax,zmax;
if(obj->_shape->getGlobalBoundingBox(xmin,ymin,zmin,xmax,ymax,zmax))
  {
  context->setReal(0,xmin);
  context->setReal(1,ymin);
  context->setReal(2,zmin);
  context->setReal(3,xmax);
  context->setReal(4,ymax);
  context->setReal(5,zmax);
  context->returnInteger(1);
  }
else context->returnInteger(0);
}

// native int Object3d::getNbPoints(void);
//
void Object3d::getNbPoints(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
context->returnInteger(obj->_shape->getPoints().size());
}

// native int Object3d::getNbTriangles(void);
//
void Object3d::getNbTriangles(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
context->returnInteger(obj->_shape->getFaces().size());
}

// native void Object3d::setPosition(float x,float y,float theta);
//
void Object3d::setPosition(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->setPosition(context->getReal(0),
                         context->getReal(1),
                         context->getReal(2));
obj->writeLocation();
}

// native void Object3d::cancelRotation(void);
//
void Object3d::cancelRotation(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->cancelRotation();
obj->writeLocation();
}

// native void Object3d::setOrientation(float roll,float pitch,float yaw);
//
void Object3d::setOrientation(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->setOrientation(context->getReal(0),
                            context->getReal(1),
                            context->getReal(2));
obj->writeLocation();
}

// native void Object3d::translate(float dx,float dy,float dz);
//
void Object3d::translate(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->translate(context->getReal(0),
                       context->getReal(1),
                       context->getReal(2));
obj->writeLocation();
}

// native void Object3d::roll(float dRoll);
//
void Object3d::roll(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->roll(context->getReal(0));
obj->writeLocation();
}

// native void Object3d::pitch(float dPitch);
//
void Object3d::pitch(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->pitch(context->getReal(0));
obj->writeLocation();
}

// native void Object3d::yaw(float dYaw);
//
void Object3d::yaw(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
obj->_shape->yaw(context->getReal(0));
obj->writeLocation();
}

// native bool Object3d::isAttachedTo(Object3d container)
//
void Object3d::stIsAttachedTo(Context * context) // static
{
const Object3d * obj=(const Object3d *)context->getOwner();
context->returnInteger(obj->isAttachedTo((const Object3d *)
                                         context->getAgent(0)));
}

// native void Object3d::getContent(string className,bool recursive)
//
void Object3d::stGetContent(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
Model * model;
if(context->getStrings(0).len())
  model=getSimul()->accessModel(Word::create(context->getStrings(0)));
else model=getSimul()->accessModel(::object3dWord);
if(model)
  {
  Value * result=TmpValue::getTmpValue(ValueType(model,1));
  obj->getContent(*result,model,context->getInteger(1));
  context->returnValue(result);
  }
else
  {
  Value * result=TmpValue::getTmpValue(context->getModule()->getResultType());
  context->returnValue(result);
  }
}

// native Object3d Object3d::viewFirst(float & xyAngle,float & zAngle,
//                                     float & distance,string className,
//                                     float xyVision,float zVision,
//                                     float range);
//
void Object3d::viewFirst(Context * context) // static
{
Word modelName(Word::create(context->getStrings(3)));
const AgentMap * m=(const AgentMap *)0;
Model * model=(Model *)0;
if(modelName.getStrings().len())
  {
  model=getSimul()->accessModel(modelName);
  if(model&&model->isA(::object3dWord))
    m=&model->getAgentMap();
  }
else
  {
  model=getSimul()->accessModel(::object3dWord);
  if(model) m=&model->getAgentMap(); // all visible agents
  }
if(m)
  {
  double xyV2=context->getReal(4);
  xyV2=(xyV2 ? xyV2/2.0 : Constant_PI);
  double zV2=context->getReal(5);
  zV2=(zV2 ? zV2/2.0 : Constant_PI_2);
  double range=context->getReal(6);
  range*=range;
  const GuiShape3D * shape=((const Object3d *)context->getOwner())->_shape;
  double x,y,z;
  double dxy,d,xyAngle=0.0,zAngle=0.0;
  const Object3d * obj;
  bool firstTime=true;
  double dMin=0.0;
  double xyMin=0.0;
  double zMin=0.0;
  const Object3d * objMin=(const Object3d *)0;
  AgentMap::const_iterator i=m->begin();
  for(;!(i==m->end());i++)
    {
    obj=(const Object3d *)(*i).second;
    if(obj!=context->getOwner())
      {
      obj->_shape->getPosition(x,y,z);
      shape->globalToLocalPosition(x,y,z);
      d=x*x+y*y+z*z;
      if((!range||d<range)&&(firstTime||d<dMin))
        {
        xyAngle=Simulator::cartToAngle(x,y);
        if(::fabs(xyAngle)<=xyV2)
          {
          dxy=::sqrt(x*x+y*y);
          zAngle=Simulator::cartToAngle(dxy,z);
          if(::fabs(zAngle)<=zV2)
            {
            dMin=d;
            xyMin=xyAngle;
            zMin=zAngle;
            objMin=obj;
            firstTime=false;
            }
          }
        }
      }
    }
  if(firstTime) // no agent found
    {
    context->setReal(0,0.0);
    context->setReal(1,0.0);
    context->setReal(2,0.0);
    context->returnAgent((Agent *)0,model);
    }
  else
    {
    context->setReal(0,xyMin);
    context->setReal(1,zMin);
    context->setReal(2,::sqrt(dMin));
    context->returnAgent((Agent *)objMin,((Agent *)objMin)->accessModel());
    }
  }
else
  {
  context->setReal(0,0.0);
  context->setReal(1,0.0);
  context->setReal(2,0.0);
  context->returnAgent((Agent *)0,context->getModule()
                                         ->getResultType().getModel());
  }
}

// native Object3d[] Object3d::view(float[] & xyAngle,float[] & zAngle,
//                                  float[] & distance,string className,
//                                  float xyVision,float zVision,
//                                  float range);
//
void Object3d::view(Context * context) // static
{
SubValueVect * xyVect=SubValue::getSubValueVect();
SubValueVect * zVect=SubValue::getSubValueVect();
SubValueVect * distVect=SubValue::getSubValueVect();
SubValueVect * agtVect=SubValue::getSubValueVect();
Word modelName(Word::create(context->getStrings(3)));
const AgentMap * m=(const AgentMap *)0;
Model * model=(Model *)0;
if(modelName.getStrings().len())
  {
  model=getSimul()->accessModel(modelName);
  if(model&&model->isA(::object3dWord))
    m=&model->getAgentMap();
  }
else
  {
  model=getSimul()->accessModel(::object3dWord);
  if(model) m=&model->getAgentMap(); // all visible agents
  }
if(m)
  {
  Value * result=TmpValue::getTmpValue(ValueType(model,1));
  double xyV2=context->getReal(4);
  xyV2=(xyV2 ? xyV2/2.0 : Constant_PI);
  double zV2=context->getReal(5);
  zV2=(zV2 ? zV2/2.0 : Constant_PI);
  double range=context->getReal(6);
  range*=range;
  const GuiShape3D * shape=((const Object3d *)context->getOwner())->_shape;
  double x,y,z;
  double dxy,d,xyAngle,zAngle;
  const Object3d * obj;
  int j;
  int nbFound=0;
  SubValue * value;
  StlList<SubValue *> agtList;
  StlList<SubValue *> distList;
  StlList<SubValue *> xyList;
  StlList<SubValue *> zList;
  StlList<SubValue *>::iterator agtIter;
  StlList<SubValue *>::iterator distIter;
  StlList<SubValue *>::iterator xyIter;
  StlList<SubValue *>::iterator zIter;
  AgentMap::const_iterator i=m->begin();
  for(;!(i==m->end());i++)
    {
    obj=(const Object3d *)(*i).second;
    if(obj!=context->getOwner())
      {
      obj->_shape->getPosition(x,y,z);
      shape->globalToLocalPosition(x,y,z);
      d=x*x+y*y+z*z;
      if(!range||d<range)
        {
        xyAngle=Simulator::cartToAngle(x,y);
        if(::fabs(xyAngle)<=xyV2)
          {
          dxy=::sqrt(x*x+y*y);
          zAngle=Simulator::cartToAngle(dxy,z);
          if(::fabs(zAngle)<=zV2)
            {
            agtIter=agtList.begin();
            distIter=distList.begin();
            xyIter=xyList.begin();
            zIter=zList.begin();
            d=::sqrt(d);
            for(j=0;j<nbFound;j++)
              {
              if(d<(*distIter)->getReal()) break; // insert here
              else
                {
                agtIter++;
                distIter++;
                xyIter++;
                zIter++;
                }
              }
            value=SubValue::getSubValue(
                            ValueType(((Agent *)obj)->accessModel()),result);
            value->setAgent((Agent *)obj);
            agtList.insert(agtIter,value);
            value=SubValue::getSubValue(ValueType(ValueType::REAL),
                                        context->accessLocal(2));
            value->setReal(d);
            distList.insert(distIter,value);
            value=SubValue::getSubValue(ValueType(ValueType::REAL),
                                        context->accessLocal(1));
            value->setReal(zAngle);
            zList.insert(zIter,value);
            value=SubValue::getSubValue(ValueType(ValueType::REAL),
                                        context->accessLocal(0));
            value->setReal(xyAngle);
            xyList.insert(xyIter,value);
            nbFound++;
            }
          }
        }
      }
    }
  agtVect->resizeIfNeeded(nbFound);
  distVect->resizeIfNeeded(nbFound);
  xyVect->resizeIfNeeded(nbFound);
  zVect->resizeIfNeeded(nbFound);
  agtIter=agtList.begin();
  distIter=distList.begin();
  xyIter=xyList.begin();
  zIter=zList.begin();
  for(j=0;j<nbFound;j++,agtIter++,distIter++,xyIter++,zIter++)
    {
    agtVect->pushBack(*agtIter);
    distVect->pushBack(*distIter);
    xyVect->pushBack(*xyIter);
    zVect->pushBack(*zIter);
    }
  context->setValueVector(0,xyVect,ValueType(ValueType::REAL,1));
  context->setValueVector(1,zVect,ValueType(ValueType::REAL,1));
  context->setValueVector(2,distVect,ValueType(ValueType::REAL,1));
  result->setValueVector(agtVect);
  context->returnValue(result);
  }
else
  {
  context->setValueVector(0,xyVect,ValueType(ValueType::REAL,1));
  context->setValueVector(1,zVect,ValueType(ValueType::REAL,1));
  context->setValueVector(2,distVect,ValueType(ValueType::REAL,1));
  Value * result=TmpValue::getTmpValue(context->getModule()->getResultType());
  result->setValueVector(agtVect);
  context->returnValue(result);
  }
}

// native Object3d Object3d::throwRay(float & xInter,float & yInter,
//                                    float & zInter,int & faceNumber,
//                                    string className);
//
void Object3d::throwRay(Context * context) // static
{
Word modelName(Word::create(context->getStrings(4)));
AgentMap * m=(AgentMap *)0;
Model * model=(Model *)0;
if(modelName.getStrings().len())
  {
  model=getSimul()->accessModel(modelName);
  if(model&&model->isA(::object3dWord))
    m=&model->accessAgentMap();
  }
else
  {
  model=getSimul()->accessModel(::object3dWord);
  if(model) m=&model->accessAgentMap(); // all visible agents
  }
double xInter=0.0,yInter=0.0,zInter=0.0;
int faceInter=-1;
Object3d * found=(Object3d *)0;
if(m)
  {
  Object3d * obj=(Object3d *)context->accessOwner();
  Object3d * other;
  double xRay,yRay,zRay;
  obj->_shape->getPosition(xRay,yRay,zRay);
  double xDir=1.0,yDir=0.0,zDir=0.0;
  obj->_shape->localToGlobalPosition(xDir,yDir,zDir);
  xDir-=xRay;
  yDir-=yRay;
  zDir-=zRay;
  double x,y,z,dx,dy,dz,d,dmin=0.0;
  int faceNumber;
  AgentMap::iterator i=m->begin();
  for(;!(i==m->end());i++)
    {
    other=(Object3d *)(*i).second;
    if((other!=obj)&&
       other->_shape->intersectRay(xRay,yRay,zRay,xDir,yDir,zDir,
                                   x,y,z,faceNumber))
      {
      dx=x-xRay;
      dy=y-yRay;
      dz=z-zRay;
      d=dx*dx+dy*dy+dz*dz;
      if(!found||(d<dmin))
        {
        dmin=d;
        xInter=x;
        yInter=y;
        zInter=z;
        faceInter=faceNumber;
        found=other;
        }
      }
    }
  }
if(found)
  {
  context->setReal(0,xInter);
  context->setReal(1,yInter);
  context->setReal(2,zInter);
  context->setInteger(3,faceInter);
  context->returnAgent(found,found->accessModel());
  }
else
  context->returnAgent((Agent *)0,context->getModule()
                                         ->getResultType().getModel());
}

// native bool Object3d::intersectRay(float & xInter,float & yInter,
//                                    float & zInter,int & faceNumber,
//                                    float xRay,float yRay,float zRay,
//                                    float yawRay,float pitchRay);
//
void Object3d::intersectRay(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
double xRay=context->getReal(4);
double yRay=context->getReal(5);
double zRay=context->getReal(6);
double yawRay=context->getReal(7);
double pitchRay=context->getReal(8);
double c1=::cos(yawRay);
double s1=::sin(yawRay);
double c2=::cos(pitchRay);
double s2=::sin(pitchRay);
double xInter,yInter,zInter;
int faceNumber;
if(obj->_shape->intersectRay(xRay,yRay,zRay,
                             c1*c2,s1*c2,-s2,
                             xInter,yInter,zInter,faceNumber))
  {
  context->setReal(0,xInter);
  context->setReal(1,yInter);
  context->setReal(2,zInter);
  context->setInteger(3,faceNumber);
  context->returnInteger(1);
  }
else context->returnInteger(0);
}

// native bool Object3d::inside(float x,float y,float z);
//
void Object3d::inside(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
if(obj->_shape->isInside(context->getReal(0),
                         context->getReal(1),
                         context->getReal(2)))
  context->returnInteger(1);
else
  context->returnInteger(0);
}

// native bool Object3d::readShape(Shape3d shaped);
//
void Object3d::readShape(Context * context) // static
{
Object3d * obj=(Object3d *)context->accessOwner();
Shape3d * shape=(Shape3d *)context->getAgent(0);
bool result;
if(shape)
  {
  result=obj->_shape->setShape(shape->getPoints(),
                               shape->getFaces(),
                               shape->getColors(),
                               shape->getTextures(),
                               &getSimul()->getPathVect());
  }
else
  {
  Gui3DPointVect points;
  Gui3DTriangleVect faces;
  Gui3DColorVect colors;
  Gui3DTextureVect textures;
  result=obj->_shape->setShape(points,faces,colors,textures,
                               &getSimul()->getPathVect());
  Model * viewerModel=getSimul()->accessModel(_guiViewer3dWord);
  OGuiViewer3d * viewer;
  AgentMap::iterator it=viewerModel->accessAgentMap().begin();
  for(;it!=viewerModel->accessAgentMap().end();it++)
    {
    viewer=(OGuiViewer3d *)(*it).second;
    ((GuiViewer3D *)viewer->getElem())->unselect(obj->_shape,true);
    }
  }
context->returnInteger(result);
}

//--------------------------------------------------------------------------//
// Shape3d functions                                                        //
//--------------------------------------------------------------------------//

// native float[][] Shape3d::getPoints(void);
//
void Shape3d::stGetPoints(Context * context) // static
{
const Shape3d * shape=(const Shape3d *)context->getOwner();
ValueType resultType(context->getModule()->getResultType());
TmpValue * result=TmpValue::getTmpValue(resultType);
SubValueVect * points=SubValue::getSubValueVect();
for(unsigned int i=0;i<shape->_points.size();i++)
  {
  SubValue * point=SubValue::getSubValue(ValueType(ValueType::REAL,1),result);
  points->pushBack(point);
  SubValueVect * coords=SubValue::getSubValueVect();
  coords->pushBack(SubValue::getSubValue(ValueType(ValueType::REAL),point));
  coords->accessBack()->setReal(shape->_points[i].x);
  coords->pushBack(SubValue::getSubValue(ValueType(ValueType::REAL),point));
  coords->accessBack()->setReal(shape->_points[i].y);
  coords->pushBack(SubValue::getSubValue(ValueType(ValueType::REAL),point));
  coords->accessBack()->setReal(shape->_points[i].z);
  point->setValueVector(coords);
  }
result->setValueVector(points);
context->returnValue(result);
}

// native void Shape3d::addPoints(float[][] newPoints);
//
void Shape3d::addPoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
const SubValueVect * newPoints=context->getValueVector(0);
for(unsigned int i=0;i<newPoints->getSize();i++)
  {
  const SubValueVect * coords=(*newPoints)[i]->getValueVector();
  if(coords->getSize()==3)
    {
    shape->_points.push_back(Gui3DPoint((*coords)[0]->getReal(),
                                        (*coords)[1]->getReal(),
                                        (*coords)[2]->getReal()));
    }
  }
}

// native void Shape3d::erasePoints(void);
//
void Shape3d::erasePoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
shape->_points.erase(shape->_points.begin(),shape->_points.end());
}

// native int[][] Shape3d::getTriangles(void);
//
void Shape3d::getTriangles(Context * context) // static
{
const Shape3d * shape=(const Shape3d *)context->getOwner();
ValueType resultType(context->getModule()->getResultType());
TmpValue * result=TmpValue::getTmpValue(resultType);
SubValueVect * faces=SubValue::getSubValueVect();
for(unsigned int i=0;i<shape->_faces.size();i++)
  {
  SubValue * face=SubValue::getSubValue(ValueType(ValueType::INTEGER,1),
                                        result);
  faces->pushBack(face);
  SubValueVect * points=SubValue::getSubValueVect();
  points->pushBack(SubValue::getSubValue(ValueType(ValueType::INTEGER),face));
  points->accessBack()->setInteger(shape->_faces[i].p1);
  points->pushBack(SubValue::getSubValue(ValueType(ValueType::INTEGER),face));
  points->accessBack()->setInteger(shape->_faces[i].p2);
  points->pushBack(SubValue::getSubValue(ValueType(ValueType::INTEGER),face));
  points->accessBack()->setInteger(shape->_faces[i].p3);
  face->setValueVector(points);
  }
result->setValueVector(faces);
context->returnValue(result);

}

// native void Shape3d::addTriangles(string color,int[][] newTriangles);
//
void Shape3d::addTriangles(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int nbFaces=0;
const SubValueVect * newTriangles=context->getValueVector(1);
for(unsigned int i=0;i<newTriangles->getSize();i++)
  {
  const SubValueVect * points=(*newTriangles)[i]->getValueVector();
  if(points->getSize()==3)
    { 
    shape->_faces.push_back(Gui3DTriangle((*points)[0]->getInteger(),
                                          (*points)[1]->getInteger(),
                                          (*points)[2]->getInteger()));
    nbFaces++;
    }
  }
if(nbFaces);
  {
  shape->_colors.push_back(Gui3DColor(context->getStrings(0),nbFaces));
  }
}

// native void Shape3d::eraseTriangles(void);
//
void Shape3d::eraseTriangles(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
shape->_faces.erase(shape->_faces.begin(),shape->_faces.end());
shape->_colors.erase(shape->_colors.begin(),shape->_colors.end());
}

// native void Shape3d::addCube(string color);
//
void Shape3d::addCube(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildCube(shape->_points,shape->_faces);
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addCone(string color,int precision);
//
void Shape3d::addCone(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildCone(shape->_points,shape->_faces,
                      context->getInteger(1));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addCylinder(string color,int precision);
//
void Shape3d::addCylinder(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildCylinder(shape->_points,shape->_faces,
                          context->getInteger(1));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addTube(string color,int precision,float rate);
//
void Shape3d::addTube(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildTube(shape->_points,shape->_faces,
                      context->getInteger(1),
                      context->getReal(2));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addSquareTube(string color,float rate);
//
void Shape3d::addSquareTube(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildSquareTube(shape->_points,shape->_faces,
                            context->getReal(1));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addSphere(string color,
//                                int zPrecision,int xyPrecision);
//
void Shape3d::addSphere(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildSphere(shape->_points,shape->_faces,
                        context->getInteger(1),context->getInteger(2));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addGeode(string color,int slices,int precision);
//
void Shape3d::addGeode(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildGeode(shape->_points,shape->_faces,
                       context->getInteger(1),
                       context->getInteger(2));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::addText(string color,string text,float spacing);
//
void Shape3d::addText(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int initFaces=shape->_faces.size();
GuiShape3D::buildText(shape->_points,shape->_faces,
                      context->getStrings(1),
                      context->getReal(2));
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()-initFaces));
}

// native void Shape3d::erase(void);
//
void Shape3d::erase(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
shape->_points.erase(shape->_points.begin(),shape->_points.end());
shape->_faces.erase(shape->_faces.begin(),shape->_faces.end());
shape->_colors.erase(shape->_colors.begin(),shape->_colors.end());
shape->_textures.erase(shape->_textures.begin(),shape->_textures.end());
}

// native void Shape3d::addShape(Shape3d shape);
//
void Shape3d::addShape(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
Shape3d * added=(Shape3d *)context->getAgent(0);
if(added)
  {
  int initPoints=shape->_points.size();
  int initFaces=shape->_faces.size();
  int initTextures=shape->_textures.size();
  unsigned int i;
  for(i=0;i<added->_points.size();i++)
    shape->_points.push_back(added->_points[i]);
  for(i=0;i<added->_faces.size();i++)
    shape->_faces.push_back(added->_faces[i]);
  for(i=0;i<added->_colors.size();i++)
    shape->_colors.push_back(added->_colors[i]);
  for(i=0;i<added->_textures.size();i++)
    shape->_textures.push_back(added->_textures[i]);
  for(i=initFaces;i<shape->_faces.size();i++)
    {
    shape->_faces[i].p1+=initPoints;
    shape->_faces[i].p2+=initPoints;
    shape->_faces[i].p3+=initPoints;
    }
  for(i=initTextures;i<shape->_textures.size();i++)
    shape->_textures[i].face+=initFaces;
  }
}

// native void Shape3d::setColor(string color);
//
void Shape3d::setColor(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
shape->_colors.erase(shape->_colors.begin(),shape->_colors.end());
shape->_colors.push_back(Gui3DColor(context->getStrings(0),
                                    shape->_faces.size()));
}

// native void Shape3d::setTexture(string fileName,int face,
//                                 float x1,float y1,
//                                 float x2,float y2,
//                                 float x3,float y3);
//
void Shape3d::setTexture(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
Gui3DTexture texture(context->getStrings(0),
                     context->getInteger(1),
                     context->getReal(2),context->getReal(3),
                     context->getReal(4),context->getReal(5),
                     context->getReal(6),context->getReal(7));
shape->insertTexture(texture);
}

// native void Shape3d::setCubeTexture(string fileName,string where);
//
void Shape3d::setCubeTexture(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
int pos=shape->_faces.size()-12;
if(pos<0) return;
if(!context->getStrings(1).len())
  {
  for(int i=0;i<6;i++)
    {
    shape->insertTexture(Gui3DTexture(context->getStrings(0),
                         pos+2*i,0,1,1,1,1,0));
    shape->insertTexture(Gui3DTexture(context->getStrings(0),
                         pos+1+2*i,0,1,1,0,0,0));
    }
  }
else if(context->getStrings(1)==Strings("x-"))
  {
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+0,0,1,1,1,1,0));
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+1,0,1,1,0,0,0));
  }
else if(context->getStrings(1)==Strings("x+"))
  {
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+2,0,1,1,1,1,0));
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+3,0,1,1,0,0,0));
  }
else if(context->getStrings(1)==Strings("y-"))
  {
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+4,0,1,1,1,1,0));
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+5,0,1,1,0,0,0));
  }
else if(context->getStrings(1)==Strings("y+"))
  {
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+6,0,1,1,1,1,0));
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+7,0,1,1,0,0,0));
  }
else if(context->getStrings(1)==Strings("z-"))
  {
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+8,0,1,1,1,1,0));
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+9,0,1,1,0,0,0));
  }
else if(context->getStrings(1)==Strings("z+"))
  {
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+10,0,1,1,1,1,0));
  shape->insertTexture(Gui3DTexture(context->getStrings(0),
                       pos+11,0,1,1,0,0,0));
  }
}

// native void Shape3d::mapTexture(string fileName,bool halfMap);
//
void Shape3d::mapTexture(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
Bool halfMap=context->getInteger(1);
unsigned int i;
double ymin=0.0,ymax=0.0,zmin=0.0,zmax=0.0;
if(shape->_points.size())
  {
  ymin=ymax=shape->_points.back().y;
  zmin=zmax=shape->_points.back().z;
  for(i=shape->_points.size()-1;i--;)
    {
    if(shape->_points[i].y<ymin) ymin=shape->_points[i].y;
    else if(shape->_points[i].y>ymax) ymax=shape->_points[i].y;
    if(shape->_points[i].z<zmin) zmin=shape->_points[i].z;
    else if(shape->_points[i].z>zmax) zmax=shape->_points[i].z;
    }
  }
double dy=ymax-ymin;
double dz=zmax-zmin;
for(i=shape->_faces.size();i--;)
  {
  double x0=shape->_points[shape->_faces[i].p1].x;
  double y0=shape->_points[shape->_faces[i].p1].y;
  double z0=shape->_points[shape->_faces[i].p1].z;
  double x1=shape->_points[shape->_faces[i].p2].x;
  double y1=shape->_points[shape->_faces[i].p2].y;
  double z1=shape->_points[shape->_faces[i].p2].z;
  double x2=shape->_points[shape->_faces[i].p3].x;
  double y2=shape->_points[shape->_faces[i].p3].y;
  double z2=shape->_points[shape->_faces[i].p3].z;
  if(!halfMap||(x0>=0.0)||(x1>=0.0)||(x2>=0.0))
    {
    if(dy)
      {
      y0=(y0-ymin)/dy;
      y1=(y1-ymin)/dy;
      y2=(y2-ymin)/dy;
      }
    else y0=y1=y2=0.0;
    if(dz)
      {
      z0=1.0-(z0-zmin)/dz;
      z1=1.0-(z1-zmin)/dz;
      z2=1.0-(z2-zmin)/dz;
      }
    else z0=z1=z2=0.0;
    shape->insertTexture(Gui3DTexture(context->getStrings(0),i,
                                      y0,z0,y1,z1,y2,z2));
    }
  }
}

// native void Shape3d::reverseTriangles(void);
//
void Shape3d::reverseTriangles(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
GuiShape3D::reverseFaces(shape->_faces);
}

// native void Shape3d::translatePoints(float dx,float dy,float dz);
//
void Shape3d::translatePoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
GuiShape3D::translatePoints(shape->_points,
                            context->getReal(0),
                            context->getReal(1),
                            context->getReal(2));
}

// native void Shape3d::rollPoints(float roll);
//
void Shape3d::rollPoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
GuiShape3D::rollPoints(shape->_points,context->getReal(0));
}

// native void Shape3d::pitchPoints(float pitch);
//
void Shape3d::pitchPoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
GuiShape3D::pitchPoints(shape->_points,context->getReal(0));
}

// native void Shape3d::yawPoints(float yaw);
//
void Shape3d::yawPoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
GuiShape3D::yawPoints(shape->_points,context->getReal(0));
}

// native void Shape3d::scalePoints(float sx,float sy,float sz);
//
void Shape3d::scalePoints(Context * context) // static
{
Shape3d * shape=(Shape3d *)context->accessOwner();
GuiShape3D::scalePoints(shape->_points,
                        context->getReal(0),
                        context->getReal(1),
                        context->getReal(2));
}


//--------------------------------------------------------------------------//
// class Object3d                                                           //
//--------------------------------------------------------------------------//

Word Object3d::_guiViewer3dWord(Word::create("GuiViewer3d")); // static
Word Object3d::_locationWord(Word::create("location"));       // static
Word Object3d::_containerWord(Word::create("_container"));    // static
Word Object3d::_contentWord(Word::create("_content"));        // static
Word Object3d::_keyPressWord(Word::create("keyPress"));       // static
Word Object3d::_mouseDragWord(Word::create("mouseDrag"));     // static
Word Object3d::_onSelectWord(Word::create("onSelect"));       // static
Word Object3d::_onUnselectWord(Word::create("onUnselect"));   // static

Object3d::Object3d(Model * model,int instNum)
 : Agent(model,instNum),
   _shape(new GuiShape3D),
   _locValue((Value *)0), _supValue((Value *)0), _subsValue((Value *)0),
   _locCB(new Obj3dCB(this,&Object3d::beforeLoc,&Object3d::afterLoc)),
   _oldX(0.0), _oldY(0.0), _oldZ(0.0),
   _oldRoll(0.0), _oldPitch(0.0), _oldYaw(0.0)
{
_locValue=accessAttribute(_locationWord)->accessValue();
_supValue=accessAttribute(_containerWord)->accessValue();
_subsValue=accessAttribute(_contentWord)->accessValue();
for(int i=6;i--;) // the location vector must contain 6 floats
  {
  _locValue->pushBack(SubValue::getSubValue(ValueType(ValueType::REAL),
                                            _locValue));
  }
writeLocation();
_locCB->connect((AttrValue *)_locValue);
_shape->setKeyCallback(keyNotify,this);
_shape->setMotionCallback(motionNotify,this);
_shape->setSelectCallback(selectNotify,this);
}

Object3d::~Object3d(void)
{
delete _locCB;
delete _shape;
}

Strings Object3d::userSave(int /* column */) const // virtual
{
Strings str;
return(str);
}

void Object3d::writeLocation(void)
{
if(_locValue->preset())
  {
  double x,y,z,roll,pitch,yaw;
  _shape->getPosition(x,y,z);
  _shape->getOrientation(roll,pitch,yaw);
  _locValue->accessElem(0)->setReal(x);
  _locValue->accessElem(1)->setReal(y);
  _locValue->accessElem(2)->setReal(z);
  _locValue->accessElem(3)->setReal(roll);
  _locValue->accessElem(4)->setReal(pitch);
  _locValue->accessElem(5)->setReal(yaw);
  _locValue->postset();
  }
}

void Object3d::beforeLoc(void)
{
if(_locValue->getLen()==6)
  {
  _oldX=_locValue->getElem(0).getReal();
  _oldY=_locValue->getElem(1).getReal();
  _oldZ=_locValue->getElem(2).getReal();
  _oldRoll=_locValue->getElem(3).getReal();
  _oldPitch=_locValue->getElem(4).getReal();
  _oldYaw=_locValue->getElem(5).getReal();
  }
else
  {
  Strings message="Attribute 'location' of '"+
                  getName().print()+
                  "' must contain 6 'float'";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

void Object3d::afterLoc(void)
{
if(_locValue->getLen()==6)
  {
  double x=_locValue->getElem(0).getReal();
  double y=_locValue->getElem(1).getReal();
  double z=_locValue->getElem(2).getReal();
  double roll=_locValue->getElem(3).getReal();
  double pitch=_locValue->getElem(4).getReal();
  double yaw=_locValue->getElem(5).getReal();
  if(_subsValue->getLen())
    {
    double dx,dy,dz,dRoll,dPitch,dYaw;
    Object3d * obj;
    Value * tmp=TmpValue::getTmpValue(_subsValue->getType());
    *tmp=*_subsValue;
    _shape->setPosition(_oldX,_oldY,_oldZ);
    _shape->setOrientation(_oldRoll,_oldPitch,_oldYaw);
    while(tmp->getLen())
      {
      for(int i=_subsValue->getLen();i--;)
        {
        obj=(Object3d *)_subsValue->accessElem(i)->getAgent();
        if(obj==tmp->getBack().getAgent())
          {
          obj->_shape->getPosition(dx,dy,dz);
          _shape->globalToLocalPosition(dx,dy,dz);
          obj->_shape->getOrientation(dRoll,dPitch,dYaw);
          _shape->globalToLocalOrientation(dRoll,dPitch,dYaw);
          obj->_shape->setPosition(x,y,z);
          obj->_shape->setOrientation(roll,pitch,yaw);
          obj->_shape->translate(dx,dy,dz);
          obj->_shape->yaw(dYaw);
          obj->_shape->pitch(dPitch);
          obj->_shape->roll(dRoll);
          obj->writeLocation();
          break;
          }
        }
      tmp->popBack();
      }
    tmp->relax();
    }
  _shape->setPosition(x,y,z);
  _shape->setOrientation(roll,pitch,yaw);
  }
else
  {
  Strings message="Attribute 'location' of '"+
                  getName().print()+
                  "' must contain 6 'float'";
  getSimul()->manageError(new Error(Error::RUNTIME,message));
  }
}

bool Object3d::isAttachedTo(const Object3d * obj) const
{
const Object3d * sup=(Object3d *)_supValue->getAgent();
if(sup==obj) return(true);
if(sup) return(sup->isAttachedTo(obj));
return(false);
}

void Object3d::getContent(Value & result,Model * model,bool recursive)
{
Object3d * obj;
for(int i=_subsValue->getLen();i--;)
  {
  obj=(Object3d *)_subsValue->accessElem(i)->getAgent();
  if(obj&&obj->getModel()->isA(model))
    {
    result.pushBack(SubValue::getSubValue(ValueType(obj->accessModel()),
                                          &result));
    result.accessBack()->setAgent(obj);
    if(recursive) obj->getContent(result,model,true);
    }
  }
}

void Object3d::keyNotify(GuiShape3D *,const Strings & key,void * data)
{                                                                   // static
Object3d * obj=(Object3d *)data;
ExecModule * module=obj->accessModule(_keyPressWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  Execution * initExec=Execution::getExecution(obj,ExecModule::NORMAL);
  Value * value=TmpValue::getTmpValue(ValueType(ValueType::STRING));
  value->setStrings(key);
  initExec->pushValue(value);
  getSimul()->executeModule(module,obj,initExec);
  Execution::relaxExecution(initExec);
  }
}

void Object3d::motionNotify(GuiShape3D *,double dx,double dy,double dz,
                            void * data) // static
{
Object3d * obj=(Object3d *)data;
ExecModule * module=obj->accessModule(_mouseDragWord);
if(module->getType()!=ExecModule::PROTOTYPE)
  {
  Execution * initExec=Execution::getExecution(obj,ExecModule::NORMAL);
  Value * value=TmpValue::getTmpValue(ValueType(ValueType::REAL));
  value->setReal(dz);
  initExec->pushValue(value);
  value=TmpValue::getTmpValue(ValueType(ValueType::REAL));
  value->setReal(dy);
  initExec->pushValue(value);
  value=TmpValue::getTmpValue(ValueType(ValueType::REAL));
  value->setReal(dx);
  initExec->pushValue(value);
  getSimul()->executeModule(module,obj,initExec);
  Execution::relaxExecution(initExec);
  }
}

void Object3d::selectNotify(GuiShape3D *,GuiViewer3D * viewer,
                            bool selected,void * data) // static
{
if(getSimul()->isBad()) return;
Object3d * obj=(Object3d *)data;
Model * objectModel=getSimul()->accessModel(::object3dWord);
AgentMap::iterator it=objectModel->accessAgentMap().begin();
for(;it!=objectModel->accessAgentMap().end();it++)
  if((Object3d *)(*it).second==obj) break;
if(it==objectModel->accessAgentMap().end()) return; // obj has been destroyed
ExecModule * module=obj->accessModule(selected ? _onSelectWord
                                               : _onUnselectWord);
if(module->getType()==ExecModule::PROTOTYPE) return;
Model * viewerModel=getSimul()->accessModel(_guiViewer3dWord);
OGuiViewer3d * viewerObj=(OGuiViewer3d *)0;
for(it=viewerModel->accessAgentMap().begin();
    it!=viewerModel->accessAgentMap().end();it++)
  {
  if(((OGuiViewer3d *)(*it).second)->getElem()==viewer)
    {
    viewerObj=(OGuiViewer3d *)(*it).second;
    break;
    }
  }
if(!viewerObj) return;
Execution * initExec=Execution::getExecution(obj,ExecModule::NORMAL);
Value * value=TmpValue::getTmpValue(ValueType(viewerObj->accessModel()));
value->setAgent(viewerObj);
initExec->pushValue(value);
getSimul()->executeModule(module,obj,initExec);
Execution::relaxExecution(initExec);
}

//--------------------------------------------------------------------------//
// class Shape3d                                                            //
//--------------------------------------------------------------------------//

Shape3d::Shape3d(Model * model,int instNum)
 : Agent(model,instNum),
   _points(), _faces(), _colors(), _textures()
{}

Shape3d::~Shape3d(void)
{}

Strings Shape3d::userSave(int /* column */) const // virtual
{
Strings str;
return(str);
}

// inline const Gui3DPointVect & Shape3d::getPoints(void) const

// inline const Gui3DTriangleVect & Shape3d::getFaces(void) const

// inline const Gui3DColorVect & Shape3d::getColors(void) const

// inline const Gui3DTextureVect & Shape3d::getTextures(void) const

// inline Gui3DPointVect & Shape3d::accessPoints(void)

// inline Gui3DTriangleVect & Shape3d::accessFaces(void)

// inline Gui3DColorVect & Shape3d::accessColors(void)

// inline Gui3DTextureVect & Shape3d::accessTextures(void)

void Shape3d::insertTexture(const Gui3DTexture & texture)
{
for(unsigned int i=0;i<_textures.size();i++)
  {
  if(_textures[i].face==texture.face)
    {
    _textures[i]=texture;
    return;
    }
  else if(_textures[i].face>texture.face)
    {
    _textures.insert(_textures.begin()+i,texture);
    return;
    }
  }
_textures.push_back(texture);
}

#endif // OPEN_GL
#endif // X_GUI || W_GUI

