// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : prologPkg.h                                                //
// description : header file for the ENIB/LI2 oRis / SWI-Prolog interface   //
// author(s)   : P. Reignier                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef PROLOGPKG_H
#define PROLOGPKG_H

extern "C"
{
#include <SWI-Prolog.h>
}

#include "oRis/Main/simul.h"

class PrologPkg
{
public:
  PrologPkg(void);
  virtual ~PrologPkg(void);

  // manipulation des requetes prolog
  void callProlog(Strings);

  // lien avec les fonctions oRis
  static void staticCallProlog(Context * context);

  // lien avec les fonction prolog
  static foreign_t staticOrisCall(term_t agtName, 
                                  term_t methodeName, 
                                  term_t params, 
                                  term_t result);
  static PrologPkg * instance;
protected:
  // ces attributs seront utilises lors de la mise en place d'une
  // interface plus fine (open_query + next_solution + close_query)
  bool _insideQuery; // si true => une requete est deja en cours 
  qid_t _queryId;    // identification de la requete prolog courante
  term_t _goal;      // but a resoudre lors d'un appel oRis -> Prolog

  bool _buildValue(const Parameter * param,term_t term,Value * value);
  predicate_t _oris2Prolog;
  bool _fail;
};

#endif // PROLOGPKG_H

