// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : scmPkg.h                                                   //
// description : header file for the ENIB/LI2 oRis / SCM-Guile interface    //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef SCMPKG_H
#define SCMPKG_H

#include "oRis/Main/simul.h"
#include "Utility/smplThrd.h"

#include <guile/gh.h>

//--------------------------------------------------------------------------//
// class EmbedScheme                                                        //
//--------------------------------------------------------------------------//

class EmbedScheme : public BlockAllocatedObject
{
public:
// Static Methods
  static EmbedScheme * getInstance(void);
// Allocators
  EmbedScheme(void);
  virtual ~EmbedScheme(void);
// Inspectors
// Modifiers

  // native void callScheme(string command);
  //
  static void callScheme(Context * context);

protected:
// Private Methods
  static void * _threadTask(void * data);
  static void _guileTask(int argc,char ** argv);
  static SCM _functionCall(SCM function,SCM args);
  static SCM _methodCall(SCM instance,SCM method,SCM args);
// Attributes
  Strings _command;
  SimpleThread * _thread;
  SimpleThreadMutex _mutex1;
  SimpleThreadMutex _mutex2;
  static EmbedScheme * _instance;
};

#endif // SCMPKG_H

