// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : semaPkg.h                                                  //
// description : header file for the ENIB/LI2 oRis package semaphor.pkg     //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef SEMAPKG_H
#define SEMAPKG_H

#include "oRis/Main/agent.h"

//--------------------------------------------------------------------------//
// class Semaphore                                                          //
//--------------------------------------------------------------------------//

class Semaphore : public Agent
{
public:
  Semaphore(Model * model,int instNum);
  virtual ~Semaphore(void);
  virtual Strings userSave(int column=0) const;

  void suspend(Context * context);
  void resume(void);

  // native void Semaphore::new(int initValue);
  //
  static void constructor(Context * context);

  // native bool Semaphore::isRandom(void);
  //
  static void isRandom(Context * context);

  // native void Semaphore::setRandom(bool isRandom);
  //
  static void setRandom(Context * context);

  // native int Semaphore::getValue(void);
  //
  static void getValue(Context * context);

  // native void Semaphore::unlock(void);
  //
  static void unlock(Context * context);

  // native void Semaphore::lock(void);
  //
  static void lock(Context * context);

  // native bool Semaphore::tryLock(void);
  //
  static void tryLock(Context * context);

//---- Attributes ----
protected:
  long _value;
  bool _random;
  SimpleVector<long> _suspendedVect;
};

#endif // SEMAPKG_H

