// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : smaCd.cpp                                                  //
// description : source file for the ENIB/LI2 class SmaCode                 //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#include "oRis/Codes/smaCd.h"
#include "oRis/Main/simul.h"
#include "oRis/Nodes/smaNd.h"

//--------------------------------------------------------------------------//
// class SmaNode                                                            //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
SmaCode::SmaCode(const SmaNode * node)
 : BlockAllocatedObject(),
   _node(node)
{}

SmaCode::~SmaCode(void)
{}

//-------- Inspectors ------------------------------------------------------//
const SmaNode * SmaCode::getNode(void) const
{
return(_node);
}

bool SmaCode::isReturn(void) const // virtual
{
return(false);
}

int SmaCode::jumpsTo(void) const // virtual
{
return(0);
}

//-------- Input/Output ----------------------------------------------------//
ostream & operator<<(ostream & stream,const SmaCode & code)
{
return(stream << code.print());
}

Strings SmaCode::print(void) const // virtual
{
Strings str="Code of node '";
if(_node) str+=_node->getName();
else str+="NO NODE !";
str+="'";
return(str);
}

//-------- Modifiers -------------------------------------------------------//

//-------- Evaluation ------------------------------------------------------//
// virtual void SmaCode::eval(Context * ) const=0

void SmaCode::manageError(Error * error) const
{
getSimul()->manageError(error);
}

