// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : agtName.cpp                                                //
// description : source file for the ENIB/LI2 class AgentName               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//------------------------------------------------------------------------- //

#include "oRis/Main/agtName.h"

//--------------------------------------------------------------------------//
// class AgentName                                                          //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
//inline AgentName::AgentName(void)

//inline AgentName::AgentName(const AgentName & agentName)

AgentName::AgentName(const Strings & agentName)
 : BlockAllocatedObject(),
   _modelName(Word::create("")), _instNum(0)
{
const char * str=agentName;
int status=1;
long instNum=0;
Strings modelName;
char c;
//---- eat spaces
do
  {
  c=*(str++);
  } while(c&&((c==' ')||(c<0x20)));
if(c)
  {
  //---- read model name
  if((c=='_')||
     ((c>='A')&&(c<='Z'))||
     ((c>='a')&&(c<='z')))
    {
    const char * start=str;
    do
      {
      c=*(str++);
      } while((c=='_')||
              ((c>='A')&&(c<='Z'))||
              ((c>='a')&&(c<='z'))||
              ((c>='0')&&(c<='9')));
    modelName=Strings(start-1);
    modelName=modelName.subString(0,str-start);
    if((c!='.')||(sscanf(str,"%ld",&instNum)!=1)) status=0;
    }
  }
else status=0;
if(status)
  {
  _modelName=Word::create(modelName);
  _instNum=instNum;
  }
}

//inline AgentName::AgentName(const Word & modelName,long instNum)

//inline AgentName::~AgentName(void)

//-------- Inspectors ------------------------------------------------------//
//inline const Word & AgentName::getModelName(void) const

//inline long AgentName::getInstNum(void) const

//-------- Comparisons -----------------------------------------------------//
//inline bool AgentName::operator==(const AgentName & agentName) const

//inline bool AgentName::operator!=(const AgentName & agentName) const

//inline bool AgentName::operator<(const AgentName & agentName) const

//inline bool AgentName::operator>(const AgentName & agentName) const

//inline bool AgentName::operator<=(const AgentName & agentName) const

//inline bool AgentName::operator>=(const AgentName & agentName) const

//-------- Input/Output ----------------------------------------------------//
ostream & operator<<(ostream &stream,const AgentName & agentName)
{
return(stream << agentName.print());
}

Strings AgentName::print(void) const
{
if(_instNum)
  {
  return(_modelName.getStrings()+"."+Strings(_instNum));
  }
if(_modelName.getStrings().len())
  {
  return("("+_modelName.getStrings()+")NONE");
  }
return(Strings("(Object)NONE"));
}

//-------- Modifiers -------------------------------------------------------//
//inline void AgentName::setModelName(const Word & modelName)

//inline void AgentName::setInstNum(long instNum)

//inline AgentName & AgentName::operator=(const AgentName & agentName)

