// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : attrVal.cpp                                                //
// description : source file for the ENIB/LI2 class AttrValue               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//


#include "oRis/Main/attrVal.h"
#include "oRis/Main/agent.h"

//--------------------------------------------------------------------------//
// class ValueCallback                                                      //
//--------------------------------------------------------------------------//

int ValueCallback::_mask=0;

//-------- Static methods --------------------------------------------------//
// inline void ValueCallback::mask(void) // static

// inline void ValueCallback::unmask(void) // static

// inline int ValueCallback::getMask(void) // static

//-------- Allocators ------------------------------------------------------//
// inline ValueCallback::ValueCallback(void)

// inline ValueCallback::ValueCallback(const ValueCallback & callback)

// inline ValueCallback::~ValueCallback(void)

//-------- Inspectors ------------------------------------------------------//

//-------- Comparisons -----------------------------------------------------//

//-------- Input/Output ----------------------------------------------------//

//-------- Modifiers -------------------------------------------------------//
// inline void ValueCallback::connect(AttrValue * value)

// inline void ValueCallback::disconnect(void)

// virtual void ValueCallback::before(void)=0

// virtual void ValueCallback::after(void)=0


//--------------------------------------------------------------------------//
// class AttrValue                                                          //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
// inline AttrValue::AttrValue(const ValueType & type)

// inline AttrValue::~AttrValue(void)

//-------- Inspectors ------------------------------------------------------//
// inline bool AttrValue::isLeftValue(void) const // virtual

// inline bool AttrValue::isSeen(void) const

//-------- Comparisons -----------------------------------------------------//

//-------- Input/Output ----------------------------------------------------//

//-------- Modifiers -------------------------------------------------------//
// inline void AttrValue::reference(void) // virtual

void AttrValue::relax(void) // virtual
{
if(!--_nbRefs)
  {
  if(_agent) _agent->unReference();
  _agent=(Agent *)0;
  delete this;
  }
}

void AttrValue::clearReferences(bool strongClear) // virtual
{
Value::clearReferences(strongClear);
if(strongClear) _nbRefs=1; // will be unreferenced once by attribute
}

void AttrValue::seeMore(void)
{
++_seen;
}

void AttrValue::seeLess(void)
{
--_seen;
}

bool AttrValue::preset(void) // virtual
{
if(_callbackVect.getSize()&&!ValueCallback::getMask())
  {
  if(_seen>0) return(false);
  ++_seen;
  unsigned int i=_callbackVect.getSize();
  do
    {
    _callbackVect[--i]->before();
    if(i>_callbackVect.getSize()) i=_callbackVect.getSize();
    } while(i);
  }
ValueCallback::mask();
return(true);
}

void AttrValue::postset(void) // virtual
{
ValueCallback::unmask();
if(_callbackVect.getSize()&&!ValueCallback::getMask())
  {
  unsigned int i=_callbackVect.getSize();
  do
    {
    _callbackVect[--i]->after();
    if(i>_callbackVect.getSize()) i=_callbackVect.getSize();
    } while(i);
  --_seen;
  }
}

void AttrValue::disconnect(void)
{
while(_callbackVect.getSize())
  _callbackVect.accessFront()->disconnect(); // removed here
}

// inline void AttrValue::setInteger(long integer) // virtual

// inline void AttrValue::setReal(double real) // virtual

// inline void AttrValue::setStrings(const Strings & string) // virtual

// inline void AttrValue::setAgent(Agent * agent) // virtual

// inline void AttrValue::setValueVectorCopy(const Value & valueVector)
//                                                                  // virtual

// inline void AttrValue::setValueVectorCopyI2R(const ValueVector &
//                                              valueVector) // virtual

// inline void AttrValue::setValueVectorCopyR2I(const ValueVector &
//                                              valueVector) // virtual

// inline void AttrValue::setValueVector(ValueVector * valueVector) // virtual

// inline void AttrValue::insert(const Value & value,int pos) // virtual

// inline void AttrValue::pushFront(const Value & value) // virtual

// inline void AttrValue::pushBack(const Value & value) // virtual

// inline void AttrValue::erase(int pos) // virtual

// inline void AttrValue::readErase(Value * & result,int pos) // virtual

// inline void AttrValue::popFront(void) // virtual

// inline void AttrValue::readPopFront(Value * & result) // virtual

// inline void AttrValue::popBack(void) // virtual

// inline void AttrValue::readPopBack(Value * & result) // virtual

// inline void AttrValue::appendVector(const ValueVector & valueVector)
//                                                                  // virtual

// inline void AttrValue::sortVector(void) // virtual

// inline Value & AttrValue::operator=(const Value & value) // virtual

// inline Value & AttrValue::affectCast(const Value & value) // virtual

