// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : errors.cpp                                                 //
// description : source file for the ENIB/LI2 class Error                   //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//------------------------------------------------------------------------- //

#include "oRis/Main/errors.h"

//--------------------------------------------------------------------------//
// class Error                                                              //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
Error::Error(Error::ErrorType type,const Strings & message)
 : BlockAllocatedObject(),
   _line(0), _file(), _type(type), _message(message)
{}

Error::~Error(void)
{}

//-------- Inspectors ------------------------------------------------------//
Error::ErrorType Error::getType(void) const
{
return(_type);
}

const Strings & Error::getMessage(void) const
{
return(_message);
}

int Error::getLineNumber(void) const
{
return(_line);
}

const Strings & Error::getFileName(void) const
{
return(_file);
}

//-------- Input/Output ----------------------------------------------------//
ostream & operator<<(ostream & stream,const Error & error)
{
return(stream << error.print());
}

Strings Error::print(void) const
{
Strings str;
if(_file.len()) str+=_file+" : ";
if(_line) str+=Strings(_line)+" : ";
str+=_message;
return(str);
}

//-------- Modifiers -------------------------------------------------------//
void Error::setLineNumber(int line)
{
_line=line;
}

void Error::setFileName(const Strings & file)
{
_file=file;
}

