// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : initOris.cpp                                               //
// description : initial oRis code for the ENIB/LI2 class Simulator         //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//------------------------------------------------------------------------- //


#include "oRis/Main/simul.h"

//--------------------------------------------------------------------------//
// class Simulator                                                          //
//--------------------------------------------------------------------------//

const char * Simulator::_launchCode1="\
  \
  replace bool by int; \
  replace true by 1; \
  replace false by 0; \
  replace randomPicking by 0; \
  replace serialPicking by 1; \
  \
  class Object; \
  class Message; \
  \
  native void onExit(string command); \
  native bool loadLibrary(string libName); \
  native int parse(string program); \
  native int load(string fileName); \
  native string[] parseEval(string command); \
  native int eval(string code); \
  native void save(string fileName); \
  native int getPickingMode(void); \
  native void setPickingMode(int mode); \
  native int getInterval(void); \
  native void setInterval(int interval); \
  native void yield(void); \
  native void softYield(void); \
  native void getExecutionStack(Object[] & callers,string[] & modules, \
                                int execution); \
  native void printStack(void); \
  native int currentExecution(void); \
  native void abort(int execution); \
  native void suspend(int execution); \
  native void resume(int execution); \
  native bool isSuspended(int execution); \
  native int getMaxDepth(void); \
  native void setMaxDepth(int maxDepth); \
  native int getClock(void); \
  native void setClock(int clk); \
  ";

// one string is too long under MSDOS !!!

const char * Simulator::_launchCode2="\
  native Object create(string objName); \
  native bool exist(Object obj); \
  native Object getObject(string objName); \
  native int numberOf(string className); \
  native Object[] getAll(string className); \
  native string[] getClasses(void); \
  native int getTime(void); \
  native string getenv(string varName); \
  native void putenv(string varName,string value); \
  native string systemName(bool detailed); \
  native void systemYield(void); \
  native int system(string command); \
  native void systemI(string command,string input); \
  native string systemO(string command); \
  native string systemE(string command); \
  native string systemIO(string command,string input); \
  native string systemIE(string command,string input); \
  native string systemOE(string command,string & err); \
  native string systemIOE(string command,string input,string & err); \
  native string control(string command,string argument); \
  native string[] commandLine(bool full); \
  native int asciiCode(string char); \
  native string asciiChar(int code); \
  native string hexaString(int value); \
  native string octalString(int value); \
  native string binaryString(int value); \
  native string locateFile(string fileName); \
  native void showURL(string url,bool newWindow); \
  native string readln(void); \
  \
  ";

// one string is too long under MSDOS !!!

const char * Simulator::_launchCode3="\
  void Object::new(void) {} \
  void Object::delete(void) {} \
  void Object::deleteOnExit(void) \
    { \
    onExit(format(\"execute \
                    { \
                    Object obj=getObject(\\\"\",this,\"\\\"); \
                    if(obj) delete obj; \
                    }\")); \
    } \
  native string Object::name(void); \
  native bool Object::isA(string className); \
  native string Object::className(void); \
  native int Object::suffix(void); \
  native void Object::suspend(void); \
  native void Object::resume(void); \
  native bool Object::isSuspended(void); \
  native void Object::setTransient(bool isTransient); \
  native bool Object::isTransient(void); \
  bool Object::equalsTo(Object obj) \
    {error(\"Application dependant\"); return(false);} \
  bool Object::lessThan(Object obj) \
    {error(\"Application dependant\"); return(false);} \
  void Object::affect(Object obj) \
    {error(\"Application dependant\");} \
  \
  native void Object::getSensitivity(string[] & msgTypes, \
                                     string[] & callbacks); \
  native void Object::setSensitivity(string msgType,string callback); \
  native void Object::cancelSensitivity(string msgType); \
  native void Object::asynchronousReception(Message message); \
  native int Object::getNbMessages(void); \
  native Message Object::peekMessage(int pos); \
  native Message Object::getNextMessage(void); \
  native void Object::putBackMessage(Message message); \
  void Object::onMessage(void); \
  \
  Object Message::_emitter; \
  void Message::new(void) {_emitter=that;} \
  void Message::delete(void) {} \
  native void Message::broadcast(void); \
  native void Message::sendTo(Object receiver); \
  Object Message::getEmitter(void) {return(_emitter);} \
  void Message::setEmitter(Object emitter) {_emitter=emitter;} \
  \
  ";

