// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : protoMod.cpp                                               //
// description : source file for the ENIB/LI2 class ProtoModule             //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//------------------------------------------------------------------------- //

#include "oRis/Main/protoMod.h"
#include "oRis/Main/simul.h"
#include "oRis/Main/errors.h"
#include "oRis/Codes/moduleCd.h"
#include "oRis/Codes/utilCd.h"

//---------------------------------------------------------------------------//
// class ProtoModule                                                         //
//---------------------------------------------------------------------------//

//-------- Allocators -------------------------------------------------------//
ProtoModule::ProtoModule(const Word & name,
                         ExecModule::SpecialType specialType,
                         const ValueType & valueType,
                         Model * model,Agent * owner)
 : ExecModule(name,specialType,valueType,model,owner)
{
_codeVect=new CodeVect;
_codeVect->pushBack(new ProtoCode((SmaNode *)0));
_codeVect->pushBack(new ReturnCode((SmaNode *)0,0,0));
}

ProtoModule::ProtoModule(const ProtoModule & module)
 : ExecModule(module)
{
_codeVect=new CodeVect;
_codeVect->pushBack(new ProtoCode((SmaNode *)0));
_codeVect->pushBack(new ReturnCode((SmaNode *)0,0,0));
}

ExecModule * ProtoModule::duplicate(void) const // virtual
{
return(new ProtoModule(*this));
}

ProtoModule::~ProtoModule(void)
{}

//-------- Inspectors ------------------------------------------------------//
// inline ExecModule::ModuleType ProtoModule::getType(void) const // virtual

//-------- Comparisons -----------------------------------------------------//

//-------- Input/Output ----------------------------------------------------//
Strings ProtoModule::print(int column) const // virtual
{
return(printProto(column));
}

//-------- Modifiers -------------------------------------------------------//

