// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : textOut.cpp                                                //
// description : source file for the ENIB/LI2 class TextOutput              //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#include "oRis/Main/textOut.h"

//--------------------------------------------------------------------------//
// class TextOutput                                                         //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
TextOutput::TextOutput(ostream * stream)
 : BlockAllocatedObject(),
   _stream(stream)
{}

TextOutput::~TextOutput(void)
{}

//-------- Input/Output ----------------------------------------------------//
TextOutput & TextOutput::operator<<(char c) // virtual
{
*_stream << c;
return(*this);
}

TextOutput & TextOutput::operator<<(const char * s) // virtual
{
*_stream << s;
return(*this);
}

TextOutput & TextOutput::operator<<(void * p) // virtual
{
*_stream << p;
return(*this);
}

TextOutput & TextOutput::operator<<(int n) // virtual
{
*_stream << n;
return(*this);
}

TextOutput & TextOutput::operator<<(unsigned int n) // virtual
{
*_stream << n;
return(*this);
}

TextOutput & TextOutput::operator<<(short s) // virtual
{
*_stream << s;
return(*this);
}

TextOutput & TextOutput::operator<<(unsigned short s) // virtual
{
*_stream << s;
return(*this);
}

TextOutput & TextOutput::operator<<(long l) // virtual
{
*_stream << l;
return(*this);
}

TextOutput & TextOutput::operator<<(unsigned long l) // virtual
{
*_stream << l;
return(*this);
}

TextOutput & TextOutput::operator<<(float f) // virtual
{
*_stream << f;
return(*this);
}

TextOutput & TextOutput::operator<<(double d) // virtual
{
*_stream << d;
return(*this);
}

TextOutput & TextOutput::operator<<(ostream & (*func)(ostream &)) // virtual
{
*_stream << func;
return(*this);
}

