// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : callerNd.cpp                                               //
// description : source file for the ENIB/LI2 class CallerNode              //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#include "oRis/Nodes/callerNd.h"
#include "oRis/Main/model.h"
#include "oRis/Codes/valCd.h"

//---------------------------------------------------------------------------//
// class CallerNode                                                          //
//---------------------------------------------------------------------------//

//-------- Allocators -------------------------------------------------------//
CallerNode::CallerNode(int lineNumber,const Strings & fileName,
                       const Strings & name)
 : SmaNode(0,lineNumber,fileName,name,false)
{}

CallerNode::CallerNode(const CallerNode & node)
 : SmaNode(node)
{}

SmaNode * CallerNode::duplicate(void) const // virtual
{
return(new CallerNode(*this));
}

CallerNode::~CallerNode(void)
{}

//-------- Input/Output -----------------------------------------------------//
Strings CallerNode::_print(int) const // virtual
{
return(getName());
}

//-------- Evaluation -------------------------------------------------------//
bool CallerNode::check(const Context * context,const Model * model) // virtual
{
SmaNode::check(context,model);
if(!_fail)
  {
  _type=ValueType(Model::getBaseModel());
  }
return(!_fail);
}

CodeVect * CallerNode::generateCode(void) // virtual
{
CodeVect * codeVect=new CodeVect;
codeVect->pushBack(new CallerCode(this));
return(codeVect);
}

