// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : constNd.cpp                                                //
// description : source file for the ENIB/LI2 class ConstNode               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#include "oRis/Nodes/constNd.h"
#include "oRis/Codes/valCd.h"

//---------------------------------------------------------------------------//
// class ConstNode                                                           //
//---------------------------------------------------------------------------//

//-------- Allocators -------------------------------------------------------//
ConstNode::ConstNode(int lineNumber,const Strings & fileName,
                     const Value & value)
 : SmaNode(0,lineNumber,fileName,value.dump(),false), _value(value)
{}

ConstNode::ConstNode(const ConstNode & node)
 : SmaNode(node), _value(node._value)
{}

SmaNode * ConstNode::duplicate(void) const // virtual
{
return(new ConstNode(*this));
}

ConstNode::~ConstNode(void)
{}

//-------- Inspectors -------------------------------------------------------//
bool ConstNode::isConst(void) const // virtual
{
return(true);
}

const Value & ConstNode::getValue(void) const // virtual
{
return(_value);
}

//-------- Input/Output -----------------------------------------------------//
Strings ConstNode::_print(int) const // virtual
{
return(_value.dump());
}

//-------- Evaluation -------------------------------------------------------//
bool ConstNode::check(const Context * context,const Model * model) // virtual
{
SmaNode::check(context,model);
if(!_fail)
  {
  _type=_value.getType();
  }
return(!_fail);
}

CodeVect * ConstNode::generateCode(void) // virtual
{
CodeVect * codeVect=new CodeVect;
codeVect->pushBack(new ConstCode(this,_value));
return codeVect;
}

