// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : reaRndNd.cpp                                               //
// description : source file for the ENIB/LI2 class RealRndNode             //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#include "oRis/Nodes/reaRndNd.h"
#include "oRis/Codes/valCd.h"

//---------------------------------------------------------------------------//
// class RealRndNode                                                         //
//---------------------------------------------------------------------------//

//-------- Allocators -------------------------------------------------------//
RealRndNode::RealRndNode(int lineNumber,const Strings & fileName,
                         const Strings & name)
 : SmaNode(0,lineNumber,fileName,name,false)
{}

RealRndNode::RealRndNode(const RealRndNode & node)
 : SmaNode(node)
{}

SmaNode * RealRndNode::duplicate(void) const // virtual
{
return(new RealRndNode(*this));
}

RealRndNode::~RealRndNode(void)
{}

//-------- Input/Output -----------------------------------------------------//
Strings RealRndNode::_print(int) const // virtual
{
return(getName());
}

//-------- Evaluation -------------------------------------------------------//
bool RealRndNode::check(const Context * context,const Model * model) // virtual
{
SmaNode::check(context,model);
if(!_fail)
  {
  _type=ValueType(ValueType::REAL);
  }
return(!_fail);
}

CodeVect * RealRndNode::generateCode(void) // virtual
{
CodeVect * codeVect=new CodeVect;
codeVect->pushBack(new RealRndCode(this));
return(codeVect);
}

