//-------------------------------------------------------------------------
//
// File    	:  fuzzySet.C
// Description  :  ensemble flou
//
// Author(s)   	: P. Reignier
// Date         : 09/03/97
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#ifndef _FUZZY_CONTROLLER
#define _FUZZY_CONTROLLER

#include "oRis/Main/agent.h"
#include "Utility/stlSet.h"

class FuzzyParse ;
class Model ;
class Context ;
class Agent ;

class FuzzyController : public Agent
{
 public:
  FuzzyController(Model* model, long instNum) ;
  virtual ~FuzzyController(void) ;

  void destroy(void) ;
  void compile(char* prog, bool atomic) ;
  void addRule(const Strings rule) ;
  void addRulesFromFile(const Strings& filename) ;
  void addUsedVariable(Agent* var) ;

  static void staticDestroy(Context* context) ;
  static void staticCompile(Context* context) ;
  static void staticAddRulesFromFile(Context* context) ;
  
 protected:
  bool _destroyed ;
  FuzzyParse* _parse ;
  Value* _rules ;
  Value* _usedVariables ;
  StlSet < Agent * > _usedVariablesSet ;
} ;

#endif
