//-------------------------------------------------------------------------
//
// File    	:  fuzzyFNod.h
// Description  :  Noeud de l'arbre semantique des regles floues
//
// Author(s)   	: P. Reignier
// Date         : 23/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
     //		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
     // Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------


#ifndef _FUZZY_NODE_H
#define _FUZZY_NODE_H

#include <Utility/stlVect.h>
#include <assert.h>

#include "fuzzySet.h"
#include "Utility/strings.h"
#include "nodeData.h"

class FuzzyFNod : public BlockAllocatedObject
{
public:
  // constructors
  FuzzyFNod (void) ;
  FuzzyFNod (const FuzzyFNod & node) ;

  // destructor
  virtual ~FuzzyFNod(void) ;

  // utilities
  virtual void generate(FNodData&) = 0 ;

  int getNbFils(void) const { return _fils.size() ;} ;
  FuzzyFNod* getFils(int n) 
    {
#ifdef ASSERT
      assert(n < _fils.size()) ;
#endif
      return _fils[n] ;
    }
  void insert(FuzzyFNod* node) ;
  virtual void print(int depth=0) ;

protected :
  
  StlVector<FuzzyFNod *> _fils ;
  Strings _signature ;
} ;

#endif

