//-------------------------------------------------------------------------
//
// File    	:  nodeData.h
// Description  :  donnees associees aux noeuds de l'arbre flou
//
// Author(s)   	: P. Reignier
// Date         : 23/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
     //		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
     // Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------


#ifndef _NODE_DATA_H
#define _NODE_DATA_H

#ifndef __MSDOS__
// #include <stl_config.h>
#endif

#include <stdio.h>

#include "fuzzySet.h"
#include "Utility/strings.h"

class FuzzyController ;

class FNodData : public BlockAllocatedObject
{
public:

  // constructors
  inline FNodData(void) ;
  inline FNodData(const FNodData& data) ;
  virtual inline ~FNodData(void) ;

  inline void setActivation(const Strings& activation) ; 
  inline void setFuzzySet(const FuzzySet& set) ;
  inline void setDerivative(bool derivative) ;
  inline void setFuzzyController(FuzzyController* controller) ;
  inline void appendProg(const Strings& text) ;
  inline void setError(bool error) ;
  inline void setVarName(const Strings& varName) ;
  inline void setVar(const Agent* agent) ;
  inline void setResult(const Strings& res) ;
  
  inline Strings getActivation(void) const ;
  inline FuzzySet getFuzzySet(void) const ;
  inline bool isDerivative(void) const ;
  inline Strings getoRisProgram(void) const ;
  inline const FuzzyController* getFuzzyController(void) const ;
  inline FuzzyController* accessFuzzyController(void) ;
  inline bool isError(void) const ;
  inline Strings getVarName(void) const ;
  inline const Agent* getVar(void) const ;
  inline Strings getResult(void) const ;
  inline void clearoRisProg(void) ;
  
  inline Strings allocateTmpFloatVar(void) ;
  inline Strings allocateTmpFuzzyVar(void) ;
  inline void resetTmpVars(void) ;

protected:
  Strings _activation ;
  
  FuzzySet _fuzzySet ;
  bool _derivative ;
  Strings _varName ;
  const Agent* _var ;
  FuzzyController* _controller ;
  bool _error ;
  Strings _result ;

  static Strings _oRisProgram ;
  static int _tmpFloatVar ;
  static int _tmpFuzzyVar ;
} ;

#include "nodeData.Ci"

#endif

