//-------------------------------------------------------------------------
//
// File    	:  varCondFNod.h
// Description  :  fuzzy variable in the left part of a rule (Condition part)
//
// Author(s)   	: P. Reignier
// Date         : 30/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#ifndef _VARCOND_NODE_H
#define _VARCOND_NODE_H

#ifndef __MSDOS__
// #include <stl_config.h>
#endif

#include "fuzzyFNod.h"
#include "nodeData.h"
#include "Utility/strings.h"

class FuzzyController ;

class VarCondFNod : public FuzzyFNod
{
public:

  // constructors 
  VarCondFNod (Strings varName) ;
  VarCondFNod (const VarCondFNod &) ;

  // destructor 
  virtual ~VarCondFNod(void) ;

  // code generation
  virtual void generate(FNodData&) ;  

protected:
  Strings _variable ;
} ;

#endif

//----------------------------------------------------------------------//
