//-------------------------------------------------------------------------
//
// File    	:  deltaFNod.C
// Description  :  to work on the derivative part of a variable
//
// Author(s)   	: P. Reignier
// Date         : 30/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#ifndef __MSDOS__
// #include <stl_config.h>
#endif

#include "deltaFNod.h"
#include "fuzzySet.h"
#include "fuzzyFNod.h"
#include "nodeData.h"
#include "Utility/strings.h"

//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//

//------varCondFNod::varCondFNod(....) ---------------------------------//

DeltaFNod::DeltaFNod (void) : FuzzyFNod() 
{
  _signature = Strings("delta") ;
}
 

//------varCondFNod::varCondFNod(varCondFNod&)--------------------------//

DeltaFNod::DeltaFNod (const DeltaFNod& node) : FuzzyFNod(node) 
{}

//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------varCondFNod::~varCondFNod()-------------------------------------//

DeltaFNod::~DeltaFNod(void) {}


//----------------------------------------------------------------------//
//
// Code generation
//
//----------------------------------------------------------------------//

void DeltaFNod::generate(FNodData& data)
{
  data.setDerivative(true) ;
  _fils[0]->generate(data) ;
}

