//-------------------------------------------------------------------------
//
// File    	:  fuzzyFNod.cpp
// Description  :  Noeud de l'arbre semantique des regles floues
//
// Author(s)   	: P. Reignier
// Date         : 23/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#include <assert.h>

#include "Utility/stlVect.h"
#include "fuzzySet.h"
#include "fuzzyFNod.h"


//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//


//------FuzzyFNod::FuzzyFNod()------------------------------------------//

FuzzyFNod::FuzzyFNod (void) 
 : BlockAllocatedObject()
{
  _signature = "Default Value" ;
}


//------FuzzyFNod::FuzzyFNod(Symbol*,int)-------------------------------//

FuzzyFNod::FuzzyFNod (const FuzzyFNod& node)
 : BlockAllocatedObject()
{
  _signature = node._signature ;
} 


//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------FuzzyFNod::~FuzzyFNod()-----------------------------------------//

FuzzyFNod::~FuzzyFNod(void) 
{
  StlVector<FuzzyFNod *>::iterator i ;
  
  for (i = _fils.begin(); i != _fils.end(); i++)
    // we kill all the sons of the current node
    delete (*i) ;
}


//----------------------------------------------------------------------//
// Utilities
//----------------------------------------------------------------------//

void FuzzyFNod::insert(FuzzyFNod* node)
{
  _fils.push_back(node) ;
}

//----------------------------------------------------------------------//

void FuzzyFNod::print(int depth)
{
  int i ;

  cout << depth ;
  for (i=0; i<depth; i++)
    cout <<  "  ";
  cout << _signature << endl ;

  StlVector<FuzzyFNod *>::iterator j ;
  for (j=_fils.begin(); j != _fils.end(); j++)
    (*j)->print(depth+1) ;
}
