//-------------------------------------------------------------------------
//
// File    	:  implyFNod.C
// Description  :  A => B node 
//
// Author(s)   	: P. Reignier
// Date         : 25/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#include "implyFNod.h"
#include "fuzzySet.h"
#include "Utility/strings.h"
#include "nodeData.h"

//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//


//------ImplyFNod::ImplyFNod(...) --------------------------------------//

ImplyFNod::ImplyFNod (int ruleNumber) : 
  FuzzyFNod() 
{
  _ruleNumber = ruleNumber ;
  _signature = Strings("imply") ;
} 

//------ImplyFNod::ImplyFNod(ImplyFNod&)--------------------------------//

ImplyFNod::ImplyFNod (const ImplyFNod& node) : FuzzyFNod(node) 
{
  _ruleNumber = node._ruleNumber ;
} 


//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------ImplyFNod::~ImplyFNod()-------------------------------------//

ImplyFNod::~ImplyFNod(void) {}


//----------------------------------------------------------------------//
//
// FNod evaluation
//
//----------------------------------------------------------------------//


void ImplyFNod::generate(FNodData& data)
{
  // the real value given as an argument is meaningless
  getFils(0)->generate(data);
  if (!data.isError())
    {
      char ruleNb[100];
      sprintf(ruleNb, "%d", _ruleNumber) ;
      data.appendProg(Strings("_activations[")+
		      Strings(ruleNb)+Strings("] = ")+data.getResult() +
		      Strings(";\n"));
      data.setActivation(data.getResult()) ;
      getFils(1)->generate(data) ;
    }
  
}

