//-------------------------------------------------------------------------
//
// File    	:  isAlsoFNod.h
// Description  :  aggregation of a new result on a actuator (conclusion
//                 part of the rules
//
// Author(s)   	: P. Reignier
// Date         : 23/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#include "isAlsoFNod.h"
#include "fuzzySet.h"
#include "fuzzyFNod.h"
#include "Utility/strings.h"
#include "fuzzyController.h"
#include "oRis/Main/attrib.h"
#include "oRis/Main/agent.h"
#include "oRis/Main/value.h"

//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//

//------IsAlsoFNod::IsAlsoFNod(....) -----------------------------------//

IsAlsoFNod::IsAlsoFNod (void) :
  FuzzyFNod() 
{
  _signature = Strings("is also") ;
} ;

//------IsAlsoFNod::IsAlsoFNod(IsAlsoFNod&)-----------------------------//

IsAlsoFNod::IsAlsoFNod (const IsAlsoFNod& node) : FuzzyFNod(node) 
{}

//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------IsAlsoFNod::~IsAlsoFNod()---------------------------------------//

IsAlsoFNod::~IsAlsoFNod(void) {}


//----------------------------------------------------------------------//
//
// FNod evaluation
//
//----------------------------------------------------------------------//

void IsAlsoFNod::generate(FNodData& data)
{
  getFils(0)->generate(data) ;
  if (!data.isError())
    {
      Strings tmpVar = data.getResult() ;
      getFils(1)->generate(data) ;
      if (!data.isError())
	{
	  Strings tmpSet = data.allocateTmpFuzzyVar() ;
	  data.appendProg("FuzzySet "+tmpSet) ;
	  data.appendProg(" = _infer->infer("+data.getActivation()+","+
			  data.getResult()+"); ") ;
	  data.appendProg("_combine->combine("+tmpVar+","+tmpSet+");\n") ;
	}
    }
}

