//-------------------------------------------------------------------------
//
// File    	:  isFNod.C
// Description  :  A is B node (condition part)
//
// Author(s)   	: P. Reignier
// Date         : 23/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#include "isFNod.h"
#include "fuzzySet.h"
#include "nodeData.h"
#include "Utility/strings.h"

//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//


//------IsFNod::IsFNod(....) -------------------------------------------//

IsFNod::IsFNod (void) : FuzzyFNod() 
{
  _signature = Strings("is") ;
} ;

//------IsFNod::IsFNod(IsFNod&)-----------------------------------------//

IsFNod::IsFNod (const IsFNod& node) : FuzzyFNod(node) 
{}


//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------IsFNod::~IsFNod()-----------------------------------------------//

IsFNod::~IsFNod(void) {}

//----------------------------------------------------------------------//
//
// Code generation
//
//----------------------------------------------------------------------//

void IsFNod::generate(FNodData& data)
{ 
  data.setDerivative(false) ;
  getFils(0)->generate(data);
  if (!data.isError())
    {
      Strings leftResult = data.getResult() ;
      getFils(1)->generate(data) ;

      if(!data.isError())
	{
	  Strings tmpVar = data.allocateTmpFloatVar() ;
	  data.appendProg("float " + tmpVar + "; ") ;
	  data.appendProg(tmpVar + " = " + leftResult + 
			  "->maxMin(" + data.getResult() + ");\n") ;
	  data.setResult(tmpVar) ;
	}
    }
  data.setDerivative(false) ;
}

