//-------------------------------------------------------------------------
//
// File    	:  modFNod.C
// Description  :  mod B node (mod = very ....)
//
// Author(s)   	: P. Reignier
// Date         : 24/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#include "modFNod.h"
#include "fuzzySet.h"
#include "Utility/strings.h"
#include "nodeData.h"

//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//

//------ModFNod::ModFNod(....) -----------------------------------------//

ModFNod::ModFNod (Strings modifier) : FuzzyFNod() 
{
  _modifier = modifier ;
  _signature = "modifier : " + modifier ;
} 

//------ModFNod::ModFNod(ModFNod&)-----------------------------------------//

ModFNod::ModFNod (const ModFNod& node) : FuzzyFNod(node) 
{
  _modifier = node._modifier ;
} ;


//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------ModFNod::~ModFNod()-----------------------------------------------//

ModFNod::~ModFNod(void) {}

//----------------------------------------------------------------------//
//
// Code generation
//
//----------------------------------------------------------------------//

void ModFNod::generate(FNodData& data)
{
  getFils(0)->generate(data) ;
  
  if (!data.isError())
    {
      Strings result = data.allocateTmpFuzzyVar() ;
      data.appendProg("FuzzySet " + result) ;
      data.appendProg(" = " + data.getResult() + "->" + _modifier+"();\n") ;
      data.setResult(result) ;
    }
}

