//-------------------------------------------------------------------------
//
// File    	:  rulesBaseFNod.h
// Description  :  aggregation of all the rules
//                 part of the rules
//
// Author(s)   	: P. Reignier
// Date         : 25/03/98
// Copyright	: Laboratoire d'Informatique Industrielle (LI2)
//		  Ecole Nationale d'Ingenieurs de Brest (ENIB)
//		  CP 15 - 29608 Brest Cedex - FRANCE
//		  Tel: (33) 98.05.66.31, Fax: (33) 98.05.66.29
//		  e-mail: li2@li2.enib.fr
//-------------------------------------------------------------------------
// Copyright (c) 1996
// Laboratoire d'Informatique Industrielle (LI2)
// Ecole Nationale d'Ingenieurs de Brest (ENIB)
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.
// ENIB/LI2 makes no representations about the suitability of this
// software for any purpose.
// It is provided "as is" without express or implied warranty.
//-------------------------------------------------------------------------

#include "fuzzySet.h"
#include "rulesBaseFNod.h"
#include "Utility/strings.h"
#include "Utility/stlVect.h"

//----------------------------------------------------------------------//
//
// Constructors
//
//----------------------------------------------------------------------//


//------RulesBaseFNod::RulesBaseFNod(....) -----------------------------//

RulesBaseFNod::RulesBaseFNod (void) : FuzzyFNod() 
{
  _signature = Strings(";") ;
} ;

//------RulesBaseFNod::RulesBaseFNod(RulesBaseFNod&)--------------------//

RulesBaseFNod::RulesBaseFNod (const RulesBaseFNod& node) : FuzzyFNod(node) 
{}


//----------------------------------------------------------------------//
//
// Destructor
//
//----------------------------------------------------------------------//

//------RulesBaseFNod::~RulesBaseFNod()---------------------------------//

RulesBaseFNod::~RulesBaseFNod(void) {}

//----------------------------------------------------------------------//
//
// Code generation
//
//----------------------------------------------------------------------//

void RulesBaseFNod::generate(FNodData& data)
{
  StlVector<FuzzyFNod *>::iterator i ;

  // the real value given as an argument is meaningless
  for (i=_fils.begin(); i != _fils.end(); i++)
    {
      (*i)->generate(data);
      if (data.isError())
	return ;
    }
}

